<?php
require_once 'model/parametro.model.php'; 
require_once 'model/parametro.entidad.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/familia.model.php';
require_once 'model/familia.entidad.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/productolote.model.php';
require_once 'model/productolote.entidad.php';
require_once 'model/precioventa.model.php';
require_once 'model/precioventa.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/vendedor.model.php';
require_once 'model/vendedor.entidad.php';
require_once 'model/cotizacion.model.php';
require_once 'model/cotizacion.entidad.php';
require_once 'model/cotizaciondetalle.model.php';
require_once 'model/cotizaciondetalle.entidad.php';
require_once 'controller/electronic.controller.php';

class CotizacionController extends MetodosController
{
    public $url;
    public $parametro_model;
    public $documento_model;
    public $almacen_model;
    public $tipomovimiento_model;
    public $movimiento_model;
    public $prodserv_model;
    public $familia_model;
    public $unidadmedida_model;
    public $productolote_model;
    public $movimientodetalle_model;
    public $precioventa_model;
    public $origendestino_model;
    public $vendedor_model;
    public $IGV = 0;
    public $ICBPER = 0.10;
    public $cotizacion_model;
    public $cotizaciondetalle_model;
    private $electronic_controller;
    private $seguridad;

    public function __CONSTRUCT()
    {
        $this->url = 'http://colibri-fm.ddns.net:8087/servicio/Transaccion/AnularSunat/' . $_SESSION['usu_enterpriseRuc'];
        $this->parametro_model = new ParametroModel();
        $this->documento_model = new DocumentoModel();
        $this->almacen_model = new AlmacenModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->movimiento_model = new MovimientoModel();
        $this->prodserv_model = new ProdservModel();
        $this->familia_model = new FamiliaModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->productolote_model = new ProductoloteModel();
        $this->precioventa_model = new PrecioventaModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->electronic_controller = new ElectronicController();
        $this->vendedor_model = new VendedorModel();
        $this->cotizacion_model = new CotizacionModel();
        $this->cotizaciondetalle_model = new CotizaciondetalleModel();
        $this->seguridad = new Seguridad();
        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 10) {
                $this->ICBPER =  ($pa->__GET('sParValor')) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 14) {
                $this->DECIMALES =  ($pa->__GET('sParValor'));
            }
        }
    }

    public function Index()
    {
        // $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'] or $this->seguridad->validRoleName(RolesType::admin2) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[2]->__GET('sParValor'));
        // $tipomovimientos = $this->tipomovimiento_model->Listar();
        // $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : $valor[1];
        $movimientos = $this->cotizacion_model->ListarDate(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y')))
        );
        require_once 'view/header.php';
        require_once 'view/webforms/wfacotizacion.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }


    public function FrmGuardarMovimiento()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->ListarCot();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $provclienlist = $this->origendestino_model->Listar2();
        $provcliendisc = array();
        if(!empty($provclienlist)){
            foreach ($provclienlist as $cpn){
                $provcliendisc[] = array(
                    'OrigenDestino_Id' => $cpn->OrigenDestino_Id,
                    'sODContacto' => $cpn->sODContacto
                );
            }
        }
        require_once 'view/webforms/wfacotizaciona.php';
    }

    public function FrmEditarMovimiento()
    {
        $this->DetruirSessiones();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $movimiento = $this->movimiento_model->Buscar($_POST['Movimiento_Id']);
        $vendedor = $this->vendedor_model->Listar();
        $data = array();
        foreach ($movimiento as $r) :

            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) :

                $array = array(
                    "ProdServ_Id" => $detmov->__GET('ProductoLote_Id'),
                    "sProSrvNombre" => $detmov->__GET('sProSrvNombre'),
                    "lotes" => 0,
                    "sMovDetConCantidad" => $detmov->__GET('nMovDetCantidad'),
                    "Unidadmedida_Id" => $detmov->__GET('nMovDetUnidad_Id'),
                    "dMovDetConFechaVencimiento" => $this->FechaVencimiento($detmov->__GET('ProductoLote_Id')),
                    "nMovDetConPrecioUnitario" => $detmov->__GET('nMovDetPrecioUnitario'),
                    "nMovDetConSubtotal" => $detmov->__GET('nMovDetImporte'),
                );
                if (isset($_SESSION['producto_c'])) {
                    $data = $_SESSION['producto_c'];
                    array_push($data, $array);
                } else {
                    $data[] = $array;
                }
                $_SESSION['producto_c'] = $data;
            endforeach;
            require_once 'view/webforms/wfamovimientoa.php';
            echo '<script type="text/javascript">
            $(document).ready(function(){
                console.log(' . $r->__GET('nMovOrigenDestino_Id') . ');
                TipoPrvClien();
                TipoDocumentoEditar(' . $r->__GET('nMovOrigenDestino_Id') . ');
                ListarProductos();
            });
														                      </script>';
        endforeach;
    }

    public function MostrarMovimiento()
    {
        $total = 0;
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $movimiento = $this->cotizacion_model->Buscar($_POST['Movimiento_Id']);
        $data = array();
        echo '<table class="table table-hover table-bordered">';
        foreach ($movimiento as $r) :
            echo "<tr>";
            echo "<input type='hidden' name='Movimiento_Id' id='Movimiento_Id' value='" . $r->__GET('Movimiento_Id') . "'>";
            echo "<td>Fecha: </td>";
            echo "<td>" . $r->__GET('dMovFecha') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo Pago: </td>";
            echo "<td>" . ($r->__GET('nMovTipopago') == 1 ? 'Contado' : 'Credito') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo: </td>";
            echo "<td>" . ($r->__GET('nMovTipoOrigenDestino') == 1 ? 'Proveedor' : 'Cliente') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Cliente/Proveedor:</td>";
            echo "<td>" . $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Destino:</td>";
            echo "<td>" . ($r->__GET('nMovTipodestino') == 1 ? 'Almacen' : 'Consumo') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Almacen:</td>";
            echo "<td>" . $this->AlmNombre($r->__GET('Almacen_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento:</td>";
            echo "<td>" . $this->DocNombre($r->__GET('Documento_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Nro. Documento:</td>";
            echo "<td>" . $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento referencia:</td>";
            echo "<td> <input style='width:400px; height:50px; border: none;' type='text' id='sMovDocReferencia' name='sMovDocReferencia' value='" . $r->__GET('sMovDocReferencia') . "'> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo de moneda:</td>";
            echo "<td>" . ($r->__GET('Moneda_Id') == 1 ? 'Soles' : 'Dolares') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Asesor Comercial: </td>";
            echo "<td>" . $r->__GET('sMovAsesor') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Lugar de Entrega: </td>";
            echo "<td>" . $r->__GET('sMovLugarEnrtega') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Garantía:</td>";
            echo "<td>" . $r->__GET('nMovGarantia') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tiempo de entrega: </td>";
            echo "<td>" . $r->__GET('nMovTiempoEntrega') . " DÍAS</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Validez de la oferta: </td>";
            echo "<td>" . $r->__GET('nMovValidezOferta') . " DÍAS</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Hora:</td>";
            echo "<td>" . date('H:i A', strtotime($r->__GET('dMovFecha_Act'))) . "</td>";
            echo "</tr>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Observación:</td>";
            echo "<td> <textarea name='sMovObservacion' id='sMovObservacion' style='width:400px; height:80px; border:none;'>" . $r->__GET('sMovObservacion') . "</textarea> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Unidad</th>";
            echo "<th>Precio</th>";
            echo "<th>Descuento</th>";
            echo "<th>Sub Total</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_movimiento = $this->cotizaciondetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) :
                echo '<tr>';
                echo '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
                echo '<td>' . $detmov->__GET('nMovDetCantidad') . '</td>';
                echo '<td>' . $this->UnidadNombre($detmov->__GET('nMovDetUnidad_Id')) . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetPrecioUnitario'), $this->DECIMALES, ".", ",") . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetConDescuento'), $this->DECIMALES, ".", ",") . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetImporte'), $this->DECIMALES, ".", ",") . '</td>';
                echo '</tr>';
            endforeach;
            echo '<tr><td style="text-align: right;" colspan="5">DESCUENTO</td><td style="text-align: right;">' . number_format($r->__GET('nMovDescuento'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="5">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nMovImporte'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="5">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nMovIGV'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="5">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nMovTotal'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }

    public function GuardarMovimiento()
    {
        $mov = new Cotizacion();
        if ($_POST['Movimiento_Id'] != 0 ? $mov->__SET('Movimiento_Id', $_POST['Movimiento_Id']) : '');
        $mov->__SET('dMovFecha', $_POST['dMovFecha']);
        $mov->__SET('dMovFechaCotizacion', $_POST['dMovFechaCotizacion']);
        $mov->__SET('nMovTipopago', $_POST['nMovTipopago']);
        $mov->__SET('Almacen_Id', $_POST['Almacen_Id']);
        $mov->__SET('nMovTipoOrigenDestino', $_POST['nMovTipoOrigenDestino']);
        $mov->__SET('nMovOrigenDestino_Id', $_POST['nMovOrigenDestino_Id']);
        $mov->__SET('nMovTipodestino', $_POST['nMovTipodestino']);
        $mov->__SET('Documento_Id', $_POST['Documento_Id']);
        $mov->__SET('sMovDocumento', $_POST['sMovDocumento']);
        $mov->__SET('sMovDocReferencia', $_POST['sMovDocReferencia']);
        $mov->__SET('Moneda_Id', $_POST['Moneda_Id']);
        $mov->__SET('nMovTipoCambio', $_POST['nMovTipoCambio']);
        $mov->__SET('nMovImporte', str_replace(",", "", $_POST['dMovImporte']));
        $mov->__SET('nMovDescuento', str_replace(",", "", $_POST['nMovDescuento']));
        $mov->__SET('nMovIGV', str_replace(",", "", $_POST['dMovIGV']));
        $mov->__SET('nMovTotal', str_replace(",", "", $_POST['dMovTotal']));
        $mov->__SET('nMovSaldo', str_replace(",", "", $_POST['dMovTotal']));
        $mov->__SET('nMovTotalCancelado', $_POST['nMovTipopago'] == 1 ? str_replace(",", "", $_POST['dMovTotal']) : '0');
        $mov->__SET('dMovDetraccion', $_POST['dMovDetraccion']);
        $mov->__SET('dMovPercepcion', $_POST['dMovPercepcion']);
        $mov->__SET('dMovRetencion', $_POST['dMovRetencion']);
        $mov->__SET('sMovObservacion', $_POST['sMovObservacion']);
        $mov->__SET('nMovEstado', 1);
        $mov->__SET('nMovEliminado', 0);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $mov->__SET('nMovVendedor_Id', $_POST['nMovVendedor_Id']);
        $mov->__SET('dMovICBPER', str_replace(",", "", $_POST['dMovICBPER']));
        
        $mov->__SET('sMovAsesor', $_POST['sMovAsesor']);
        $mov->__SET('sMovLugarEnrtega', $_POST['sMovLugarEnrtega']);
        $mov->__SET('nMovGarantia', $_POST['nMovGarantia']);
        $mov->__SET('nMovTiempoEntrega', $_POST['nMovTiempoEntrega']);
        $mov->__SET('nMovValidezOferta', $_POST['nMovValidezOferta']);

        if ($_POST['Movimiento_Id'] != 0) {
            $this->cotizacion_model->Editar($mov);
        } else {
            $Movimiento_Id = $this->cotizacion_model->Guardar($mov);
            $mov->__SET('Movimiento_Id', $Movimiento_Id);

            $parametro = $this->parametro_model->ListarParametros();

            if (isset($_SESSION['producto_c'])) {
                $data = $_SESSION['producto_c'];
                for ($i = 0; $i < count($data); $i++) {
                    $movdet = new Cotizaciondetalle();
                    $movdet->__SET('Movimiento_Id', $Movimiento_Id);
                    $movdet->__SET('dMovFechaCotizacion', $_POST['dMovFechaCotizacion']);
                    $movdet->__SET('TipoDestino', $_POST['nMovTipodestino']);
                    $movdet->__SET('ProdServ_Id', $data[$i]['ProdServ_Id']);
                    $movdet->__SET('Almacen_Id', $_POST['Almacen_Id']);
                    $movdet->__SET('Lote', $data[$i]['lotes'] != 0 ? $data[$i]['lotes'] : date('Ymdhis'));

                    $movdet->__SET('FechaVencimiento', $data[$i]['dMovDetConFechaVencimiento']); // pendiente
                    $movdet->__SET('Cantidad', $data[$i]['sMovDetConCantidad']);
                    $movdet->__SET('Unidad_Id', $data[$i]['Unidadmedida_Id']); // pendiente
                    $movdet->__SET('MonedaCompra_Id', $_POST['Moneda_Id']);
                    $movdet->__SET('PrecioLista', $data[$i]['nMovDetConPrecioUnitario']);
                    $movdet->__SET('Descuento', 0);
                    $movdet->__SET('Precio', $data[$i]['nMovDetConPrecioUnitario']);
                    $movdet->__SET('nMovDetConDescuento', $data[$i]['nMovDetConDescuento']);
                    $movdet->__SET('SubTotal', $data[$i]['nMovDetConSubtotal']);
                    $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                    $movdet->__SET('TipoCambio', $_POST['nMovTipoCambio']);
                    $movdet->__SET('nMovDetIncluyeIgv', 0);
                    $dMovICBPER = 0;
                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {

                        $dMovICBPER = $this->calcularICBPER($data[$i]['sMovDetConCantidad']);
                    }

                    $movdet->__SET('dMovDetICBPER', $dMovICBPER);
                    $this->cotizaciondetalle_model->Guardar($movdet);
                }
            }
        }
        $this->DetruirSessiones();
        echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                  </div>';

        $Documento_Id = $_POST['Documento_Id'];
        $doc = $this->documento_model->Numero($Documento_Id);


        // echo "<script type='text/javascript'>location.href='?c=Movimiento&a=Index';</script>";
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }

    public function TipoMovimiento()
    {
        $productos = $this->prodserv_model->Listar2();
        $tipomovimiento = $this->tipomovimiento_model->Buscar($_POST['Tipomovimiento_Id']);
        foreach ($tipomovimiento as $tv) {
            echo '<script type="text/javascript">
                        $(\'#nMovTipoOrigenDestino option[value="' . $tv->__GET('nTMovTipoOD') . '"]\').attr(\'selected\',\'selected\');
                        TipoPrvClien();
                    </script>';
        }
        if ($_POST['Tipomovimiento_Id'] == 1 || $_POST['Tipomovimiento_Id'] == 3) {
            require_once 'view/webforms/tipomovimiento/ingreso_compra.php';
        } elseif ($_POST['Tipomovimiento_Id'] == 2 || $_POST['Tipomovimiento_Id'] == 4) {
            require_once 'view/webforms/tipomovimiento/salida_venta_cotizacion.php';
        }
    }

    public function ListarUnidades()
    {
        $unidad = $this->unidadmedida_model->ListarUP($this->ObtenerID($_POST['ProdServ_Id']));
        $_SESSION['$unidad'] = $unidad;
        // echo "<option value=''>Seleccione unidad</option>";
        foreach ($unidad as $uni) {
            echo "<option value='" . $uni->__GET('UnidadMedida_Id') . "' data-codigosunat='" . $uni->__GET('sUndCodeSunat') . "'
                                                                         data-alias='" . $uni->__GET('sUndAlias') . "'
                                                                         data-factor='" . $uni->__GET('nUndFac_Cnv') . "'>" .
                $uni->__GET('sUndDescripcion') .
                "</option>";
        }
    }
    public function RenderizadoClass($nProSrvExoneradoIGV)
    {
        switch ($nProSrvExoneradoIGV) {
            case 0:
                return 'style="color:black;"';
            case 1:
                return 'style="color:#cc3300;"';
            case 2:
                return 'style="color:#ffc107;"';
        }
    }
    public function ListarProductos()
    {
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {

                    echo "<tr " . $this->RenderizadoClass($data[$i]['nProSrvExoneradoIGV']) . "> 

                                <td>" . (isset($data[$i]['sProSrvNombre']) ? $data[$i]['sProSrvNombre'] : $this->ProdservdNombre($data[$i]['ProdServ_Id'])) . "</td>
                                <td>" . $data[$i]['sMovDetConCantidad'] . "</td>
                                <td>" . $this->UnidadNombre($data[$i]['Unidadmedida_Id']) . "</td>
                                <td>" . number_format($data[$i]['nMovDetConPrecioUnitario'], $this->DECIMALES) . "</td>
                                <td>" . number_format($data[$i]['nMovDetConDescuento'], $this->DECIMALES) . "</td>
                                <td>" . number_format($data[$i]['nMovDetConSubtotal'], $this->DECIMALES) . "</td>
                                <td>
                                    <a href=\"#\" class=\"btn btn-danger btn-flat btn-xs\" data-toggle=\"modal\" data-target=\"#eliminar_productos\" data-productoid='" . $i . "'><i class=\"fa fa-trash-o\"></i></a>
                                </td>
                            </tr>";
                }
            } else {
                echo "<tr> 
                        <td colspan='7'>No hay datos</td>
                      </tr>";
            }
        } else {
            echo "<tr>
                        <td colspan='7'>No hay datos</td>
                      </tr>";
        }
    }

    public function validardetallemovimiento()
    {
        if (isset($_SESSION['producto_c'])) {
            echo count($_SESSION['producto_c']);
            // echo 0;
        } else {
            echo 0;
        }
    }

    public function ListarLoteProducto()
    {
        $data = $this->productolote_model->Listar(!empty($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : 0);
        if (count($data) > 0) {
            foreach ($data as $l) {
                echo "<tr>
                            <th>
                                <input type='radio' name='lotes' id='lotes' value='" . $l->__GET("Lote") . "' onclick='enviarPrecioCosto(" . $l->__GET("PrecioCosto") . ");' data-preciocosto='" . $l->__GET("PrecioCosto") . "' data-almacen='" . $l->__GET("Almacen_Id") . "' checked>
                                <input type='radio' style='visibility:hidden;' name='lotes1' id='lotes' value='" . $l->__GET("Stock") . "'>
                            </th>
                            <td>" . $l->__GET("Almacen") . "</td>
                            <td>" . $l->__GET("Lote") . "</td>
                            <td>" . number_format($l->__GET("Stock"), 4) . "</td>
                            <td>" . $l->__GET("Unidad") . "</td>";
                            if ($_SESSION['usu_role'] != 22) {
                                echo "<td>" . number_format($l->__GET("PrecioCosto"), 4) . "</td>";
                            }
                            
                            echo "</tr>";
            }
        } else {
            echo "<tr>
                    <td colspan='7'>
                        No hay datos
                    </td>
                  </tr>";
        }
    }

    public function NombreAlmacen($Almacen_Id)
    {
        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sAlmNombre');
        }
    }

    /*public function AgregarProductoC()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            // $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'] / $this->IGV;
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario']; // 5/06/2024
        } else {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sMovDetConCantidad" => $_POST['sMovDetConCantidad'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dMovDetConFechaVencimiento" => isset($_POST['dMovDetConFechaVencimiento']) ? $_POST['dMovDetConFechaVencimiento'] : date('d-m-Y'),
            "nMovDetConPrecioUnitario" => round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nMovDetConDescuento" => round($_POST['nMovDetConDescuento'], $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nMovDetConSubtotal" => (round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP) * $_POST['sMovDetConCantidad'])-round($_POST['nMovDetConDescuento'], $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            array_push($data, $array);
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        echo '<div class="alert alert-success prod" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito!</strong>, Los Datos fueron agregados correctamente.
                  </div>';
    }*/
    // hoy 05/06/2024 bien 
    public function AgregarProductoC()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            // $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'] / $this->IGV; // bien
            $nMovDetConPrecioUnitario = ($_POST['nMovDetConPrecioUnitario']-$_POST['nMovDetConDescuento']) / $this->IGV; // bien
            //$nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario']; // 5/06/2024
        } else {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario']-$_POST['nMovDetConDescuento'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sMovDetConCantidad" => $_POST['sMovDetConCantidad'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dMovDetConFechaVencimiento" => isset($_POST['dMovDetConFechaVencimiento']) ? $_POST['dMovDetConFechaVencimiento'] : date('d-m-Y'),
            "nMovDetConPrecioUnitario" => round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nMovDetConDescuento" => round($_POST['nMovDetConDescuento'], $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nMovDetConSubtotal" => (round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP) * $_POST['sMovDetConCantidad']), //-round($_POST['nMovDetConDescuento'], $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            array_push($data, $array);
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        echo '<div class="alert alert-success prod" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito!</strong>, Los Datos fueron agregados correctamente.
                  </div>';
    }

    public function EliminarProductoLista()
    {
        $array = array();
        $data = $_SESSION['producto_c'];
        for ($i = 0; $i < count($data); $i++) {
            if ($i != $_POST['Codigo_Producto']) {
                $array[] = array(
                    "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : $data[$i]['ProdServ_Id'],
                    "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sMovDetConCantidad" => $data[$i]['sMovDetConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dMovDetConFechaVencimiento" => $data[$i]['dMovDetConFechaVencimiento'],
                    "nMovDetConPrecioUnitario" => $data[$i]['nMovDetConPrecioUnitario'],
                    "nMovDetConSubtotal" => $data[$i]['nMovDetConSubtotal'],
                    "nProSrvExoneradoIGV" => $data[$i]['nProSrvExoneradoIGV'],
                    "nProSrvICBPer" => $data[$i]['nProSrvICBPer'],
                );
            }
        }
        $_SESSION['producto_c'] = $array;
        // echo "Datos eliminados";
    }

    public function ModificarPrecioProductoLista()
    {
        // echo $_POST['checked'] === 'true' ? 1 : 0;
        $array = array();
        $data = $_SESSION['producto_c'];
        for ($i = 0; $i < count($data); $i++) {
            if ($i == $_POST['Codigo_Producto']) {
                $array[] = array(
                    "HasBonus" => true,
                    "ProdServ_Id" => $data[$i]['ProdServ_Id'],
                    "lotes" => $data[$i]['lotes'],
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sMovDetConCantidad" => $data[$i]['sMovDetConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dMovDetConFechaVencimiento" => $data[$i]['dMovDetConFechaVencimiento'],
                    "nMovDetConPrecioUnitario" => $_POST['checked'] === 'true' ? 0 : $data[$i]['after_nMovDetConPrecioUnitario'],
                    "nMovDetConSubtotal" => $_POST['checked'] === 'true' ? 0.01 : $data[$i]['after_nMovDetConSubtotal'],
                    "nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? 1 : $data[$i]['after_nProSrvExoneradoIGV'], // $data[$i]['nProSrvExoneradoIGV']
                    "after_nMovDetConPrecioUnitario" => $_POST['checked'] === 'true' ? $data[$i]['nMovDetConPrecioUnitario'] : 0,
                    "after_nMovDetConSubtotal" => $_POST['checked'] === 'true' ? $data[$i]['nMovDetConSubtotal'] : 0,
                    "after_nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? $data[$i]['nProSrvExoneradoIGV'] : 0, // $data[$i]['nProSrvExoneradoIGV']
                );
            } else {
                $array[] = $data[$i];
            }
        }
        $_SESSION['producto_c'] = $array;
    }

    public function EliminarProductos()
    {
        $pro = new Prodserv();
        $pro->__SET('ProdServ_Id', $_POST['idProdServ']);
        $this->prodserv_model->Eliminar($pro);
        echo '<script type="text/javascript">window.location="?c=Productos&a=Index";</script>';
    }

    public function AnularMovimiento()
    {
        $mov = new Cotizacion();
        $mov->__SET('Movimiento_Id', $_POST['IdMovimiento']);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $this->cotizacion_model->Eliminar($mov);
        echo '<script type="text/javascript">window.location="?c=Cotizacion&a=Index";</script>';
    }

    public function ObtenerID($ProdServ_Id)
    {
        foreach ($this->prodserv_model->Buscar($ProdServ_Id) as $p) {
            return $p->__GET('nProSrvUnidad_Id');
        }
    }

    // hoy 05/06/2024 bien
    public function CalcularImpTotIGV()
    {
        $dMovICBPER = 0;
        // $importe = 0;
        $dMovImporte = 0;
        $dMovIGV = 0;
        $nMovDescuento = 0;

        $total = 0;
        $IGV = 0;
        $isItem = 'false';
        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = 0.18;
                }
                /*else {
            $IGV = 1.18;
            }*/
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {

                    $dMovImporte += $data[$i]['nMovDetConSubtotal'];
                    $nMovDescuento += $data[$i]['nMovDetConDescuento'];

                    if (isset($data[$i]['nProSrvExoneradoIGV']) && $data[$i]['nProSrvExoneradoIGV'] == 0) {

                        $dMovIGV += $data[$i]['nMovDetConSubtotal'] * $IGV;
                        // $dMovIGV += $dMovImporte * $IGV;
                    } else {

                        $dMovIGV += 0;
                    }

                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {
                        $dMovICBPER += $this->calcularICBPER($data[$i]['sMovDetConCantidad']);
                    }
                }
                $isItem = 'true';
            } else {
                $isItem = 'false';
            }
        }


        $dMovIGV = isset($_SESSION['usu_enterpriseExoneratedIGV']) && $_SESSION['usu_enterpriseExoneratedIGV'] == 1 ? 0 : $dMovIGV;

        // TODO: fix para el calculo cuando se marca igv incluido en modal 5/06/2024
        // $dMovImporte = $dMovImporte - $dMovIGV;
        
        echo "<script type='text/javascript'>
                    document.getElementById('dMovImporte').value = '" . number_format($dMovImporte, 2, ".", ",") . "';
                    document.getElementById('nMovDescuento').value = '" . number_format($nMovDescuento, 2, ".", ",") . "';
                    document.getElementById('dMovIGV').value = '" . number_format($dMovIGV, 2, ".", ",") . "';
                    document.getElementById('dMovICBPER').value = '" . number_format($dMovICBPER, 2, ".", ",") . "';
                    document.getElementById('dMovTotal').value = '" . number_format(($dMovImporte + $dMovIGV + $dMovICBPER), 2, ".", ",") . "';
                    document.getElementById('Tipomovimiento_Id').disabled = $isItem;
                    document.getElementById('nMovTipodestino').disabled = $isItem;
                </script>";
    }

    public function CalcularImpTotIGV_venta()
    {
        $importe = 0;
        $total = 0;
        $IGV = 1;

        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = $this->IGV;
                }
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            for ($i = 0; $i < count($data); $i++) {
                $importe = $importe + $data[$i]['nMovDetConSubtotal'];
            }
        }
        echo "<script type='text/javascript'>
                    document.getElementById('dPedImporte').value = '" . number_format($importe, 2) . "';
                    document.getElementById('dPedIGV').value = '" . number_format(($importe * $IGV - $importe), 2) . "';
                    document.getElementById('dPedTotal').value = '" . number_format(($importe * $IGV), 2) . "';
                </script>";
    }

    public function UnidadNombre($Unidadmedida_Id)
    {
        $dato = $this->unidadmedida_model->Buscar($Unidadmedida_Id);
        foreach ($dato as $d) {
            return $d->__GET('sUndAlias');
        }
    }

    public function ProdservdNombre($ProdServ_Id)
    {
        $data = $this->prodserv_model->Buscar($ProdServ_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sProSrvNombre');
        }
    }

    public function DocNombre($Documento_Id)
    {
        $data = $this->documento_model->Buscar($Documento_Id);
        foreach ($data as $doc) {
            return $doc->__GET('sDocNombre');
        }
    }
    public function AlmNombre($Almacen_Id)
    {

        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $alm) {
            return $alm->__GET('sAlmNombre');
        }
    }
    public function DetruirSessiones()
    {
        unset($_SESSION['producto_c']);
    }

    public function PDFMovimiento()
    {
        $movimiento = $this->cotizacion_model->Buscar($_POST['PDFMmovimiento_Id']);
        $detalle_movimiento = $this->Detalles($movimiento[0]->Movimiento_Id);
        require_once 'view/webforms/PDF/movimiento.php';
    }
    public function act_obs_docref()
    {

        $mov = new Movimiento();
        if ($_POST['Movimiento_Id'] != 0 ? $mov->__SET('Movimiento_Id', $_POST['Movimiento_Id']) : '');
        $mov->__SET('sMovDocReferencia', $_POST['sMovDocReferencia']);
        $mov->__SET('sMovObservacion', $_POST['sMovObservacion']);
        $mov->__SET('nMovVendedor_Id', $_POST['vendedor']);
        if ($_POST['Movimiento_Id'] != 0) {
            $this->movimiento_model->act_obs_docref($mov);
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }

    public function Detalles($Movimiento_Id)
    {
        $detalle_movimiento = $this->cotizaciondetalle_model->Buscar($Movimiento_Id);
        $result = '';
        foreach ($detalle_movimiento as $detmov) :
            $result .= '<tr>';
            $result .= '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
            $result .= '<td>' . $detmov->__GET('nMovDetCantidad') . '</td>';
            $result .= '<td>' . $this->UnidadNombre($detmov->__GET('nMovDetUnidad_Id')) . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nMovDetPrecioUnitario'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nMovDetImporte'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '</tr>';
        endforeach;
        return $result;
    }

    public function ImprimirTicket()
    {
        $parametro = $_GET['Movimiento'];
        //$comando = 'start /d "C:\STC R2\" start "" "C:\STC R2\STCCFD.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando = 'start /d "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\" start "" "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\PrintVale.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando_escapado = escapeshellcmd($comando);
        exec($comando_escapado, $resultadoSalida, $ejecucion);
        if ($ejecucion > 0) {
            echo 'Ocurrio un problema en la impresion.';
        } else {
            echo 'La impresion se realizo correctamente gracias.';
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }


    public function comprobante()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['Movimiento_Id']);

        $r = $movimiento[0];
        $detalle = $this->movimientodetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/comprobanteelectronico.php';
    }

    public function comprobantePDF()
    {
        $movimiento = $this->cotizacion_model->Buscar($_REQUEST['Movimiento_Id']);

        //print_r($movimiento);print_r($_SESSION);

        $r = $movimiento[0];
        $detalle_movimiento = $this->cotizaciondetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
        $observacion = $r->__GET('sMovObservacion');
        $detraccion = $this->parametro_model->obtenerParametro(6)['sParValor'];
        $cuenta_bn = $_SESSION['usu_enterpriseCTADetraccion'];
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[16]->__GET('sParValor'));
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];

        $od = $this->origendestino_model->Buscar($r->nMovOrigenDestino_Id)[0];

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/ecomprobante2.php';
    }
    
    public function comprobantePDF2()
    {
        $movimiento = $this->cotizacion_model->Buscar($_REQUEST['Movimiento_Id']);

        //print_r($movimiento);print_r($_SESSION);

        $r = $movimiento[0];
        $detalle_movimiento = $this->cotizaciondetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
        $observacion = $r->__GET('sMovObservacion');
        $detraccion = $this->parametro_model->obtenerParametro(6)['sParValor'];
        $cuenta_bn = $_SESSION['usu_enterpriseCTADetraccion'];
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[16]->__GET('sParValor'));
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];

        $od = $this->origendestino_model->Buscar($r->nMovOrigenDestino_Id)[0];

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/cotizacion.php';
    }

    public function getByDocumento()
    {
        $movimiento = $this->movimiento_model->getByDocumento($_REQUEST['documento']);
        if ($movimiento) {
            $movimiento['detalle'] = $this->movimientodetalle_model->getByMovimientoId($movimiento['Movimiento_Id']);
        }
        echo json_encode($movimiento);
    }


    public function validar_documento($movimiento)
    {
        $documento = $movimiento->RUC_DNI;
        /**
         * Validar si es solo dni
         */
        if (strlen($documento) == 8) {
            return true;
        }
        /**
         * Validar si es ruc
         */
        if (strlen($documento) == 11) {
            return true;
        }
        /**
         * si el documento no tiene el tamaño
         * de dni o ruc no es valido
         */
        return false;
    }
    /**
     * Calcular ICBPER function
     *
     * @param [type] $value
     * @param [type] $cantidad
     * @return void
     */
    // function calcularICBPER($value, $cantidad) {
    //     return ($value * $this->ICBPER) * $cantidad;
    // }
    function calcularICBPER($cantidad)
    {
        return ($this->ICBPER) * $cantidad;
    }
}
