<?php
header('Access-Control-Allow-Origin: *'); 
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/familia.model.php';
require_once 'model/familia.entidad.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/productolote.model.php';
require_once 'model/productolote.entidad.php';
require_once 'model/precioventa.model.php';
require_once 'model/precioventa.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/vendedor.model.php';
require_once 'model/vendedor.entidad.php';
require_once 'controller/electronic.controller.php';

class DespachoController extends MetodosController
{
    public $url;
    public $parametro_model;
    public $documento_model;
    public $almacen_model;
    public $tipomovimiento_model;
    public $movimiento_model;
    public $prodserv_model;
    public $familia_model;
    public $unidadmedida_model;
    public $productolote_model;
    public $movimientodetalle_model;
    public $precioventa_model;
    public $origendestino_model;
    public $IGV = 0;
    public $ICBPER = 0.10;
    private $electronic_controller;
    private $seguridad;

    public function __CONSTRUCT()
    {
        $this->url = 'http://colibri-fm.ddns.net:8087/servicio/Transaccion/AnularSunat/' . $_SESSION['usu_enterpriseRuc'];
        $this->parametro_model = new ParametroModel();
        $this->documento_model = new DocumentoModel();
        $this->almacen_model = new AlmacenModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->movimiento_model = new MovimientoModel();
        $this->prodserv_model = new ProdservModel();
        $this->familia_model = new FamiliaModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->productolote_model = new ProductoloteModel();
        $this->precioventa_model = new PrecioventaModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->electronic_controller = new ElectronicController();
        $this->vendedor_model = new VendedorModel();
        $this->seguridad = new Seguridad();
        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 10) {
                $this->ICBPER =  ($pa->__GET('sParValor')) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 14) {
                $this->DECIMALES =  ($pa->__GET('sParValor'));
            }
        }
    }

    public function Index()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'] or $this->seguridad->validRoleName(RolesType::admin2) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->Listar();
        $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : $valor[1];
        $movimientos = $this->movimiento_model->ListarDateDespacho(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
            $TipoMovimiento_Id
        );

        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfadespacho.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function ConfirmarDespacho()
    {
        $Despacho_Id = $_POST['IdDespacho'] == "" ? 0 : $_POST['IdDespacho'];;
        $Movimiento_Id = $_POST['Movimiento_Id'];
        $obs = $_POST['obs'];
        $cbxCompleto = isset($_POST['cbxCompleto']) ? 1 : 0;
        // if ($cbxCompleto == 0) { // entrega incompleta
            $this->movimiento_model->crearDespacho($Despacho_Id, $cbxCompleto, $Movimiento_Id, $obs);
        // } else {
            // $this->movimiento_model->crearDespacho($Despacho_Id, $cbxCompleto, $Movimiento_Id, $obs);
        // }

        // if ($Despacho_Id == '') {
        //     $this->movimiento_model->crearDespacho($Movimiento_Id, $obs);
        // } else {
        //     $this->movimiento_model->ConfirmarDespacho($Despacho_Id);            
        // }
        

        echo "<script type='text/javascript'>location.href='?c=Despacho&a=Index';</script>";
    }
    
    public function despachosIncompletos()
    {
        $despachos_incompletos = $this->movimiento_model->despachosIncompletos();
        echo json_encode($despachos_incompletos);
    }
    
    public function VerDespachosIncompletos()
    {
        $despachos = $this->movimiento_model->VerDespachosIncompletos();
        // echo '<pre>';
        // var_dump($despachos);
        // echo '</pre>';
        // exit();
        require_once 'view/header.php';
        require_once 'view/webforms/wfadespachoIncompletos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
}
