<?php

require_once 'view/librerias/PHPExcel2/Classes/PHPExcel.php';
require_once 'view/librerias/PHPExcel2/Classes/PHPExcel/IOFactory.php';

date_default_timezone_set('America/Lima');

$objPHPExcel = new PHPExcel();
$objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'START DATE')
            ->setCellValue('B1', 'END DATE')
            ->setCellValue('C1', 'CARGA FINAL')
            ->setCellValue('D1', 'CHEQUE')
            ->setCellValue('E1', '% COMISION')
            ->setCellValue('F1', '% RETURNS')
            ->setCellValue('G1', 'TOTAL');

$sheet = $objPHPExcel->getActiveSheet();

$rowIndex = 2;

foreach ($incomes as $income) {
    $sheet->setCellValue('A' . $rowIndex, date('Y-m-d', strtotime($income->dIngFechaInicio)));
    $sheet->setCellValue('B' . $rowIndex, date('Y-m-d', strtotime($income->dIngFechaFin)));
    $sheet->setCellValue('C' . $rowIndex, $income->nIngCargaFinal);
    $sheet->setCellValue('D' . $rowIndex, $income->nIngCheque);
    $sheet->setCellValue('E' . $rowIndex, intval($income->nIngPorcenComision) . '%');
    $sheet->setCellValue('F' . $rowIndex, '-' . intval($income->nIngPorcenRetorno) . '%');
    $sheet->setCellValue('G' . $rowIndex, (intval($income->nIngPorcenComision) + intval($income->nIngPorcenRetorno)) . '%');
    $rowIndex++;
}

foreach (range('A', 'G') as $columnID) {
    $objPHPExcel->getActiveSheet()->getColumnDimension($columnID)->setAutoSize(true);
}

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

$fileName = "incomes.xlsx";
$objWriter->save($fileName);

echo json_encode(array("success" => true, "filename" => $fileName));
exit;