<?php

require_once 'model/gasto.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/enterprise.model.php';

class GastoController extends MetodosController {

    public $gasto_model;
    public $parametro_model;
    public $enterprise_model;

    public function __construct() {
        $this->gasto_model = new GastoModel();
        $this->parametro_model = new ParametroModel();
        $this->enterprise_model = new EnterpriseInfoModel();
    }

    public function Index() {
        $fechaIncio = isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio']))
            : date('Y-m-d', strtotime('-1 day', strtotime(date('d-m-Y'))));
        $fechaFin = isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin']))
            : date('Y-m-d', strtotime(date('d-m-Y')));
        $paramDestino = isset($_POST['paramDestino']) ? $_POST['paramDestino'] : 0;

        $gastos = $this->gasto_model->ListarxDate($fechaIncio, $fechaFin, $paramDestino);
        $parametro = $this->parametro_model->ListarParametros();

        $companies = $this->enterprise_model->Listar();

        require_once 'view/header.php';
        require_once 'view/webforms/wfamovimiento.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function MostrarGasto() {
        $gasto = $this->gasto_model->Buscar($_POST['Gasto_Id']);
        
        echo '<table class="table table-hover table-bordered">';

        foreach ($gasto as $value) {

            $estado = '';
            if($value->nGasEstado == '0') {
                $estado = '<span class="label label-danger">Anulado</span>';
            } else if ($value->nGasEstado == '1') {
                $estado = '<span class="label label-success">Registrado</span>';
            }

            $detalle = $this->gasto_model->ListarGastoDetalle($_POST['Gasto_Id']);

            echo '<tr>';
            echo '<td><strong>Destino: </strong></td>';
            echo '<td>';
            foreach ($detalle as $item) {
                echo $item->sEnterName . '<br>';
            }
            echo '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Fecha de Emision: </strong></td>';
            echo '<td>' . date('d-m-Y', strtotime($value->dGasFechaEmision)) . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Descripcion: </strong></td>';
            echo '<td>' . $value->sGasDescripcion . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Monto: </strong></td>';
            echo '<td>' . $value->nGasMonto . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Estado: </strong></td>';
            echo '<td>' . $estado . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Registrado por: </strong></td>';
            echo '<td>' . $value->Name . '</td>';
            echo '</tr>';
        }

        echo '</table>';
    }

    public function GuardarGasto() {
        $Gasto = [
            'dGasFechaEmision' => date('Y-m-d', strtotime($_POST['dMovFecha'])),
            'sGasDescripcion' => $_POST['sGasDescripcion'],
            'nGasMonto' => $_POST['nGasMonto'],
            'Usuario_Id' => $_SESSION['usu_codigo'],
            'Gasto_Id' => $_POST['Gasto_Id']
        ];

        $_POST['Gasto_Id'] == '' || $_POST['Gasto_Id'] == '0' ? $res = $this->gasto_model->GuardarGasto($Gasto) : $res = $this->gasto_model->EditarGasto($Gasto);

        $checks = json_decode($_POST['checkboxes']);

        if ($_POST['Gasto_Id'] == '' || $_POST['Gasto_Id'] == '0') {
            // creamos detalle de gasto
            
            foreach ($checks as $item) {
                if ($item->checked) {
                    $this->gasto_model->CrearGastoDetalle($res, $item->id);
                }
            }
            

        } else {
            // eliminamos detalle de gasto
            $this->gasto_model->EliminarGastoDetalle($_POST['Gasto_Id']);

            // creamos detalle de gasto
            foreach ($checks as $item) {
                if ($item->checked) {
                    $this->gasto_model->CrearGastoDetalle($_POST['Gasto_Id'], $item->id);
                }
            }
        }

        echo '<div class="alert alert-success prod" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Successful!</strong>, the data was recorded correctly.
                    </div>';

    }

    public function EliminarGasto() {
        $gasto_id = $_POST['Gasto_Id'];
        $this->gasto_model->EliminarGasto($gasto_id);

        echo '<script type="text/javascript">window.location="?c=Gasto&a=Index";</script>';
    }

    public function FrmEditarGasto() {
        $Gasto_Id = $_POST['Gasto_Id'];
        $gasto = $this->gasto_model->Buscar($Gasto_Id);
        foreach ($gasto as $r) {
            require_once 'view/webforms/wfamovimientoa.php';
        }
    }

    public function getGasto() {
        $id = $_POST['Gasto_Id'];
        $gasto = $this->gasto_model->Buscar($id);
        echo json_encode($gasto);
    }

    public function getGastoDetalle() {
        $id = $_POST['Gasto_Id'];
        $detalle = $this->gasto_model->ListarGastoDetalle($id);
        echo json_encode($detalle);
    }


}