<?php

require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/guiaremision.model.php';
require_once 'model/guiaremision.entidad.php';
require_once 'model/guiaremisiontransportista.entidad.php';
require_once 'model/guiaremisiontransportista.model.php';
require_once 'model/guiaremisiontransportistadetalle.model.php';

require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/motivotraslado.model.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/tipotransporte.model.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'controller/electronic.controller.php';
require_once './extends/request-services.php';


class GuiaremisionTransportistaController
{
    private $parametro_model;
    private $guiaremision_model;
    private $guiaremisiondetalle_model;
    private $almacen_model;
    private $motivotraslado_model;
    private $documento_model;
    private $electronic_controller;
    private $tipotransporte_model;
    private $unidadmedida_model;
    private $movimiento_model;
    private $seguridad;
    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->guiaremision_model = new GuiaremisiontransportistaModel();
        $this->guiaremisiondetalle_model = new GuiaremisiontransportistadetalleModel();
        $this->almacen_model = new AlmacenModel();
        $this->motivotraslado_model = new MotivotrasladoModel();
        $this->documento_model = new DocumentoModel();
        $this->electronic_controller = new ElectronicController();
        $this->tipotransporte_model = new TipotransporteModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimiento_model = new MovimientoModel();
        $this->seguridad = new Seguridad();
    }

    public function index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        // $guiaremision = $this->guiaremision_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $guiaremision = $this->guiaremision_model->Guia_listardate($fechaIni, $fechaFin);
        
        // $guiaremision = $this->guiaremision_model->Guia_listardate(
        //     isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
        //     isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))));
        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisiontransportista.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function formulario()
    {
        $almacen = $this->almacen_model->Listar();
        $parametro = $this->parametro_model->ListarParametros();
        $motivotraslado = $this->motivotraslado_model->Listar('GRT');
        $tipotransporte = $this->tipotransporte_model->Listar();
        $unidadmedida = $this->unidadmedida_model->Listar();
        
        // TODO: inversion AG
        $series = $this->documento_model->ListarSeries();
        // TODO: FIN inversion AG

        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisiontransportistaa.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function save()
    {
        try {
            if ($_REQUEST['Guiaremision_Id'] == 0) {
                $id = $this->guiaremision_model->Crear($_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $this->guiaremisiondetalle_model->Crear([
                            'Guiaremisiontransportista_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                    }
                }
                //TODO: Verificar el id del documento guia remision transportista
                if ($_POST['sTraSerieSelect'] != '') {
                    $this->documento_model->Incrementa($_POST['sTraSerieSelect']);
                } else {
                    $this->documento_model->Incrementa(18);
                }
            } else {
                $id = $_REQUEST['Guiaremision_Id'];
                $this->guiaremision_model->Update($_REQUEST['Guiaremision_Id'], $_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    $this->guiaremisiondetalle_model->Delete($_REQUEST['Guiaremision_Id']);
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $this->guiaremisiondetalle_model->Crear([
                            'Guiaremisiontransportista_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                    }
                }
            }
            echo $id;
        } catch (Exception $e) {
            var_dump($e);
        }
    }

    public function Previsualizar()
    {

        $result = null;
        $parametro = $this->parametro_model->ListarParametros();
        $guiaremision = $this->guiaremision_model->Buscar($_REQUEST['code']);
        // $guiaremision = $this->guiaremision_model->Buscar($_POST['code']);

        //NO TIENE DOCUMENTO REFERENCIAL
        if ($guiaremision['sSerieNumeroRelacionado'] == '') {
            $button_gr = '<button type="submit" class="btn btn-primary btn-flat">Enviar GR</button>';
        } else {
            // TIENE UN DOCUMENTO REFERENCIAL
            $gr_format = explode("-", $guiaremision['sSerieNumeroRelacionado']);

            //obtenemos el id del documento del comprobante relacionado
            $get_id_doc = $this->documento_model->BuscarByNombreCorto($gr_format[0]);
            foreach ($get_id_doc as $t) {
                $id = $t->__GET('Documento_Id');
            }

            //obtenemos el id del comprobante relacionado
            $getid_comprobante = $this->movimiento_model->ObtenerIdConNroSerie($id, $gr_format[1]);
            $id_comprobante = $getid_comprobante[0]->Movimiento_Id;
            // verificamos si factura está validada
            $request = new RequestServices();
            $request->url = 'http://colibri2.fmsac.com/comprobante/' . $_SESSION['usu_enterpriseRuc'] . '/' . $gr_format[0] . '/' . $gr_format[1];
            $request->parameters = [];
            $result = $request->serviceGET();

            // si está validada habilitados el botón
            if ($result == 1 || $result == 2 || $result == 3) {
                $button_gr = '<button type="submit" class="btn btn-primary btn-flat">Enviar GR</button>';
            } else {
                $button_gr = '<button type="button" id="comprobante_gr" data-toggle="modal" data-target="#modal-confirmar-validacion" class="btn btn-primary btn-flat" data-gr="' . $_REQUEST['code'] . '" data-comprobante="' . $id_comprobante . '">Enviar GR + Comprobante</button>';
            }
        }

        if (!isset($_REQUEST['origen'])) {
            require_once 'view/header.php';
        }
        
        require_once 'view/webforms/wfaguiaremisiontransportistav.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        if (!isset($_REQUEST['origen'])) {
            // require_once 'view/header.php';
            require_once 'view/footer.php';
        }
    }

    public function eliminar()
    {
        $this->guiaremision_model->Eliminar($_REQUEST['guiaremision_id']);
    }

    public function bajarComprante()
    {
        $this->guiaremision_model->Baja($_REQUEST['guiaremision_id']);
        $response = array('success' => $res);
        echo json_encode($response);
        //$guia = $this->guiaremision_model->Buscar($_REQUEST['guiaremision_id']);
        //$request = new RequestServices();
        //$request->url = 'http://colibri2.fmsac.com/baja.php?ruc=' . ($guia['sTraRUCEmpresa']) . '&serie=' . $guia['sTraSerie'] . '&numero=' . ($guia['sTraNumero']);
        //$request->parameters = [];
        //$result = $request->serviceGET();
        //echo json_encode($result);
    }

    public function Enviarcomprobante()
    {

        echo $this->electronic_controller->GuiaRemisionTransportista($_REQUEST['Guiaremision_Id']);
        //Actualizar estado SUNAT
        // $this->guiaremision_model->updaeteEstado($_REQUEST['Guiaremision_Id'], 1);
    }

    public function Buscar()
    {
        $guiasremision = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        $guiasremision['dTraFecha'] = date('d-m-Y', strtotime($guiasremision['dTraFecha']));
        $guiasremision['dTraFechaTraslado'] = date('d-m-Y', strtotime($guiasremision['dTraFechaTraslado']));
        $guiasremision['detalle'] = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        echo json_encode($guiasremision);
    }

    public function comprobante()
    {
        $guia = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($guia);
        $detalle = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($detalle);

        //TODO Cambie el 09 => 31
        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '31',
            $guia['sTraSerie'],
            $guia['sTraNumero'],
            '0.00', //$r->nMovIGV,
            '0.00', //$r->nMovTotal,
            date('d-m-Y', strtotime($guia['dTraFecha'])),
            (strlen($guia['sCliNroIdentidad'] == 8) ? '1' : '6'), //DNI=1;6=RUC
            $guia['sCliNroIdentidad'],
            ''
        );

        require_once 'view/webforms/PDF/guiaremisiontransportista.php';
    }

    public function getPuntoPartida()
    {
        $puntoPartida = $this->guiaremision_model->getPuntoPartidaRemitente($_REQUEST['sReDocumento']);
        echo json_encode($puntoPartida);
    }

    public function getPuntoLlegada()
    {
        $puntoPartida = $this->guiaremision_model->getPuntoLlegadaDestinatario($_REQUEST['sCliNroIdentidad']);
        echo json_encode($puntoPartida);
    }

    public function obtenerGuiaRT()
    {
        $guias = $this->guiaremision_model->ListarDateToArray($_POST['fechaInicio'], $_POST['fechaFin']);
        echo json_encode(array('guias' => $guias, 'ruc' => $_SESSION['usu_enterpriseRuc']));
    }

    public function actualizarEstadoGRTPorId()
    {
        $row = $this->guiaremision_model->actualizarEstadoPorId($_REQUEST['Guiaremisiontransportista_Id'], $_REQUEST['Estado']);
        echo $row;
    }
    
    // TODO: inversiones AG
    public function Cambio() {
        $val = $this->documento_model->FilterSerie($_POST['idSerie']);
        echo json_encode($val);
    }
    // TODO: FIN inversiones AG
    
    public function verificarEstadoColibri() {
        $rucJson = $_POST['rucJson'];
        $sTraSerie = $_POST['sTraSerie'];
        $sTraNumero = $_POST['sTraNumero'];

        $url = "https://colibri2.fmsac.com/comprobante";

        // Hacer la solicitud a colibri
        $request = new RequestServices();
        $request->url = $url . '/' . $rucJson . '/' . $sTraSerie . '/' . $sTraNumero;
        
        $result = $request->servicePost();
        echo $result;
        
    }
    
    function VerObservaciones() {
        $ruc = trim($_REQUEST['ruc']);
        $serie = trim($_REQUEST['serie']);
        $numero = trim($_REQUEST['numero']);

        $url = "https://colibri2.fmsac.com/mensajescomprobantes.php?ruc=" . $ruc . "&serie=" . $serie . "&numero=" . $numero;
        
        $request = new RequestServices();
        $request->url = $url;

        $result = $request->serviceGET();
        echo $result;
        
    }
}
