<?php

require_once 'model/ingreso.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';

require_once 'model/enterprise.model.php';

class IngresoController {
    public $ingreso_model;
    public $parametro_model;
    public $enterprise_model;

    public function __construct() {
        $this->ingreso_model = new IngresoModel();
        $this->parametro_model = new ParametroModel();
        $this->enterprise_model = new EnterpriseInfoModel();
    }

    public function Index() {
        $fechaIncio = isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio']))
            : date('Y-m-d', strtotime('-1 day', strtotime(date('d-m-Y'))));
        $fechaFin = isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin']))
            : date('Y-m-d', strtotime(date('d-m-Y')));

        $ingresos = $this->ingreso_model->ListarxDate($fechaIncio, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();

        require_once 'view/header.php';
        require_once 'view/webforms/wfaingreso.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarIngreso() {
        $companies = $this->enterprise_model->Listar();
        require_once 'view/webforms/wfaingresoa.php';
    }

    public function FrmEditarIngreso() {
        $companies = $this->enterprise_model->Listar();
        $ingreso = $this->ingreso_model->Buscar($_POST['Ingreso_Id']);
        foreach ($ingreso as $r) {
            require_once 'view/webforms/wfaingresoa.php';
        }
    }

    public function ObtenerDescuentoFijos() {
        $descuentos = $this->ingreso_model->ObtenerDescuentoFijos();
        echo json_encode($descuentos);
    }

    public function GuardarIngreso() {
        $data = [
            'Ingreso_Id' => $_POST['Ingreso_Id'],
            'dIngFechaInicio' => date('Y-m-d', strtotime($_POST['dIngFechaInicio'])),
            'dIngFechaFin' => date('Y-m-d', strtotime($_POST['dIngFechaFin'])),
            'nIngCargaFinal' => $_POST['nIngCargaFinal'],
            'nIngRetornos' => $_POST['nIngRetornos'],
            'nIngVentasNetas' => $_POST['nIngVentasNetas'],
            'nIngPromociones' => $_POST['nIngPromociones'],
            'nIngPermisoEfectivo' => $_POST['nIngPermisoEfectivo'],
            'nIngTotalPrevisiones' => $_POST['nIngTotalPrevisiones'], // ?
            'nIngTotalVarios' => $_POST['nIngTotalVarios'],
            'nIngTotalNeto' => $_POST['nIngTotalNeto'], // pasar doble para cheque creo
            'nIngCheque' => $_POST['nIngTotalNeto'], // para cheque
            'nIngPorcenComision' => $_POST['nIngPorcenComision'],
            'nIngPorcenRetorno' => $_POST['nIngPorcenRetorno'],
            'Usuario_Id' => $_SESSION['usu_codigo'],
            'nIngrEnterprise_Id' => $_POST['nIngrEnterprise_Id']
        ];

        $_POST['Ingreso_Id'] == 0 || $_POST['Ingreso_Id'] == '' ? $res = $this->ingreso_model->GuardarIngreso($data) : $res = $this->ingreso_model->EditarIngreso($data);

        if ($res == -99) {
            echo '<div class="alert alert-danger prod" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error!</strong>, the data was not ' . ($_POST['Ingreso_Id'] == 0 || $_POST['Ingreso_Id'] == '' ? 'saved' : 'updated') . ' correctly.
                    </div>';
        } else {
            if ($_POST['Ingreso_Id'] == 0 || $_POST['Ingreso_Id'] == '') {
                // crear detalle
                if (!empty($_POST['details'])) {
                    foreach ($_POST['details'] as $item) {
                        $this->ingreso_model->GuardarDetalle($item, $res);
                    }
                    echo '<div class="alert alert-success prod" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Successful!</strong>, the data was recorded correctly.
                    </div>';
                }
            } else {
                // eliminar detalle
                $this->ingreso_model->EliminarDetalleIngreso($_POST['Ingreso_Id']);
                // crear detalle
                if (!empty($_POST['details'])) {
                    foreach ($_POST['details'] as $item) {
                        $this->ingreso_model->GuardarDetalle($item, $res);
                    }
                    echo '<div class="alert alert-success prod" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Successful!</strong>, the data was updated correctly.
                    </div>';
                }
            }
        }

        // $men = $res == 1 ? 'recorded' : 'updated';

        // echo '<div class="alert alert-success prod" role="alert">
        //                 <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        //                 <strong>Successful!</strong>, the data was ' . $men . ' correctly.
        //             </div>';
    }

    public function VerIngreso() {
        $ingreso = $this->ingreso_model->Buscar($_POST['Ingreso_Id']);
        
        echo '<table class="table table-hover table-bordered">';

        foreach ($ingreso as $r) {

            $estado = '';
            if($r->nIngEstado == '0') {
                $estado = '<span class="label label-danger">Delete</span>';
            } else if ($r->nIngEstado == '1') {
                $estado = '<span class="label label-success">Register</span>';
            }

            echo '<tr>';
            echo '<td><strong>Start Date: </strong></td>';
            echo '<td>' . date('Y-m-d', strtotime($r->dIngFechaInicio)) . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>End Date: </strong></td>';
            echo '<td>' . date('Y-m-d', strtotime($r->dIngFechaFin)) . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Carga Final: </strong></td>';
            echo '<td> $ ' . $r->nIngCargaFinal . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Returns: </strong></td>';
            echo '<td> $ ' . $r->nIngRetornos . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Ventas netas: </strong></td>';
            echo '<td> $ ' . $r->nIngVentasNetas . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Promotions: </strong></td>';
            echo '<td> $ ' . $r->nIngPromociones . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Permiso de efectivo: </strong></td>';
            echo '<td> $ ' . $r->nIngPermisoEfectivo . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Total previsiones: </strong></td>';
            echo '<td> $ ' . $r->nIngTotalPrevisiones . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Status: </strong></td>';
            echo '<td>' . $estado . '</td>';
            echo '</tr>';

            $detalle = $this->ingreso_model->ListarDetalle($r->Ingreso_Id);
            if (count($detalle) > 0) {
                echo '<tr style="text-align: center;">';
                echo '<td colspan="2"><strong>List of discounts</strong></td>';
                echo '</tr>';

                echo '<tr>';
                echo '<td colspan="2">';
                echo '<table class="table table-bordered">';
                echo '<thead>';
                echo '<tr>';
                echo '<th>Description</th>';
                echo '<th>Amount</th>';
                echo '</tr>';
                echo '</thead>';

                echo '<tbody>';
                foreach ($detalle as $item) {
                    echo '<tr>';
                    echo '<td>' . $item->sConNombre . '</strong></td>';
                    echo '<td>' . $item->nIDMonto . '</td>';
                    echo '</tr>';
                }
                echo '</tbody>';

                echo '</table>';

                echo '</td>';
                echo '</tr>';
            }


            echo '<tr>';
            echo '<td><strong>Total descuento: </strong></td>';
            echo '<td> $ ' . $r->nIngTotalVarios . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Total neto: </strong></td>';
            echo '<td> $ ' . $r->nIngTotalNeto . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Cheque: </strong></td>';
            echo '<td> $ ' . $r->nIngCheque . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>Cheque: </strong></td>';
            echo '<td> $ ' . $r->nIngCheque . '</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>% commission: </strong></td>';
            echo '<td>' . intval($r->nIngPorcenComision) . '%</td>';
            echo '</tr>';

            echo '<tr>';
            echo '<td><strong>% returns: </strong></td>';
            echo '<td> -' . intval($r->nIngPorcenRetorno) . '%</td>';
            echo '</tr>';
        }

        echo '</table>';
    }

    public function ListarIngresosDetalleTabla() {
        echo json_encode($this->ingreso_model->ListarDetalle($_POST['Ingreso_Id']));
    }

    public function EliminarIngreso() {
        $this->ingreso_model->EliminarIngreso($_POST['Ingreso_Id']);
        echo '<script type="text/javascript">window.location="?c=Gasto&a=Index";</script>';
    }

    public function ExportarExcel() {
        $incomes = $this->ingreso_model->Buscar('0');

        require_once '/exportExcelIncome.php';
    }

    public function donwloadExcel() {
        if (isset($_GET['filename'])) {
            $filename = $_GET['filename'];

            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
            header('Content-Disposition: attachment;filename="' . $filename . '"');
            header('Cache-Control: max-age=0');
            readfile($filename);

            unlink($filename);
            exit;
        } else {

        }
    }
}