<?php

header('Access-Control-Allow-Origin: *');
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/familia.model.php';
require_once 'model/familia.entidad.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/productolote.model.php';
require_once 'model/productolote.entidad.php';
require_once 'model/precioventa.model.php';
require_once 'model/precioventa.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/vendedor.model.php';
require_once 'model/vendedor.entidad.php';
require_once 'model/cotizacion.model.php';
require_once 'model/cotizacion.entidad.php';
require_once 'model/cotizaciondetalle.model.php';
require_once 'model/cotizaciondetalle.entidad.php';
require_once 'model/ordencompra.model.php';
require_once 'model/ordencompra.entidad.php';
require_once 'model/ordencompradetalle.model.php';
require_once 'model/ordencompradetalle.entidad.php';
require_once 'controller/electronic.controller.php';

class MovimientoController extends MetodosController
{

    public $url;
    public $parametro_model;
    public $documento_model;
    public $almacen_model;
    public $tipomovimiento_model;
    public $movimiento_model;
    public $prodserv_model;
    public $familia_model;
    public $unidadmedida_model;
    public $productolote_model;
    public $movimientodetalle_model;
    public $precioventa_model;
    public $origendestino_model;
    public $cotizacion_model;
    public $cotizaciondetalle_model;
    public $vendedor_model;
    public $ordencompra_model;
    public $ordencompradetalle_model;
    public $IGV = 0;
    public $ICBPER = 0.10;
    private $electronic_controller;
    private $seguridad;

    public function __CONSTRUCT()
    {
        $this->url = 'http://colibri2.fmsac.com/baja/' . $_SESSION['usu_enterpriseRuc'];
        $this->parametro_model = new ParametroModel();
        $this->documento_model = new DocumentoModel();
        $this->almacen_model = new AlmacenModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->movimiento_model = new MovimientoModel();
        $this->prodserv_model = new ProdservModel();
        $this->familia_model = new FamiliaModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->productolote_model = new ProductoloteModel();
        $this->precioventa_model = new PrecioventaModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->electronic_controller = new ElectronicController();
        $this->vendedor_model = new VendedorModel();
        $this->cotizacion_model = new CotizacionModel();
        $this->cotizaciondetalle_model = new CotizaciondetalleModel();
        $this->ordencompra_model = new OrdenCompraModel();
        $this->ordencompradetalle_model = new OrdenCompraDetalleModel();
        $this->seguridad = new Seguridad();
        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 10) {
                $this->ICBPER = ($pa->__GET('sParValor')) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 14) {
                $this->DECIMALES = ($pa->__GET('sParValor'));
            }
        }
    }

    public function Index()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'] or $this->seguridad->validRoleName(RolesType::admin2) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->Listar();
        $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : $valor[1];
        if ($this->seguridad->validRoleName(RolesType::jefe_vendedor)) {
            $movimientos = $this->movimiento_model->ListarJefeVendedor(
                isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
                isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
                $TipoMovimiento_Id,
                $usuariocodigo
            );
        } else {
            $movimientos = $this->movimiento_model->ListarDate(
                isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
                isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
                $TipoMovimiento_Id,
                $usuariocodigo
            );
        }

        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfamovimiento.php';
        if (isset($_POST['Movimiento_Id'])) {
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            PromoverCotizacion({$_POST['Movimiento_Id']})
                        });
                  </script>";
        }
        if (isset($_POST['OrdenCompra_Id'])) {
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            PromoverOrdenCompra({$_POST['OrdenCompra_Id']})
                        });
                  </script>";
        }
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Index2()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->Listar();
        $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : $valor[1];
        $movimientos = $this->movimiento_model->ListarDate2(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
            $TipoMovimiento_Id,
            $usuariocodigo
        );

        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfamovimientoven.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarMovimiento()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $obtenerRol = $this->seguridad->roles(); // jc- 2021-12-16
        $RolVendedor = $obtenerRol[0]->RoleName; // jc- 2021-12-16
        $habilitado = 0;
        // $edicion_fecha = 0;

        switch ($_SESSION['usu_enterpriseRuc']) {
            case '20603942133':
                $habilitado = 1;
                break;
            case '20608420721':
                $habilitado = 1;
                break;
            case '20553754454':
                $habilitado = 1;
                break;
            default:
                break;
        }
        $empresas_obs = $habilitado;
        $observacion_vendedor = $habilitado = 1 ? 'onchange=asignarobs();' : '';


        if ($_SESSION['usu_enterpriseRuc'] == '20482796517') {
            $edicion_fecha = 1;
        } else {
            $edicion_fecha = 0;
        }

        $detracciones = $this->movimiento_model->ListarDetracciones();
        $oc_documento = '';

        // para el tipo moneda
        $tipo_moneda = null;
        foreach ($parametro as $p) {
            if (strpos($p->sParDescripcion, "Tipo moneda") !== false) {
                $tipo_moneda = $p;
                break;
            }
        }
        
        // TODO: para jjcancino
        if ($_SESSION['usu_enterpriseRuc'] == '20440120149' || $_SESSION['usu_enterpriseRuc'] == 20440120149) {
        // if ($_SESSION['usu_enterpriseRuc'] == '20000000001' || $_SESSION['usu_enterpriseRuc'] == 20000000001) {
            $referencialBoolean = true;
        }

        require_once 'view/webforms/wfamovimientoa.php';
    }

    public function FrmEditarMovimiento()
    {
        $this->DetruirSessiones();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $movimiento = $this->movimiento_model->Buscar($_POST['Movimiento_Id']);
        $vendedor = $this->vendedor_model->Listar();
        $detracciones = $this->movimiento_model->ListarDetracciones();
        $data = array();

        $oc_documento = '';
        if (!empty($movimiento[0]->nMovOrdenCompra_Id)) {
            $oc = $this->ordencompra_model->Buscar($movimiento[0]->nMovOrdenCompra_Id);
            $oc_documento = $oc[0]->sOCDocumento;
        }
        foreach ($movimiento as $r) :

            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) :

                $array = array(
                    "ProdServ_Id" => $detmov->__GET('ProductoLote_Id'),
                    "sProSrvNombre" => $detmov->__GET('sProSrvNombre'),
                    "lotes" => 0,
                    "sMovDetConCantidad" => $detmov->__GET('nMovDetCantidad'),
                    "Unidadmedida_Id" => $detmov->__GET('nMovDetUnidad_Id'),
                    "dMovDetConFechaVencimiento" => $this->FechaVencimiento($detmov->__GET('ProductoLote_Id')),
                    "nMovDetConPrecioUnitario" => $detmov->__GET('nMovDetPrecioUnitario'),
                    "nMovDetConSubtotal" => $detmov->__GET('nMovDetImporte'),
                );
                if (isset($_SESSION['producto_c'])) {
                    $data = $_SESSION['producto_c'];
                    array_push($data, $array);
                } else {
                    $data[] = $array;
                }
                $_SESSION['producto_c'] = $data;
            endforeach;
            require_once 'view/webforms/wfamovimientoa.php';
            echo '<script type="text/javascript">
            $(document).ready(function(){
                console.log(' . $r->__GET('nMovOrigenDestino_Id') . ');
                TipoPrvClien();
                TipoDocumentoEditar(' . $r->__GET('nMovOrigenDestino_Id') . ');
                ListarProductos();
            });
														                      </script>';
        endforeach;
    }

    public function FrmEditarClienteproveedor()
    {
        //            $obtenerUsuario= $this->usuario_model->Buscar($_POST['Usuario_Id']);
        //            foreach ($obtenerUsuario as $r):
        //                require_once 'view/webforms/wfausuarioa.php';
        //            endforeach;
    }

    public function MostrarMovimiento()
    {
        $total = 0;
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $movimiento = $this->movimiento_model->Buscar($_POST['Movimiento_Id']);
        $data = array();

        $oc_documento = '';
        if (!empty($movimiento[0]) && !empty($movimiento[0]->nMovOrdenCompra_Id)) {
            $oc = $this->ordencompra_model->Buscar($movimiento[0]->nMovOrdenCompra_Id);
            $oc_documento = $oc[0]->Documento;
        }
        echo '<table class="table table-hover table-bordered">';
        foreach ($movimiento as $r) :
            //  medio de pago
            $mediopago = '';
            switch ($r->__GET('nPagTipoPago_Id')) {
                case '1':
                    $mediopago = 'Efectivo';
                    break;
                case '2':
                    $mediopago = 'Banco-Deposito';
                    break;
                case '3':
                    $mediopago = 'Banco-Transferencia';
                    break;
                case '4':
                    $mediopago = 'Cheque';
                    break;
                case '5':
                    $mediopago = 'Letra';
                    break;
                case '6':
                    $mediopago = 'Nota de crédito';
                    break;
                case '7':
                    $mediopago = 'Comprobantes de retención';
                    break;
                case '8':
                    $mediopago = 'Detracción';
                    break;
                case '9':
                    $mediopago = 'Tarjeta de crédito';
                    break;
            }
            echo "<tr>";
            echo "<input type='hidden' name='Movimiento_Id' id='Movimiento_Id' value='" . $r->__GET('Movimiento_Id') . "'>";
            echo "<input type='hidden' name='vendedor_id' id='vendedor_id' value=''>";
            echo "<td>Fecha: </td>";
            echo "<td>" . $r->__GET('dMovFecha') . "</td>";
            echo "</tr>";
            if (!empty($r->__GET('nMovOrdenCompra_Id'))) {
                echo "<tr>";
                echo "<td>N° Orden Compra referido: </td>";
                echo "<td>$oc_documento</td>";
                echo "</tr>";
            }
            echo "<tr>";
            echo "<td>Tipo Movimiento: </td>";
            echo "<td>" . $r->__GET('sTMovNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo Pago: </td>";
            echo "<td>" . ($r->__GET('nMovTipopago') == 1 ? 'Contado' : 'Credito') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Medio Pago: </td>";
            echo "<td>" . $mediopago . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo: </td>";
            echo "<td>" . ($r->__GET('nMovTipoOrigenDestino') == 1 ? 'Proveedor' : 'Cliente') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Cliente/Proveedor:</td>";
            echo "<td>" . $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Destino:</td>";
            echo "<td>" . ($r->__GET('nMovTipodestino') == 1 ? 'Almacen' : 'Consumo') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Almacen:</td>";
            echo "<td>" . $this->AlmNombre($r->__GET('Almacen_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento:</td>";
            echo "<td>" . $this->DocNombre($r->__GET('Documento_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Nro. Documento:</td>";
            echo "<td>" . $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento referencia:</td>";
            echo "<td> <input style='width:400px; height:50px; border: none;' type='text' id='sMovDocReferencia' name='sMovDocReferencia' value='" . $r->__GET('sMovDocReferencia') . "'> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo de moneda:</td>";
            echo "<td>" . ($r->__GET('Moneda_Id') == 1 ? 'Soles' : 'Dolares') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Hora:</td>";
            echo "<td>" . date('H:i A', strtotime($r->__GET('dMovFecha_Act'))) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Vendedor:</td>";
            echo "<td> <select id='vendedor' style='width: 270px;'>";
            $vendedor = $this->vendedor_model->listarVendedorEditar($r->__GET('vendedor_id'));
            // var_dump($r->__GET('vendedor_id'));
            foreach ($vendedor as $v) :
                $vendedor_seleccionado = isset($r) ? $r->__GET('vendedor_id') == $v->vendedor_id ? 'selected' : '' : '';
                echo "<option value=" . $v->vendedor_id . " " . $vendedor_seleccionado . ">" . $v->sVenNom . "</option>";
            endforeach;
            echo "</select> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Observación:</td>";
            echo "<td> <textarea name='sMovObservacion' id='sMovObservacion' style='width:400px; height:80px; border:none;'>" . $r->__GET('sMovObservacion') . "</textarea> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Unidad</th>";
            echo "<th>Precio</th>";
            echo "<th>Sub Total</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) :
                
                $fullName = is_null($detmov->__GET('sProSrvCodigo')) ? $detmov->__GET('sProSrvNombre') : $detmov->__GET('sProSrvCodigo') . ' - ' . $detmov->__GET('sProSrvNombre');
                
                echo '<tr>';
                echo '<td>'. $fullName .'</td>';
                // echo '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
                echo '<td>' . $detmov->__GET('nMovDetCantidad') . '</td>';
                echo '<td>' . $this->UnidadNombre($detmov->__GET('nMovDetUnidad_Id')) . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetPrecioUnitario'), $this->DECIMALES, ".", ",") . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetImporte'), $this->DECIMALES, ".", ",") . '</td>';
                echo '</tr>';
            endforeach;
            echo '<tr><td style="text-align: right;" colspan="4">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nMovImporte'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="4">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nMovIGV'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="4">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nMovTotal'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }

    private function validatePromoverOC($nMovOrdenCompra_Id)
    {
        if ($nMovOrdenCompra_Id != null) {
            $datachk = array();
            $lotechk = array();
            $ocd = $this->ordencompradetalle_model->Buscar($nMovOrdenCompra_Id);
            if (isset($_SESSION['producto_c'])) {
                $data = $_SESSION['producto_c'];
                print_r($_SESSION['producto_c']);

                for ($i = 0; $i < count($data); $i++) {
                    $Almacen_Id = $_POST['Almacen_Id'];
                    $ProdServ_Id = $data[$i]['ProdServ_Id'];

                    $item = array();
                    $pl = $this->ordencompradetalle_model->BuscarLote($Almacen_Id, $ProdServ_Id);
                    $item['ProdServ_Id'] = $ProdServ_Id;
                    $item['ProductoLote_Id'] = $pl->ProductoLote_Id;
                    $item['nProLStockReal'] = $pl->nProLStockReal;
                    $item['index'] = $i;
                    $datachk[] = $item;
                    $lotechk[] = $pl->ProductoLote_Id;
                }
                print_r($datachk);
                foreach ($ocd as $ocdet) {
                    $ProdServ_Id = $ocdet->ProdServ_Id;
                    $ProductoLote_Id = $ocdet->ProductoLote_Id;
                    $cantPendiente = $ocdet->nOCDCantidadPendiente;
                    print_r($ocdet);

                    $index = array_search($ocdet->ProductoLote_Id, $lotechk) !== false;
                    if ($index) {
                        //si el item a promover es menor 1 (tiene 0 items pendientes, eliminar de sesion)
                        if ($ocdet->nOCDCantidadPendiente < 1) {
                            unset($_SESSION['producto_c'][$datachk[$index]['index']]);
                        }
                    }
                }
                print_r($_SESSION['producto_c']);
            }
        }
    }

    public function GuardarMovimiento()
    {
        $importes = json_decode($_POST['importes']);
        $nMovOrdenCompra_Id = ($_POST['nMovOrdenCompra_Id'] == '' ? NULL : $_POST['nMovOrdenCompra_Id']);
        $mov = new Movimiento();
        if ($_POST['Movimiento_Id'] != 0 ? $mov->__SET('Movimiento_Id', $_POST['Movimiento_Id']) : '');
        $mov->__SET('nMovOrdenCompra_Id', $nMovOrdenCompra_Id);
        $mov->__SET('dMovFecha', $_POST['dMovFecha']);
        $mov->__SET('nMovTipoMovimiento_Id', $_POST['Tipomovimiento_Id']);
        $mov->__SET('nMovTipopago', $_POST['nMovTipopago']);
        $mov->__SET('Almacen_Id', $_POST['Almacen_Id']);
        $mov->__SET('nMovTipoOrigenDestino', $_POST['nMovTipoOrigenDestino']);
        $mov->__SET('nMovOrigenDestino_Id', $_POST['nMovOrigenDestino_Id']);
        $mov->__SET('nMovTipodestino', $_POST['nMovTipodestino']);
        $mov->__SET('Documento_Id', $_POST['Documento_Id']);
        $mov->__SET('sMovDocumento', $_POST['sMovDocumento']);
        $mov->__SET('sMovDocReferencia', $_POST['sMovDocReferencia']);
        $mov->__SET('Moneda_Id', $_POST['Moneda_Id']);
        $mov->__SET('nMovTipoCambio', $_POST['nMovTipoCambio']);
        $mov->__SET('nMovImporte', str_replace(",", "", $_POST['dMovImporte']));
        $mov->__SET('nMovIGV', str_replace(",", "", $_POST['dMovIGV']));
        $mov->__SET('nMovTotal', str_replace(",", "", $_POST['dMovTotal']));
        $mov->__SET('nMovSaldo', str_replace(",", "", $_POST['dMovTotal']));
        $mov->__SET('nMovTotalCancelado', $_POST['nMovTipopago'] == 1 ? str_replace(",", "", $_POST['dMovTotal']) : '0');
        $mov->__SET('dMovDetraccion', $_POST['dMovDetraccion']);
        $mov->__SET('dMovPercepcion', $_POST['dMovPercepcion']);
        $mov->__SET('dMovRetencion', $_POST['dMovRetencion']);
        $mov->__SET('sMovObservacion', $_POST['sMovObservacion']);
        $mov->__SET('nMovEstado', $_POST['nMovTipopago'] == 1 ? '2' : '1');
        $mov->__SET('nMovEliminado', 0);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $mov->__SET('nMovVendedor_Id', $_POST['nMovVendedor_Id']);
        $mov->__SET('dMovICBPER', str_replace(",", "", $_POST['dMovICBPER']));
        $mov->__SET('nMovPorcentajeDetraccion', !isset($_POST['porcentaje_detraccion']) ? 0 : $_POST['porcentaje_detraccion']);
        $mov->__SET('sMovCodDetraccion', !isset($_POST['codigo_detraccion']) ? 0 : $_POST['codigo_detraccion']);

        //$this->validatePromoverOC($nMovOrdenCompra_Id);
        //die();
        // var_dump($mov);
        // die();
        $flagVR = false;

        if ($_POST['nPrimerValorReferencial'] != null) {
            $flagVR = true;
            $mov->__SET('nPrimerValorReferencial', $_POST['nPrimerValorReferencial']);
            $mov->__SET('nSegundoValorReferencial', $_POST['nSegundoValorReferencial']);
            $mov->__SET('nTercerValorReferencial', $_POST['nTercerValorReferencial']);
        }
        
        if ($_POST['Movimiento_Id'] != 0) {
            if ($flagVR) {
                $this->movimiento_model->EditarwithVR($mov);
            } else {
                $this->movimiento_model->Editar($mov);
            }
        } else {
            if ($flagVR) {
                $Movimiento_Id = $this->movimiento_model->GuardarwithVR($mov);
            } else {
                $Movimiento_Id = $this->movimiento_model->Guardar($mov);
            }
            // var_dump($Movimiento_Id);
            // die();
            // guardar despacho
            // $this->movimiento_model->crearDespacho($Movimiento_Id);
            
            $mov->__SET('Movimiento_Id', $Movimiento_Id);

            $parametro = $this->parametro_model->ListarParametros();

            if (isset($_SESSION['producto_c'])) {
                $data = $_SESSION['producto_c'];
                for ($i = 0; $i < count($data); $i++) {
                    $movdet = new Movimientodetalle();
                    $movdet->__SET('Movimiento_Id', $Movimiento_Id);
                    $movdet->__SET('TipoMovimiento_Id', $_POST['Tipomovimiento_Id']);
                    $movdet->__SET('TipoDestino', $_POST['nMovTipodestino']);
                    $movdet->__SET('ProdServ_Id', $data[$i]['ProdServ_Id']);
                    $movdet->__SET('Almacen_Id', $_POST['Almacen_Id']);

                    $multlotes = null;
                    foreach ($parametro as $r) {
                        if ($r->__GET('Parametro_Id') == 13) {
                            $multlotes = $r->__GET('sParValor');
                        }
                    }
                    if ($multlotes) {
                        $multlotes = explode('|', $multlotes);

                        if ($multlotes[1]) {
                            $movdet->__SET('Lote', $data[$i]['lotes'] != 0 ? $data[$i]['lotes'] : date('Ymdhis'));
                        } else {
                            $movdet->__SET('Lote', $data[$i]['lotes'] != 0 ? $data[$i]['lotes'] : '202001'); //un solo lote
                        }
                    }
                    $movdet->__SET('FechaVencimiento', $data[$i]['dMovDetConFechaVencimiento']); // pendiente
                    $movdet->__SET('Cantidad', $data[$i]['sMovDetConCantidad']);
                    $movdet->__SET('Unidad_Id', $data[$i]['Unidadmedida_Id']); // pendiente
                    $movdet->__SET('MonedaCompra_Id', $_POST['Moneda_Id']);
                    $movdet->__SET('PrecioLista', $data[$i]['nMovDetConPrecioUnitario']);
                    $movdet->__SET('Descuento', 0);
                    $movdet->__SET('Precio', $data[$i]['nMovDetConPrecioUnitario']);
                    $movdet->__SET('SubTotal', $data[$i]['nMovDetConSubtotal']);
                    $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                    $movdet->__SET('TipoCambio', $_POST['nMovTipoCambio']);
                    $movdet->__SET('nMovDetIncluyeIgv', 0);
                    $dMovICBPER = 0;
                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {
                        // $dMovICBPER = $this->calcularICBPER($data[$i]["nMovDetConPrecioUnitario"], $data[$i]['sMovDetConCantidad']);
                        $dMovICBPER = $this->calcularICBPER($data[$i]['sMovDetConCantidad']);
                    }

                    $movdet->__SET('dMovDetICBPER', $dMovICBPER);
                    $this->movimientodetalle_model->Guardar($movdet);
                }
            }
            // $this->documento_model->Incrementa($_POST['Documento_Id']);
        }

        // guardamos los importes que se ingresaron en el calendario, al seleccionar crédito
        if ($_POST['nMovTipopago'] == 2) { // si es al crédito
            if (!empty($importes)) { // si es que se llenó el modal
                $cantidad_importes = count($importes);
                $detraccion_f = round($_POST['dMovDetraccion'] / $cantidad_importes, 2);
                for ($j = 0; $j < $cantidad_importes; $j++) {
                    $this->movimiento_model->GuardarPago(
                        $Movimiento_Id,
                        $importes[$j]->nrocuota,
                        // number_format($importes[$j]->importe, 2, ".", ","),
                        $importes[$j]->importe - $detraccion_f,
                        $importes[$j]->fecha
                    );
                }
            } else {
                if (empty($_POST['dias_credito'])) {
                    $param = 0;
                } else {
                    $param = $_POST['dias_credito'];
                }
                $this->movimiento_model->GuardarPago(
                    $Movimiento_Id,
                    1,
                    str_replace(",", "", $_POST['dMovTotal']) - $_POST['dMovDetraccion'],
                    date('Y-m-d', strtotime($_POST['dMovFecha'] . "+ $param days"))
                );
            }
        }

        $this->DetruirSessiones();
        /* echo '<div class="alert alert-success" role="alert">
          <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
          </div>'; */

        $Documento_Id = $_POST['Documento_Id'];
        $doc = $this->documento_model->Numero($Documento_Id);

        //RESULTADO PARA RESPONSE DE GUARDARMOVIMIENTO
        /* $res = array(
          'Movimiento_Id' => $Movimiento_Id,
          'importe' => number_format($_POST['dMovTotal'],2),
          'previsualizacion' => ($_SESSION['usu_enterpriseIsFE'] && $doc->isFE),
          'enviarcomprobante' => ($_SESSION['usu_enterpriseIsFE'] && !$doc->isFE),
          'print' => '<div class="alert alert-success" role="alert">
          <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
          </div>'
          ); */

        //esta habilitado a nivel de empresa para facturacion electronica?
        if ($_SESSION['usu_enterpriseIsFE']) {
            //esta habilitado para facturacion electronica?
            if ($doc->isFE) {
                //previsualizar para enviar
                echo '<script type="text/javascript">previsualizacion(' . $Movimiento_Id . ');</script>';
                return;
            } else {

                //verifica si el documento tiene formato de impresion
                //cond: nDocTipoImprimir!=0 => Imprime
                if ($doc->nDocTipoImprimir != 0) {
                    echo "<script type='text/javascript'>enviarcomprobante($Movimiento_Id)</script>";
                }
            }
        }

        echo "<script type='text/javascript'>location.href='?c=Movimiento&a=Index';</script>";

        //echo json_encode($res);
    }

    public function TipoMovimiento()
    {
        $productos = $this->prodserv_model->Listar2();
        $tipomovimiento = $this->tipomovimiento_model->Buscar($_POST['Tipomovimiento_Id']);
        foreach ($tipomovimiento as $tv) {
            echo '<script type="text/javascript">
                        $(\'#nMovTipoOrigenDestino option[value="' . $tv->__GET('nTMovTipoOD') . '"]\').attr(\'selected\',\'selected\');
                        TipoPrvClien();
                    </script>';
        }
        if ($_POST['Tipomovimiento_Id'] == 1 || $_POST['Tipomovimiento_Id'] == 3) {
            require_once 'view/webforms/tipomovimiento/ingreso_compra.php';
        } elseif ($_POST['Tipomovimiento_Id'] == 2 || $_POST['Tipomovimiento_Id'] == 4) {
            require_once 'view/webforms/tipomovimiento/salida_venta.php';
        }
    }

    public function ListarUnidades()
    {
        $unidad = $this->unidadmedida_model->ListarUP($this->ObtenerID($_POST['ProdServ_Id']));
        $_SESSION['$unidad'] = $unidad;
        // echo "<option value=''>Seleccione unidad</option>";
        foreach ($unidad as $uni) {
            echo "<option value='" . $uni->__GET('UnidadMedida_Id') . "' data-codigosunat='" . $uni->__GET('sUndCodeSunat') . "'
                                                                         data-factconversion='" . $uni->__GET('nUndFac_Cnv') . "'
                                                                         data-alias='" . $uni->__GET('sUndAlias') . "'
                                                                         data-factor='" . $uni->__GET('nUndFac_Cnv') . "'>" .
                $uni->__GET('sUndDescripcion') .
                "</option>";
        }
    }

    public function RenderizadoClass($nProSrvExoneradoIGV)
    {
        switch ($nProSrvExoneradoIGV) {
            case 0:
                return 'style="color:black;"';
            case 1:
                return 'style="color:#cc3300;"';
            case 2:
                return 'style="color:#ffc107;"';
        }
    }
// TODO: Lista de productos
    public function ListarProductos()
    {
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {
                    // <td>
                    //     <input type='checkbox' onchange='changePreice(" . $i . ", this)' " . (isset($data[$i]['HasBonus']) ? ($data[$i]['HasBonus'] === true ? 'checked' : '') : false) . "/>
                    // </td>

                    /* echo "<tr " . $this->RenderizadoClass($data[$i]['nProSrvExoneradoIGV']) . "> 

                      <td>" . (isset($data[$i]['sProSrvNombre']) ? $data[$i]['sProSrvNombre'] : $this->ProdservdNombre($data[$i]['ProdServ_Id'])) . "</td>
                      <td>" . $data[$i]['sMovDetConCantidad'] . "</td>
                      <td>" . $this->UnidadNombre($data[$i]['Unidadmedida_Id']) . "</td>
                      <td>" . number_format($data[$i]['nMovDetConPrecioUnitario'], $this->DECIMALES) . "</td>
                      <td>" . number_format($data[$i]['nMovDetConSubtotal'], $this->DECIMALES) . "</td>
                      <td>
                      <a href=\"#\" class=\"btn btn-danger btn-flat btn-xs\" data-toggle=\"modal\" data-target=\"#eliminar_productos\" data-productoid='" . $i . "'><i class=\"fa fa-trash-o\"></i></a>
                      </td>
                      </tr>"; */
                    $max_qty = null;
                    if (!empty($_SESSION['is_oc'])) {
                        if (isset($data[$i]['max'])) {
                            $max_qty = sprintf('data-max="%s"', $data[$i]['max']);
                        } else {
                            $max_qty = sprintf('data-max="%s"', $data[$i]['sMovDetConCantidad']);
                        }
                    }
                    echo "<tr " . $this->RenderizadoClass($data[$i]['nProSrvExoneradoIGV']) . " id='produpd-$i'> 
                        <td style='display: none;'>" .  $data[$i]['ProdServ_Id'] . "</td>
                        <td>" . (isset($data[$i]['sProSrvNombre']) ? $data[$i]['sProSrvNombre'] : $this->ProdservdNombre($data[$i]['ProdServ_Id'])) . "</td>
                        <td><input type='text' $max_qty value='" . $data[$i]['sMovDetConCantidad'] . "' class='form-control inp-cantidad' onchange='movActualizarProducto($i)'/></td>
                        <td>" . $this->UnidadNombre($data[$i]['Unidadmedida_Id']) . "</td>
                        <td><input type='text' value='" . number_format($data[$i]['nMovDetConPrecioUnitario'], $this->DECIMALES) . "' onchange='movActualizarProducto($i)' class='form-control inp-precio'/></td>
                        <td>" . number_format($data[$i]['nMovDetConSubtotal'], $this->DECIMALES) . "</td>
                        <td>
                            <a href=\"#\" class=\"btn btn-danger btn-flat btn-xs\" data-toggle=\"modal\" data-target=\"#eliminar_productos\" data-productoid='" . $i . "'><i class=\"fa fa-trash-o\"></i></a>
                        </td>
                    </tr>";
                }
            } else {
                echo "<tr> 
                        <td colspan='7'>No hay datos</td>
                      </tr>";
            }
        } else {
            echo "<tr>
                        <td colspan='7'>No hay datos</td>
                      </tr>";
        }
    }

    public function validardetallemovimiento()
    {
        if (isset($_SESSION['producto_c'])) {
            echo count($_SESSION['producto_c']);
            // echo 0;
        } else {
            echo 0;
        }
    }

    public function ListarLoteProducto()
    {
        $data = $this->productolote_model->Listar(!empty($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : 0);
        if (count($data) > 0) {
            foreach ($data as $l) {
                echo "<tr>
                            <th>
                                <input type='radio' name='lotes' id='lotes' data-stock='" . $l->__GET("Stock") . "' value='" . $l->__GET("Lote") . "' onclick='enviarPrecioCosto(" . $l->__GET("PrecioCosto") . ");' data-preciocosto='" . $l->__GET("PrecioCosto") . "' data-almacen='" . $l->__GET("Almacen_Id") . "' checked>
                                <input type='radio' style='visibility:hidden;' name='lotes1' id='lotes' value='" . $l->__GET("Stock") . "'>
                            </th>
                            <td>" . $l->__GET("Almacen") . "</td>
                            <td>" . $l->__GET("Lote") . "</td>
                            <td>" . number_format($l->__GET("Stock"), $this->DECIMALES) . "</td>
                            <td>" . $l->__GET("Unidad") . "</td>";
                            if ($_SESSION['usu_role'] != 22) {
                                echo "<td>" . number_format($l->__GET("PrecioCosto"), $this->DECIMALES) . "</td>";
                            }
                            echo "</tr>";
            }
        } else {
            echo "<tr>
                    <td colspan='7'>
                        No hay datos
                    </td>
                  </tr>";
        }
    }



    public function NombreAlmacen($Almacen_Id)
    {
        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sAlmNombre');
        }
    }

    public function ActualizarProductoC()
    {
        $data = array();
        if (isset($_POST['index'])) {

            $index = $_POST['index'];
            $cantidad = $_POST['cantidad'];
            $precio = $_POST['precio'];
            $max = $_POST['max'];

            $_SESSION['producto_c'][$index]['sMovDetConCantidad'] = $cantidad;
            $_SESSION['producto_c'][$index]['max'] = $max;
            $_SESSION['producto_c'][$index]['nMovDetConPrecioUnitario'] = $precio;
            $_SESSION['producto_c'][$index]['nMovDetConSubtotal'] = $precio * $cantidad;

            die('1');
        }
    }

    private function findIndexProductoC($array, $producto, $precio)
    {
        if (!empty($array)) {
            $i = 0;
            foreach ($array as $x) {
                if ($x['ProdServ_Id'] == $producto && $x['nMovDetConPrecioUnitario'] == $precio) {
                    return $i;
                }
                $i++;
            }
        }
        return false;
    }
    public function AgregarProductoC()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'] / $this->IGV;
        } else {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sMovDetConCantidad" => $_POST['sMovDetConCantidad'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dMovDetConFechaVencimiento" => isset($_POST['dMovDetConFechaVencimiento']) ? $_POST['dMovDetConFechaVencimiento'] : date('d-m-Y'),
            "nMovDetConPrecioUnitario" => $nMovDetConPrecioUnitario,
            "nMovDetConSubtotal" => $nMovDetConPrecioUnitario * $_POST['sMovDetConCantidad'],
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $findIndex = $this->findIndexProductoC($_SESSION['producto_c'], $_POST['ProdServ_Id'], $nMovDetConPrecioUnitario);
            if ($findIndex !== false) {
                $_SESSION['producto_c'][$findIndex]['sMovDetConCantidad'] = $_SESSION['producto_c'][$findIndex]['sMovDetConCantidad'] + $_POST['sMovDetConCantidad'];
                $_SESSION['producto_c'][$findIndex]['nMovDetConSubtotal'] = $_SESSION['producto_c'][$findIndex]['nMovDetConPrecioUnitario'] * $_SESSION['producto_c'][$findIndex]['sMovDetConCantidad'];
                $data = $_SESSION['producto_c'];
            } else {
                $data = $_SESSION['producto_c'];
                array_push($data, $array);
            }
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        echo '<div class="alert alert-success prod" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito!</strong>, Los Datos fueron agregados correctamente.
                  </div>';
    }

    // TODO: eliminar del detalle
    public function EliminarProductoLista()
    {
        $array = array();
        $data = $_SESSION['producto_c'];
        $cod_prod = null;
        for ($i = 0; $i < count($data); $i++) {
            if ($i != $_POST['Codigo_Producto']) {
                $array[] = array(
                    "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : $data[$i]['ProdServ_Id'],
                    "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sMovDetConCantidad" => $data[$i]['sMovDetConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dMovDetConFechaVencimiento" => $data[$i]['dMovDetConFechaVencimiento'],
                    "nMovDetConPrecioUnitario" => $data[$i]['nMovDetConPrecioUnitario'],
                    "nMovDetConSubtotal" => $data[$i]['nMovDetConSubtotal'],
                    "nProSrvExoneradoIGV" => $data[$i]['nProSrvExoneradoIGV'],
                    "nProSrvICBPer" => $data[$i]['nProSrvICBPer'],
                );
            } else {
                $cod_prod = $data[$i]['ProdServ_Id'];
            }
        }
        $_SESSION['producto_c'] = $array;
        // echo "Datos eliminados";
        // if (!empty($cod_prod)) {
        //     echo sprintf('<script>stocker.delPL("%s");</script>', $cod_prod);
        // }
    }

    public function ModificarPrecioProductoLista()
    {
        // echo $_POST['checked'] === 'true' ? 1 : 0;
        $array = array();
        $data = $_SESSION['producto_c'];
        for ($i = 0; $i < count($data); $i++) {
            if ($i == $_POST['Codigo_Producto']) {
                $array[] = array(
                    "HasBonus" => true,
                    "ProdServ_Id" => $data[$i]['ProdServ_Id'],
                    "lotes" => $data[$i]['lotes'],
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sMovDetConCantidad" => $data[$i]['sMovDetConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dMovDetConFechaVencimiento" => $data[$i]['dMovDetConFechaVencimiento'],
                    "nMovDetConPrecioUnitario" => $_POST['checked'] === 'true' ? 0 : $data[$i]['after_nMovDetConPrecioUnitario'],
                    "nMovDetConSubtotal" => $_POST['checked'] === 'true' ? 0.01 : $data[$i]['after_nMovDetConSubtotal'],
                    "nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? 1 : $data[$i]['after_nProSrvExoneradoIGV'], // $data[$i]['nProSrvExoneradoIGV']
                    "after_nMovDetConPrecioUnitario" => $_POST['checked'] === 'true' ? $data[$i]['nMovDetConPrecioUnitario'] : 0,
                    "after_nMovDetConSubtotal" => $_POST['checked'] === 'true' ? $data[$i]['nMovDetConSubtotal'] : 0,
                    "after_nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? $data[$i]['nProSrvExoneradoIGV'] : 0, // $data[$i]['nProSrvExoneradoIGV']
                );
            } else {
                $array[] = $data[$i];
            }
        }
        $_SESSION['producto_c'] = $array;
    }

    public function EliminarProductos()
    {
        $pro = new Prodserv();
        $pro->__SET('ProdServ_Id', $_POST['idProdServ']);
        $this->prodserv_model->Eliminar($pro);
        echo '<script type="text/javascript">window.location="?c=Productos&a=Index";</script>';
    }

    public function AnularMovimiento()
    {
        $notificacion = '';
        // $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Advertencia!', 'No se pudo anular el movimiento, inténtelo en otro momento.');

        // isset($_REQUEST['estadoSunat']) && ($_REQUEST['estadoSunat'] == 1 || $_REQUEST['estadoSunat'] == 2 || $_REQUEST['estadoSunat'] == 3)
        if (isset($_REQUEST['estadoSunat']) && ($_REQUEST['estadoSunat'] == 1 || $_REQUEST['estadoSunat'] == 2 || $_REQUEST['estadoSunat'] == 3)) {
            $movimiento = $this->movimiento_model->Buscar($_REQUEST['IdMovimiento']);
            foreach ($movimiento as $r) {
                //echo $r->__GET('nMovEstadoSunat') . '<br>';

                if ($r->__GET('nMovEstadoSunat') == '1' || $r->__GET('nMovEstadoSunat') == '2' || $r->__GET('nMovEstadoSunat') == '3') {
                    $request = new RequestServices();
                    $request->url = $this->url . '/' . $r->__GET('sDocNombreCorto') . '/' . $r->__GET('sMovDocumento');
                    //var_dump($request, 'solicitud');
                    $request->parameters = [];
                    $result = $request->serviceGET();
                    //1 => Aceptado, 6 => PendienteBaja, 7 => Pendiente reenvio de baja
                    //5 => Anulado
                    $result = json_decode($result, true);
                    //echo var_dump($result);
                    // exit;
                    if ($result['codigo'] == '1') {
                        $this->movimiento_model->updaeteEstado_sunat($_REQUEST['IdMovimiento'], 5);
                        $resultado =  sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Correcto!', 'El comprobante fue anulado correctamente');
                    } else if ($result['codigo'] == '2') {
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Correcto!', 'El documento ya fue dado de baja, se actualizará el estado sunat en un momento');
                    } else if ($result['codigo'] == '0') {
                        $notificacion = 'warning|Aviso!|Tiene documentos pendientes de validación / baja';
                        $this->seguridad->actualizarNotificaciones($notificacion, $_SESSION['usu_enterpriseId']);
                        $this->movimiento_model->updaeteEstado($_REQUEST['IdMovimiento'], 6);
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'El comprobante ya fue a enviado a darse de baja, consulte su estado luego.');
                    } else if ($result['codigo'] == '6') {
                        $notificacion = 'warning|Aviso!|Tiene documentos pendientes de validación / baja';
                        $this->seguridad->actualizarNotificaciones($notificacion, $_SESSION['usu_enterpriseId']);
                        // $this->movimiento_model->updaeteEstado($_REQUEST['IdMovimiento'], 6);
                        
                        $this->movimiento_model->updaeteEstado_sunat($_REQUEST['IdMovimiento'], 6); // pendiente de baja
                        
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'El comprobante esta pendiente de baja');
                    } else if ($result['codigo'] == '7') {
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'El comprobante esta pendiente de reenvio de baja');
                    } else if ($result['codigo'] == '5') {
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'El comprobante ya fue anulado');
                    } else { // para el 99 que se manda hasta ahora 5/04/2024
                        //No estan validados por sunat => 0 y 0
                        // $this->movimiento_model->updaeteEstado_sunat($_REQUEST['IdMovimiento'], 0);
                        // $this->movimiento_model->updateMovEstado($_REQUEST['IdMovimiento'], 0);
                        // $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'No se pudo anular el comprobante, inténtelo en otro momento.');
                        
                        $this->movimiento_model->updaeteEstado_sunat($_REQUEST['IdMovimiento'], 6); // pendiente de baja
                        $this->movimiento_model->updateMovEstado($_REQUEST['IdMovimiento'], 0);
                        $resultado = sprintf('<script>MostrarAlerta("%s","%s");</script>', 'Aviso!', 'No se pudo anular el comprobante, inténtelo en otro momento.');
                    }

                    // if ($result === '1') {
                    //     $this->movimiento_model->updaeteEstado($_REQUEST['IdMovimiento'], 5);
                    // } else {
                    //     $this->movimiento_model->updaeteEstado($_REQUEST['IdMovimiento'], 1);
                    //     echo '<script type="text/javascript">alert("No se pudo anular el movimiento, inténtelo en otro momento.")</script>';
                    // }
                }
            }
        }
        $mov = new Movimiento();
        $mov->__SET('Movimiento_Id', $_POST['IdMovimiento']);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $this->movimiento_model->Eliminar($mov);
        // echo $resultado;
        echo '<script type="text/javascript">window.location="?c=Movimiento&a=Index";</script>';
    }

    public function ObtenerID($ProdServ_Id)
    {
        foreach ($this->prodserv_model->Buscar($ProdServ_Id) as $p) {
            return $p->__GET('nProSrvUnidad_Id');
        }
    }

    public function CalcularImpTotIGV()
    {
        $dMovICBPER = 0;
        // $importe = 0;
        $dMovImporte = 0;
        $dMovIGV = 0;

        $total = 0;
        $IGV = 0;
        $isItem = 'false';
        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = 0.18;
                }
                /* else {
                  $IGV = 1.18;
                  } */
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {

                    $dMovImporte += $data[$i]['nMovDetConSubtotal'];

                    if (isset($data[$i]['nProSrvExoneradoIGV']) && $data[$i]['nProSrvExoneradoIGV'] == 0) {

                        $dMovIGV += $data[$i]['nMovDetConSubtotal'] * $IGV;
                    } else {

                        $dMovIGV += 0;
                    }

                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {
                        $dMovICBPER += $this->calcularICBPER($data[$i]['sMovDetConCantidad']);
                    }
                }
                $isItem = 'true';
            } else {
                $isItem = 'false';
            }
        }


        $dMovIGV = isset($_SESSION['usu_enterpriseExoneratedIGV']) && $_SESSION['usu_enterpriseExoneratedIGV'] == 1 ? 0 : $dMovIGV;

        /* echo "<script type='text/javascript'>
          document.getElementById('dMovImporte').value = '" . number_format($dMovImporte, 2, ".", ",") . "';
          document.getElementById('dMovIGV').value = '" . number_format($dMovIGV, 2, ".", ",") . "';
          document.getElementById('dMovICBPER').value = '" . number_format($dMovICBPER, 2, ".", ",") . "';
          document.getElementById('dMovTotal').value = '" . number_format(($dMovImporte + $dMovIGV + $dMovICBPER), 2, ".", ",") . "';
          document.getElementById('Tipomovimiento_Id').disabled = $isItem;
          document.getElementById('nMovTipodestino').disabled = $isItem;
          </script>"; */
        $pre_dmovimporte = $dMovImporte + $dMovIGV + $dMovICBPER;

        echo "<script type='text/javascript'>
                document.getElementById('dMovImporte').value = '" . number_format($dMovImporte, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dMovIGV').value = '" . number_format($dMovIGV, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dMovICBPER').value = '" . number_format($dMovICBPER, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dMovTotal').value = '" . number_format($pre_dmovimporte, $this->DECIMALES, ".", ",") . "';
                document.getElementById('Tipomovimiento_Id').disabled = $isItem;
                document.getElementById('nMovTipodestino').disabled = $isItem;
            </script>";
    }

    public function CalcularImpTotIGV_venta()
    {
        $importe = 0;
        $total = 0;
        $IGV = 1;

        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = $this->IGV;
                }
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            for ($i = 0; $i < count($data); $i++) {
                $importe = $importe + $data[$i]['nMovDetConSubtotal'];
            }
        }
        echo "<script type='text/javascript'>
                    document.getElementById('dPedImporte').value = '" . number_format($importe, $this->DECIMALES) . "';
                    document.getElementById('dPedIGV').value = '" . number_format(($importe * $IGV - $importe), $this->DECIMALES) . "';
                    document.getElementById('dPedTotal').value = '" . number_format(($importe * $IGV), $this->DECIMALES) . "';
                </script>";
    }

    public function UnidadNombre($Unidadmedida_Id)
    {
        $dato = $this->unidadmedida_model->Buscar($Unidadmedida_Id);
        foreach ($dato as $d) {
            return $d->__GET('sUndAlias');
        }
    }

    public function ProdservdNombre($ProdServ_Id)
    {
        $data = $this->prodserv_model->Buscar($ProdServ_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sProSrvNombre');
        }
    }

    public function DocNombre($Documento_Id)
    {
        $data = $this->documento_model->Buscar($Documento_Id);
        foreach ($data as $doc) {
            return $doc->__GET('sDocNombre');
        }
    }

    public function AlmNombre($Almacen_Id)
    {

        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $alm) {
            return $alm->__GET('sAlmNombre');
        }
    }

    public function DetruirSessiones()
    {
        unset($_SESSION['producto_c']);
        unset($_SESSION['is_oc']);
    }

    public function PDFMovimiento()
    {
        $movimiento = $this->movimiento_model->Buscar($_POST['PDFMmovimiento_Id']);
        $detalle_movimiento = $this->Detalles($movimiento[0]->Movimiento_Id);
        require_once 'view/webforms/PDF/movimiento.php';
    }

    public function act_obs_docref()
    {

        $mov = new Movimiento();
        if ($_POST['Movimiento_Id'] != 0 ? $mov->__SET('Movimiento_Id', $_POST['Movimiento_Id']) : '');
        $mov->__SET('sMovDocReferencia', $_POST['sMovDocReferencia']);
        $mov->__SET('sMovObservacion', $_POST['sMovObservacion']);
        $mov->__SET('nMovVendedor_Id', $_POST['vendedor']);
        if ($_POST['Movimiento_Id'] != 0) {
            $this->movimiento_model->act_obs_docref($mov);
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }

    public function Detalles($Movimiento_Id)
    {
        $detalle_movimiento = $this->movimientodetalle_model->Buscar($Movimiento_Id);
        $result = '';
        foreach ($detalle_movimiento as $detmov) :
            $result .= '<tr>';
            $result .= '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
            $result .= '<td>' . $detmov->__GET('nMovDetCantidad') . '</td>';
            $result .= '<td>' . $this->UnidadNombre($detmov->__GET('nMovDetUnidad_Id')) . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nMovDetPrecioUnitario'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nMovDetImporte'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '</tr>';
        endforeach;
        return $result;
    }

    public function ImprimirTicket()
    {
        $parametro = $_GET['Movimiento'];
        //$comando = 'start /d "C:\STC R2\" start "" "C:\STC R2\STCCFD.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando = 'start /d "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\" start "" "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\PrintVale.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando_escapado = escapeshellcmd($comando);
        exec($comando_escapado, $resultadoSalida, $ejecucion);
        if ($ejecucion > 0) {
            echo 'Ocurrio un problema en la impresion.';
        } else {
            echo 'La impresion se realizo correctamente gracias.';
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }

    public function Previsualizacion()
    {
        $movimiento = $this->movimiento_model->Buscar($_POST['Movimiento_Id']);
        $data = array();
        $mov = "<table class='table table-hover table-bordered'>";
        foreach ($movimiento as $r) :
            $mov .= "<tr>";
            $mov .= "<td>Fecha: <input type='hidden' id='nDocTipoImprimir' name='nDocTipoImprimir' value='" . $r->__GET('nDocTipoImprimir') . "'></td>";
            $mov .= "<td>" . $r->__GET('dMovFecha') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Hora: </td>";
            $mov .= "<td>" . date('h:i a', strtotime($r->__GET('dMovFecha_Act'))) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo Movimiento: </td>";
            $mov .= "<td>" . $r->__GET('sTMovNombre') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo Pago: </td>";
            $mov .= "<td>" . ($r->__GET('nMovTipopago') == 1 ? 'Contado' : 'Credito') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo: </td>";
            $mov .= "<td>" . ($r->__GET('nMovTipoOrigenDestino') == 1 ? 'Proveedor' : 'Cliente') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Cliente/Proveedor:</td>";
            $mov .= "<td>" . $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Dirección:</td>";
            $mov .= "<td>" . $this->DireccionClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>RUC/DNI:</td>";
            $mov .= "<td>" . $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Ubigeo:</td>";
            $mov .= "<td>" . $this->UbigeoNombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Destino:</td>";
            $mov .= "<td>" . ($r->__GET('nMovTipodestino') == 1 ? 'Almacen' : 'Consumo') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Almacen:</td>";
            $mov .= "<td>" . $this->AlmNombre($r->__GET('Almacen_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Documento:</td>";
            $mov .= "<td>" . $this->DocNombre($r->__GET('Documento_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Nro. Documento:</td>";
            $mov .= "<td>" . $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Documento referencia:</td>";
            $mov .= "<td>" . $r->__GET('sMovDocReferencia') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo de moneda:</td>";
            $mov .= "<td>" . ($r->__GET('Moneda_Id') == 1 ? 'Soles' : 'Dolares') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Observación:</td>";
            $mov .= "<td>" . $r->__GET('sMovObservacion') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td colspan='2'>";
            $mov .= "<table class='table table-hover table-bordered'>";
            $mov .= "<thead>";
            $mov .= "<tr>";
            $mov .= "<th>Producto</th>";
            $mov .= "<th>Cantidad</th>";
            $mov .= "<th>Unidad</th>";
            $mov .= "<th>Precio</th>";
            $mov .= "<th>Sub Total</th>";
            $mov .= "</tr>";
            $mov .= "</thead>";
            $mov .= "<tbody>";
            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) :
                $mov .= '<tr>';
                $mov .= '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
                $mov .= '<td>' . $detmov->__GET('nMovDetCantidad') . '</td>';
                $mov .= '<td>' . $this->UnidadNombre($detmov->__GET('nMovDetUnidad_Id')) . '</td>';
                $mov .= '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetPrecioUnitario'), $this->DECIMALES, ".", ".") . '</td>';
                $mov .= '<td style="text-align: right;">' . number_format($detmov->__GET('nMovDetImporte'), $this->DECIMALES, ".", ".") . '</td>';
                $mov .= '</tr>';
            endforeach;
            $mov .= '<tr><td style="text-align: right;" colspan="4">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nMovImporte'), $this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '<tr><td style="text-align: right;" colspan="4">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nMovIGV'), $this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '<tr><td style="text-align: right;" colspan="4">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nMovTotal'), $this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '</tbody>';
            $mov .= '</table>';
            $mov .= '</td>';
            $mov .= '</tr>';
            $mov .= "</table>";
        endforeach;
        $fecha_emision = $r->__GET('dMovFecha');
        $print_force = null;
        $Movimiento_Id = $_POST['Movimiento_Id'];
        $importe = number_format($r->__GET('nMovTotal'), $this->DECIMALES);

        $pagoenefectivo = (bool) $this->parametro_model->obtenerParametro(17)['sParValor'];
        $Documento_Id = $r->__GET('Documento_Id');
        $doc = $this->documento_model->Numero($Documento_Id);

        if ($_SESSION['usu_enterpriseIsFE'] && $doc->isFE && $pagoenefectivo && $r->__GET('nMovTipopago') == 1) {
            $print_force = sprintf('forcePago("%s","%s")', $Movimiento_Id, $importe);
        }

        require_once 'view/webforms/wfamovimientov.php';
    }

    private function enviarcomprobanteautomatico($Movimiento_Id)
    {
        return $this->electronic_controller->Transaction($Movimiento_Id);
    }

    public function enviarcomprobante()
    {
        echo $this->electronic_controller->Transaction($_REQUEST['Movimiento_Id']);
    }

    public function enviarcomprobante_gr()
    {
        $variablea = $this->electronic_controller->Transaction($_REQUEST['Movimiento_Id']);
        echo '<div id="result_colibri" style="display:none">' . $variablea . '</div>';
    }

    public function comprobante()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['Movimiento_Id']);
        
        $r = $movimiento[0];
        
        $detalle = $this->movimientodetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[15]->__GET('sParValor'));
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];
        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/comprobanteelectronico.php';
    }

    public function comprobante2()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['Movimiento_Id']);

        $r = $movimiento[0];
        $detalle = $this->movimientodetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[15]->__GET('sParValor'));
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/comprobanteelectronico2.php';
    }

    public function comprobantePDF()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['Movimiento_Id']);

        //print_r($movimiento);print_r($_SESSION);

        $r = $movimiento[0];
        $detalle_movimiento = $this->movimientodetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
        // var_dump($detalle_movimiento[0]['nProSrvExoneradoIGV']);
        $observacion = $r->__GET('sMovObservacion');
        $detraccion = $this->parametro_model->obtenerParametro(6)['sParValor'];
        $cuenta_bn = $_SESSION['usu_enterpriseCTADetraccion'];
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[16]->__GET('sParValor'));
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];
        $pagos_movimiento = $this->movimiento_model->BuscarPagos($r->__GET('Movimiento_Id'));

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/ecomprobante2.php';
    }

    public function getByDocumento()
    {
        $movimiento = $this->movimiento_model->getByDocumento($_REQUEST['documento']);
        if ($movimiento) {
            $movimiento['detalle'] = $this->movimientodetalle_model->getByMovimientoId($movimiento['Movimiento_Id']);
        }
        echo json_encode($movimiento);
    }

    public function getDocumentosBajaValidacion()
    {
        $movimiento = $this->movimiento_model->getMovimientosBaja();
        if ($movimiento) {
            echo json_encode($movimiento);
        } else {
            echo '[]';
        }
    }

    /**
     * Registrar array de movimientos function
     *
     * @return void
     */
    public function GuardarMovimientoAll()
    {
        $movmientosList = json_decode($_REQUEST['movimientos']);
        $index = 0;
        foreach ($movmientosList as $item) {
            $documento = $this->documento_model->Numero($item->Documento_Id);
            if ($documento->nDocNomAutomatico == 0) {
                http_response_code(StatusCodes::HTTP_PRECONDITION_FAILED);
                echo json_encode(["message" => "Se presento un problema al obtener el documento"]);
                exit();
            }
            if ($this->validar_documento($item)) {
                $OrigenDestino_Id = $this->registrar_cliente($item);
                if ($OrigenDestino_Id != null) {
                    $movmientosList[$index]->status = 'CLIENT_REGISTERED';
                } else {
                    $origenDestino = $this->origendestino_model->getByDocument($item->RUC_DNI);
                    $OrigenDestino_Id = $origenDestino->OrigenDestino_Id;
                }
                $mov = new Movimiento();
                $mov->__SET('dMovFecha', $item->dMovFecha);
                $mov->__SET('nMovTipoMovimiento_Id', $item->Tipomovimiento_Id);
                $mov->__SET('nMovTipopago', $item->nMovTipopago);
                $mov->__SET('Almacen_Id', $item->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $item->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $OrigenDestino_Id); // cliente
                $mov->__SET('nMovTipodestino', $item->nMovTipodestino);
                $mov->__SET('Documento_Id', $item->Documento_Id);
                $mov->__SET('sMovDocumento', $documento->sDocSiguiente);
                $mov->__SET('sMovDocReferencia', "");
                $mov->__SET('Moneda_Id', $item->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $item->nMovTipoCambio);
                $mov->__SET('nMovImporte', str_replace(",", "", $item->dMovImporte));
                $mov->__SET('nMovIGV', str_replace(",", "", $item->dMovIGV));
                $mov->__SET('nMovTotal', str_replace(",", "", $item->dMovTotal));
                $mov->__SET('nMovSaldo', str_replace(",", "", $item->dMovTotal));
                $mov->__SET('nMovTotalCancelado', $item->nMovTipopago == 1 ? str_replace(",", "", $item->dMovTotal) : '0');
                $mov->__SET('dMovDetraccion', $item->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $item->dMovPercepcion);
                $mov->__SET('dMovRetencion', $item->dMovRetencion);
                $mov->__SET('sMovObservacion', $item->sMovObservacion);
                $mov->__SET('nMovEstado', $item->nMovTipopago == 1 ? '2' : '1');
                $mov->__SET('nMovEliminado', 0);
                $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                $mov->__SET('nMovVendedor_Id', $item->nMovVendedor_Id);
                $mov->__SET('dMovICBPER', 0);
                $mov->__SET('nMovPorcentajeDetraccion', 0);
                $mov->__SET('sMovCodDetraccion', 0);

                $Movimiento_Id = $this->movimiento_model->Guardar($mov);
                if ($Movimiento_Id > 0) {
                    $movmientosList[$index]->id = $Movimiento_Id;
                    if ($movmientosList[$index]->status == "") {
                        $movmientosList[$index]->status = 'MOVEMENT_REGISTERED';
                    }
                    foreach ($item->deail as $prod) {
                        $movdet = new Movimientodetalle();
                        $movdet->__SET('Movimiento_Id', $Movimiento_Id);
                        $movdet->__SET('TipoMovimiento_Id', $prod->TipoMovimiento_Id);
                        $movdet->__SET('TipoDestino', $prod->TipoDestino);
                        $movdet->__SET('ProdServ_Id', $prod->ProdServ_Id);
                        $movdet->__SET('Almacen_Id', $prod->Almacen_Id);
                        // $movdet->__SET('Lote', $prod->Lote != 0 ? $prod->Lote : date('Ymdhis'));
                        $movdet->__SET('Lote', $prod->Lote != 0 ? $prod->Lote : '202001'); //un solo lote
                        $movdet->__SET('FechaVencimiento', ''); // pendiente
                        $movdet->__SET('Cantidad', $prod->Cantidad);
                        $movdet->__SET('Unidad_Id', $prod->Unidad_Id); // default UND = 2
                        $movdet->__SET('MonedaCompra_Id', $prod->MonedaCompra_Id);
                        $movdet->__SET('PrecioLista', $prod->PrecioLista);
                        $movdet->__SET('Descuento', 0);
                        $movdet->__SET('Precio', $prod->Precio);
                        $movdet->__SET('SubTotal', $prod->SubTotal);
                        $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                        $movdet->__SET('TipoCambio', $prod->TipoCambio);
                        $movdet->__SET('nMovDetIncluyeIgv', $prod->nMovDetIncluyeIgv);
                        $this->movimientodetalle_model->Guardar($movdet);
                    }
                    // $this->documento_model->Incrementa($item->Documento_Id);
                    // guardamos los importes que se ingresaron en el calendario, al seleccionar crédito

                    if ($item->nMovTipopago == 2) { // si es al crédito
                        $param = $item->DIAS_CREDITO;
                        $this->movimiento_model->GuardarPago(
                            $Movimiento_Id,
                            1,
                            str_replace(",", "", $item->dMovTotal),
                            date('Y-m-d', strtotime($item->dMovFecha . "+ $param days"))
                        );
                    }
                } else {
                    if ($movmientosList[$index]->status == "") {
                        $movmientosList[$index]->status = 'MOVEMENT_NOT_REGISTERED';
                    }
                }
            } else {
                $movmientosList[$index]->status = 'INVALID_DOCUMENT';
            }
            $index++;
        }
        echo json_encode($movmientosList);
    }

    /**
     * Registrar cliente por movimientos function
     *
     * @param [type] $movimiento
     * @return void
     */
    public function registrar_cliente($movimiento)
    {
        $doc = $this->origendestino_model->validar($movimiento->RUC_DNI, 0);
        if ($doc['status'] === true) {
            $pro = new Origendestino();
            $pro->__SET('nODTipo', 2);
            $pro->__SET('sODRucDni', $movimiento->RUC_DNI);
            $pro->__SET('sODNombre', $movimiento->NOMBRE);
            $pro->__SET('sODNombreComercial', $movimiento->NOMBRE);
            $pro->__SET('sODDireccion', "");
            $pro->__SET('sODTelefono', "");
            $pro->__SET('sODCorreo', "");
            $pro->__SET('sODContacto', "");
            $pro->__SET('nODDiasCredito', ($movimiento->DIAS_CREDITO != "") ? $movimiento->DIAS_CREDITO : "");
            $pro->__SET('nProcliDepId', "");
            $pro->__SET('nProcliDepName', "");
            $pro->__SET('nProcliProvId', "");
            $pro->__SET('nProcliProvName', "");
            $pro->__SET('nProcliDistId', "");
            $pro->__SET('nProcliDistName', "");
            $pro->__SET('nODEstado', 1);
            $pro->__SET('nODEliminado', 0);
            $pro->__SET('nODUsuario_Id', $_SESSION['usu_codigo']);
            return $this->origendestino_model->Crear($pro);
        }
        return null;
    }

    /**
     * Validar documento function
     *
     * @param [type] $movimiento
     * @return void
     */
    public function validar_documento($movimiento)
    {
        $documento = $movimiento->RUC_DNI;
        /**
         * Validar si es solo dni
         */
        if (strlen($documento) == 8) {
            return true;
        }
        /**
         * Validar si es ruc
         */
        if (strlen($documento) == 11) {
            return true;
        }
        /**
         * si el documento no tiene el tamaño
         * de dni o ruc no es valido
         */
        return false;
    }

    /**
     * Calcular ICBPER function
     *
     * @param [type] $value
     * @param [type] $cantidad
     * @return void
     */
    // function calcularICBPER($value, $cantidad) {
    //     return ($value * $this->ICBPER) * $cantidad;
    // }
    function calcularICBPER($cantidad)
    {
        return ($this->ICBPER) * $cantidad;
    }

    public function AgregarProductoX()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'];
        } else {
            $nMovDetConPrecioUnitario = $_POST['nMovDetConPrecioUnitario'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sMovDetConCantidad" => $_POST['sMovDetConCantidad'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dMovDetConFechaVencimiento" => isset($_POST['dMovDetConFechaVencimiento']) ? $_POST['dMovDetConFechaVencimiento'] : date('d-m-Y'),
            //"nMovDetConPrecioUnitario" => round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP),
            //"nMovDetConPrecioUnitario" => number_format($nMovDetConPrecioUnitario, $this->DECIMALES, '.', ''),
            "nMovDetConPrecioUnitario" => $nMovDetConPrecioUnitario,
            //"nMovDetConSubtotal" => round($nMovDetConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP) * $_POST['sMovDetConCantidad'],
            //"nMovDetConSubtotal" => $nMovDetConPrecioUnitario * $_POST['sMovDetConCantidad'],
            "nMovDetConSubtotal" => $nMovDetConPrecioUnitario * $_POST['sMovDetConCantidad'],
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            array_push($data, $array);
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        return true;
    }

    private function forceAddProductC($lotes, $ProdServ_Id, $Almacen_Id, $Unidadmedida_Id, $sMovDetConCantidad, $nMovDetConPrecioUnitario, $nIncluyeIGV, $nProSrvExoneradoIGV, $nProSrvICBPer)
    {
        $x = array(
            'lotes' => $lotes,
            'ProdServ_Id' => $ProdServ_Id,
            'Almacen_Id' => $Almacen_Id,
            'Unidadmedida_Id' => $Unidadmedida_Id,
            'sMovDetConCantidad' => (float) $sMovDetConCantidad,
            //            'nMovDetConPrecioUnitario' => number_format($nMovDetConPrecioUnitario, $this->DECIMALES),
            //            'nMovDetConSubtotal' => number_format($sMovDetConCantidad * $nMovDetConPrecioUnitario, $this->DECIMALES),
            'nMovDetConPrecioUnitario' => $nMovDetConPrecioUnitario,
            'nMovDetConSubtotal' => $sMovDetConCantidad * $nMovDetConPrecioUnitario,
            'nIncluyeIGV' => $nIncluyeIGV,
            'nProSrvExoneradoIGV' => $nProSrvExoneradoIGV,
            'nProSrvICBPer' => $nProSrvICBPer
        );
        $_POST = array();
        $_POST = $x;
        $this->AgregarProductoX();
    }

    public function PromoverCotizacion()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $obtenerRol = $this->seguridad->roles(); // jc- 2021-12-16
        $RolVendedor = $obtenerRol[0]->RoleName; // jc- 2021-12-16
        $detracciones = $this->movimiento_model->ListarDetracciones();
        $habilitado = 0;

        switch ($_SESSION['usu_enterpriseRuc']) {
            case '20603942133':
                $habilitado = 1;
                break;
            case '20608420721':
                $habilitado = 1;
                break;
            case '20553754454':
                $habilitado = 1;
                break;
            default:
                break;
        }
        $empresas_obs = $habilitado;
        $observacion_vendedor = $habilitado = 1 ? 'onchange=asignarobs();' : '';

        $ptipomovimiento = null;
        $pbienes = null;
        $pobservacion = null;
        $ptipopago = null;
        $ptipodocumento = null;

        foreach ($parametro as $r) {
            if ($r->__GET('Parametro_Id') == 3) {
                $ptipomovimiento = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 4) {
                $pbienes = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 5) {
                $pobservacion = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 7) {
                $ptipopago = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 8) {
                $ptipodocumento = $r->__GET('sParValor');
            }
        }

        $cotizacion = $this->cotizacion_model->Buscar($_POST['Movimiento_Id'])[0];

        $detalle_cotizacion = $this->cotizaciondetalle_model->Buscar($cotizacion->__GET('Movimiento_Id'));
        //print_r($detalle_cotizacion);die();
        if (!empty($detalle_cotizacion)) {
            foreach ($detalle_cotizacion as $dc) {
                $lote = $this->cotizaciondetalle_model->BuscarLote($cotizacion->Almacen_Id, $dc->prodserv_Id);
                //print_r($lote);die();
                //$cur_precioUnitario = $dc->nMovDetPrecioUnitario;
                $cur_precioUnitario = $dc->nMovDetImporte / $dc->nMovDetCantidad;
                $this->forceAddProductC(@$lote->sProLNombreLote, $dc->prodserv_Id, $cotizacion->Almacen_Id, $dc->nMovDetUnidad_Id, $dc->nMovDetCantidad, $cur_precioUnitario, $dc->nMovDetIncluyeIGV, $dc->nProSrvExoneradoIGV, $dc->dMovDetICBPER);
            }
        }

        $mov = new Movimiento();
        $mov->__SET('Movimiento_Id', '0');
        $mov->__SET('nMovOrdenCompra_Id', '');
        $mov->__SET('nro_decimales', '');
        $mov->__SET('dMovFecha', date('d-m-Y'));
        $mov->__SET('nMovTipoMovimiento_Id', 2); //$ptipomovimiento);
        $mov->__SET('nMovTipopago', $cotizacion->__get('nMovTipopago'));
        $mov->__SET('nMovTipoOrigenDestino', $cotizacion->__get('nMovTipoOrigenDestino'));
        $mov->__SET('nMovOrigenDestino_Id', $cotizacion->__get('nMovOrigenDestino_Id'));
        $mov->__SET('nMovTipodestino', $cotizacion->__get('nMovTipodestino'));
        $mov->__SET('Almacen_Id', $cotizacion->__get('nMovTipodestino'));
        $mov->__SET('Documento_Id', $ptipodocumento);
        $mov->__SET('sMovDocReferencia', $cotizacion->__get('Documento'));
        $mov->__SET('nDocAfectoIGV', $cotizacion->__get('nDocAfectoIGV'));
        $mov->__SET('Moneda_Id', $cotizacion->__get('Moneda_Id'));
        $mov->__SET('nMovTipoCambio', $cotizacion->__get('nMovTipoCambio'));
        $mov->__SET('nMovImporte', $cotizacion->__get('nMovImporte'));
        $mov->__SET('nMovIGV', $cotizacion->__get('nMovIGV'));
        $mov->__SET('nMovTotal', $cotizacion->__get('nMovTotal'));
        $mov->__SET('nMovSaldo', $cotizacion->__get('nMovSaldo'));
        //$mov->__SET('nMovVendedor_Id',$cotizacion->__get('nMovVendedor_Id'));
        $mov->__SET('vendedor_id', $cotizacion->__get('vendedor_id'));
        $mov->__SET('dMovDetraccion', $cotizacion->__get('dMovDetraccion'));
        $mov->__SET('dMovPercepcion', $cotizacion->__get('dMovPercepcion'));
        $mov->__SET('dMovRetencion', $cotizacion->__get('dMovRetencion'));
        $mov->__SET('sMovObservacion', $cotizacion->__get('sMovObservacion'));
        $r = $mov;

        $promovido = true;
        $promovido_fecha_credito = '';
        $promovido_importe = 0;

        if ($cotizacion->__get('nMovTipopago') == 2) {
            $cliente = $this->origendestino_model->Buscar($cotizacion->__get('nMovOrigenDestino_Id'));
            $dias_credito = $cliente[0]->nODDiasCredito;
            $fecha_emision = date('Y-m-d');
            $fecha_vencimiento = date('Y-m-d', strtotime(sprintf('%s +%sdays', $fecha_emision, $dias_credito)));
            $promovido_fecha_credito = date('d-m-Y', strtotime($fecha_vencimiento));
            $promovido_importe = $cotizacion->__get('nMovTotal');
        }

        require_once 'view/webforms/wfamovimientoa.php';
    }

    public function PromoverOrdenCompra()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $obtenerRol = $this->seguridad->roles(); // jc- 2021-12-16
        $RolVendedor = $obtenerRol[0]->RoleName; // jc- 2021-12-16
        $detracciones = $this->movimiento_model->ListarDetracciones();
        $habilitado = 0;

        switch ($_SESSION['usu_enterpriseRuc']) {
            case '20603942133':
                $habilitado = 1;
                break;
            case '20608420721':
                $habilitado = 1;
                break;
            case '20553754454':
                $habilitado = 1;
                break;
            default:
                break;
        }
        $empresas_obs = $habilitado;
        $observacion_vendedor = $habilitado = 1 ? 'onchange=asignarobs();' : '';

        $ptipomovimiento = null;
        $pbienes = null;
        $pobservacion = null;
        $ptipopago = null;
        $ptipodocumento = null;

        foreach ($parametro as $r) {
            if ($r->__GET('Parametro_Id') == 3) {
                $ptipomovimiento = 1; //$r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 4) {
                $pbienes = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 5) {
                $pobservacion = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 7) {
                $ptipopago = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 8) {
                $ptipodocumento = 3; //$r->__GET('sParValor');
            }
        }

        $oc = $this->ordencompra_model->Buscar($_POST['OrdenCompra_Id'])[0];

        $detalle_oc = $this->ordencompradetalle_model->Buscar($oc->__GET('OrdenCompra_Id'));
        //print_r($detalle_oc);die();
        if (!empty($detalle_oc)) {
            foreach ($detalle_oc as $dc) {
                $lote = $this->ordencompradetalle_model->BuscarLote($oc->Almacen_Id, $dc->prodserv_Id);
                //print_r($lote);die();
                $this->forceAddProductC(@$lote->sProLNombreLote, $dc->prodserv_Id, $oc->Almacen_Id, $dc->nOCDUnidad_Id, $dc->nOCDCantidadPendiente, $dc->nOCDPrecioUnitario, $dc->nOCDIncluyeIGV, $dc->nProSrvExoneradoIGV, $dc->dOCDICBPER);
            }
        }

        $mov = new Movimiento();
        $mov->__SET('Movimiento_Id', '0');
        $mov->__SET('nMovOrdenCompra_Id', $oc->OrdenCompra_Id);
        $mov->__SET('nro_decimales', '');
        $mov->__SET('dMovFecha', date('d-m-Y'));
        $mov->__SET('nMovTipoMovimiento_Id', 1); //$ptipomovimiento);
        $mov->__SET('nMovTipopago', $oc->__get('nOCTipopago'));
        $mov->__SET('nMovTipoOrigenDestino', $oc->__get('nOCTipoOrigenDestino'));
        $mov->__SET('nMovOrigenDestino_Id', $oc->__get('nOCOrigenDestino_Id'));
        $mov->__SET('nMovTipodestino', $oc->__get('nOCTipodestino'));
        $mov->__SET('Almacen_Id', $oc->__get('nOCTipodestino'));
        $mov->__SET('Documento_Id', $ptipodocumento);
        $mov->__SET('sMovDocReferencia', $oc->__get('sOCDocReferencia'));
        $mov->__SET('nDocAfectoIGV', $oc->__get('nDocAfectoIGV'));
        $mov->__SET('Moneda_Id', $oc->__get('Moneda_Id'));
        $mov->__SET('nMovTipoCambio', $oc->__get('nOCTipoCambio'));
        $mov->__SET('nMovImporte', $oc->__get('nOCImporte'));
        $mov->__SET('nMovIGV', $oc->__get('nOCIGV'));
        $mov->__SET('nMovTotal', $oc->__get('nOCTotal'));
        $mov->__SET('nMovSaldo', $oc->__get('nOCSaldo'));
        $mov->__SET('vendedor_id', $oc->__get('vendedor_id'));
        $mov->__SET('dMovDetraccion', $oc->__get('dOCDetraccion'));
        $mov->__SET('dMovPercepcion', $oc->__get('dOCPercepcion'));
        $mov->__SET('dMovRetencion', $oc->__get('dOCRetencion'));
        $mov->__SET('sMovObservacion', $oc->__get('sOCObservacion'));
        $r = $mov;

        $promovido = true;
        $promovido_fecha_credito = '';
        $promovido_importe = 0;

        $_SESSION['is_oc'] = true;

        if ($oc->__get('nOCTipopago') == 2) {
            $cliente = $this->origendestino_model->Buscar($oc->__get('nOCOrigenDestino_Id'));
            $dias_credito = $cliente[0]->nODDiasCredito;
            $fecha_emision = date('Y-m-d');
            $fecha_vencimiento = date('Y-m-d', strtotime(sprintf('%s +%sdays', $fecha_emision, $dias_credito)));
            $promovido_fecha_credito = date('d-m-Y', strtotime($fecha_vencimiento));
            $promovido_importe = $oc->__get('nOCTotal');
        }

        $oc = $this->ordencompra_model->Buscar($oc->OrdenCompra_Id);
        $oc_documento = $oc[0]->sOCDocumento;

        require_once 'view/webforms/wfamovimientoa.php';
    }

    public function AgregarCliente()
    {
        $fx = implode('', file('view/webforms/wfaclienteproveedora.php'));
        $fx = str_replace('class="breadcrumb"', 'class="breadcrumb hidden"', $fx);
        $fx = str_replace(':GuardarProvclien();', ':GuardarProvclienModal();', $fx);
        $fx = preg_replace('/class=\"col-md-6\">\s+<div class=\"box\">/', 'class="col-md-12"><div class="box">', $fx);
        $fx = preg_replace(
            '/<a href=\"\?c=Clienteproveedor&a=Index\" class=\"btn btn-danger btn-flat\">Cancelar<\/a>/',
            '<a data-dismiss="modal" class="btn btn-danger btn-flat">Cancelar</a>',
            $fx
        );
        echo eval('?>' . $fx . '<?php');
    }

    public function obtenerTipoCambioPorFecha()
    {

        $token = 'apis-token-1.aTSI1U7KEuT-6bbbCguH-4Y8TI6KS73N';
        $fecha = $_POST['fecha'];
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.apis.net.pe/v1/tipo-cambio-sunat?fecha=' . $fecha,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_SSL_VERIFYPEER => 0,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 2,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Referer: https://apis.net.pe/tipo-de-cambio-sunat-api',
                'Authorization: Bearer ' . $token
            ),
        ));
        $response = curl_exec($curl);
        curl_close($curl);
        echo $response;
    }

    public function obtenerMovimientos()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'] or $this->seguridad->validRoleName(RolesType::admin2) ? 0 : $_SESSION['usu_codigo'];

        $movimientos = $this->movimiento_model->ListarDateToArray(
            $_POST['fechaInicio'],
            $_POST['fechaFin'],
            $_POST['TipoMovimiento_Id'],
            $usuariocodigo
        );

        echo json_encode(array('movimientos' => $movimientos, 'ruc' => $_SESSION['usu_enterpriseRuc']));
    }

    public function actualizarEstadoMovPorId()
    {
        $row = $this->movimiento_model->actualizarEstadoPorId($_REQUEST['Movimiento_Id'], $_REQUEST['Estado']);
        echo $row;
    }
    
    public function verificarEstadoColibri()
    {
        $rucJson = $_POST['rucJson'];
		$sDocNombreCorto = $_POST['sDocNombreCorto'];
		$sMovDocumento = $_POST['sMovDocumento'];
        $url = "https://colibri2.fmsac.com/comprobante";

        // Hacer la solicitud a colibri
        $request = new RequestServices();
        $request->url = $url . '/' . $rucJson . '/' . $sDocNombreCorto . '/' . $sMovDocumento;

        $result = $request->servicePost();
        echo json_encode($result);

    }
    
    public function ExisteDocumento() {
        $sMovDocumento = $_POST['sMovDocumento'];
        $Documento_Id = $_POST['Documento_Id'];

        $result = $this->movimiento_model->ExisteDocumento($sMovDocumento, $Documento_Id);
        echo json_encode($result);
    }
}
