<?php
header('Access-Control-Allow-Origin: *');  
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/familia.model.php';
require_once 'model/familia.entidad.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/productolote.model.php';
require_once 'model/productolote.entidad.php';
require_once 'model/precioventa.model.php';
require_once 'model/precioventa.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/vendedor.model.php';
require_once 'model/vendedor.entidad.php';
require_once 'model/cotizacion.model.php';
require_once 'model/cotizacion.entidad.php';
require_once 'model/cotizaciondetalle.model.php';
require_once 'model/cotizaciondetalle.entidad.php';
require_once 'model/ordencompra.model.php';
require_once 'model/ordencompra.entidad.php';
require_once 'model/ordencompradetalle.model.php';
require_once 'model/ordencompradetalle.entidad.php';
require_once 'controller/electronic.controller.php';

class OrdenCompraController extends MetodosController
{
    public $url;
    public $parametro_model;
    public $documento_model;
    public $almacen_model;
    public $tipomovimiento_model;
    public $movimiento_model;
    public $prodserv_model;
    public $familia_model;
    public $unidadmedida_model;
    public $productolote_model;
    public $movimientodetalle_model;
    public $precioventa_model;
    public $origendestino_model;
    public $cotizacion_model;
    public $cotizaciondetalle_model;
    public $ordencompra_model;
    public $ordencompradetalle_model;
    public $IGV = 0;
    public $ICBPER = 0.10;
    private $electronic_controller;
    private $seguridad;

    public function __CONSTRUCT()
    {
        //$this->url = 'http://colibri-fm.ddns.net:8087/servicio/Transaccion/AnularSunat/' . $_SESSION['usu_enterpriseRuc'];
        $this->parametro_model = new ParametroModel();
        $this->documento_model = new DocumentoModel();
        $this->almacen_model = new AlmacenModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->movimiento_model = new MovimientoModel();
        $this->prodserv_model = new ProdservModel();
        $this->familia_model = new FamiliaModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->productolote_model = new ProductoloteModel();
        $this->precioventa_model = new PrecioventaModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->electronic_controller = new ElectronicController();
        $this->vendedor_model = new VendedorModel();
        $this->cotizacion_model = new CotizacionModel();
        $this->cotizaciondetalle_model = new CotizaciondetalleModel();
        $this->ordencompra_model = new OrdenCompraModel();
        $this->ordencompradetalle_model = new OrdenCompraDetalleModel();
        $this->seguridad = new Seguridad();
        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 10) {
                $this->ICBPER =  ($pa->__GET('sParValor')) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 14) {
                $this->DECIMALES =  ($pa->__GET('sParValor'));
            }
        }
    }

    function puedePromoverOrdenCompra($OrdenCompra_Id){
        $Movimiento_Id = $this->ordencompra_model->getMovimiento($OrdenCompra_Id);
        if(!empty($Movimiento_Id)){
            $datachk = array();
            $lotechk = array();
            $data = $this->movimientodetalle_model->Buscar($Movimiento_Id);
            $oc = $this->ordencompra_model->Buscar($OrdenCompra_Id)[0];
            $ocd = $this->ordencompradetalle_model->Buscar($OrdenCompra_Id);
            if(!empty($data)){
                for ($i = 0; $i < count($data); $i++) {
                    $Almacen_Id = $oc->Almacen_Id;
                    $ProdServ_Id = $data[$i]->prodserv_Id;
                    $item = array();
                    $pl =  $this->ordencompradetalle_model->BuscarLote($Almacen_Id, $ProdServ_Id);
                    $item['ProdServ_Id'] = $ProdServ_Id;
                    $item['ProductoLote_Id'] = $pl->ProductoLote_Id;
                    $item['nProLStockReal'] = $pl->nProLStockReal;
                    $item['index'] = $i;
                    $datachk[] = $item;
                    $lotechk[] = $pl->ProductoLote_Id;
                }
                //print_r($datachk);
                foreach($ocd as $ocdet){
                    $ProdServ_Id = $ocdet->ProdServ_Id;
                    $ProductoLote_Id = $ocdet->ProductoLote_Id;
                    $cantPendiente = $ocdet->nOCDCantidadPendiente;
                    //print_r($ocdet);

                    $index = array_search($ocdet->ProductoLote_Id, $lotechk)!==false;
                    if($index){
                        //si el item a promover es menor 1 (tiene 0 items pendientes, eliminar de sesion)
                        if($ocdet->nOCDCantidadPendiente<1){
                            $ref_index = $datachk[$index-1]['index'];
                            unset($data[$ref_index]);
                        }
                    }
                }
                //print_r($data);
                return sizeof($data)>0;
            }
        }
        return true;
    }

    public function Index()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'] or $this->seguridad->validRoleName(RolesType::admin2) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->ListarOC();
        $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : 1;
        $movimientos = $this->ordencompra_model->ListarDate(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
            $TipoMovimiento_Id,
            $usuariocodigo
        );

        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfaordencompra.php';
        if(isset($_POST['OrdenCompra_Id'])){
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            PromoverCotizacion({$_POST['OrdenCompra_Id']})
                        });
                  </script>";
        }
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Index2()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->ListarOC();
        $TipoOrdenCompra_Id = isset($_REQUEST['TipoOrdenCompra_Id']) ? $_REQUEST['TipoOrdenCompra_Id'] : $valor[1];
        $movimientos = $this->movimiento_model->ListarDate2(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
            $TipoOrdenCompra_Id,
            $usuariocodigo
        );

        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfamovimientoven.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarMovimiento()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->ListarOC();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $obtenerRol =  $this->seguridad->roles(); // jc- 2021-12-16
        $RolVendedor = $obtenerRol[0]->RoleName; // jc- 2021-12-16
        require_once 'view/webforms/wfaordencompraa.php';
    }

    public function FrmEditarMovimiento()
    {
        $this->DetruirSessiones();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->ListarOC();
        $movimiento = $this->movimiento_model->Buscar($_POST['OrdenCompra_Id']);
        $vendedor = $this->vendedor_model->Listar();
        $data = array();
        foreach ($movimiento as $r) :

            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('OrdenCompra_Id'));
            foreach ($detalle_movimiento as $detmov) :

                $array = array(
                    "ProdServ_Id" => $detmov->__GET('ProductoLote_Id'),
                    "sProSrvNombre" => $detmov->__GET('sProSrvNombre'),
                    "lotes" => 0,
                    "sOCDConCantidad" => $detmov->__GET('nOCDCantidad'),
                    "Unidadmedida_Id" => $detmov->__GET('nOCDUnidad_Id'),
                    "dOCDConFechaVencimiento" => $this->FechaVencimiento($detmov->__GET('ProductoLote_Id')),
                    "nOCDConPrecioUnitario" => $detmov->__GET('nOCDPrecioUnitario'),
                    "nOCDConSubtotal" => $detmov->__GET('nOCDImporte'),
                );
                if (isset($_SESSION['producto_c'])) {
                    $data = $_SESSION['producto_c'];
                    array_push($data, $array);
                } else {
                    $data[] = $array;
                }
                $_SESSION['producto_c'] = $data;
            endforeach;
            require_once 'view/webforms/wfaordencompraa.php';
            echo '<script type="text/javascript">
            $(document).ready(function(){
                console.log(' . $r->__GET('nMovOrigenDestino_Id') . ');
                TipoPrvClien();
                TipoDocumentoEditar(' . $r->__GET('nMovOrigenDestino_Id') . ');
                ListarProductos();
            });
														                      </script>';
        endforeach;
    }

    public function FrmEditarClienteproveedor()
    {
        //            $obtenerUsuario= $this->usuario_model->Buscar($_POST['Usuario_Id']);
        //            foreach ($obtenerUsuario as $r):
        //                require_once 'view/webforms/wfausuarioa.php';
        //            endforeach;
    }

    public function MostrarMovimiento()
    {
        $total = 0;
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->ListarOC();
        $movimiento = $this->ordencompra_model->Buscar($_POST['Movimiento_Id']);
        $data = array();
        echo '<table class="table table-hover table-bordered">';
        foreach ($movimiento as $r) :
            echo "<tr>";
            echo "<input type='hidden' name='OrdenCompra_Id' id='OrdenCompra_Id' value='" . $r->__GET('OrdenCompra_Id') . "'>";
            echo "<td>Fecha: </td>";
            echo "<td>" . $r->__GET('dOCFecha') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo Movimiento: </td>";
            echo "<td>" . $r->__GET('sTMovNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo Pago: </td>";
            echo "<td>" . ($r->__GET('nOCTipopago') == 1 ? 'Contado' : 'Credito') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo: </td>";
            echo "<td>" . ($r->__GET('nOCTipoOrigenDestino') == 1 ? 'Proveedor' : 'Cliente') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Cliente/Proveedor:</td>";
            echo "<td>" . $this->NombreClienteProveedor($r->__GET('nOCOrigenDestino_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Destino:</td>";
            echo "<td>" . ($r->__GET('nOCTipodestino') == 1 ? 'Almacen' : 'Consumo') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Almacen:</td>";
            echo "<td>" . $this->AlmNombre($r->__GET('Almacen_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento:</td>";
            echo "<td>" . $this->DocNombre($r->__GET('Documento_Id')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Nro. Documento:</td>";
            echo "<td>" . $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sOCDocumento') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Documento referencia:</td>";
            echo "<td> <input style='width:400px; height:50px; border: none;' type='text' id='sMovDocReferencia' name='sMovDocReferencia' value='" . $r->__GET('sOCDocReferencia') . "'> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Tipo de moneda:</td>";
            echo "<td>" . ($r->__GET('Moneda_Id') == 1 ? 'Soles' : 'Dolares') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td> Fecha de entrega:</td>";
            echo "<td>" . ($r->__GET('dOCFechaEntrega') ) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td> Lugar de entrega:</td>";
            echo "<td>" . ($r->__GET('sOCLugarEntrega')) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Hora:</td>";
            echo "<td>" . date('H:i A', strtotime($r->__GET('dOCFecha_Act'))) . "</td>";
            echo "</tr>";
            echo "<tr>";
            // echo "<td>Vendedor:</td>";

            // $vendedor = $this->vendedor_model->Listar();
            // foreach ($vendedor as $ven) {
            // echo"<td> <select name='nMovVendedor_Id' id='nMovVendedor_Id'>

            //  <option value=' ". $ven->__GET('vendedor_id'). "' ".  $ven->__GET('vendedor_id') ."selected> " .$ven->__GET('sVenNom'). "</option>
            // </select> </td>";
            //     }


            // echo "</tr>";
            echo "<tr>";
            echo "<td>Observación:</td>";
            echo "<td> <textarea name='sMovObservacion' id='sMovObservacion' style='width:400px; height:80px; border:none;'>" . $r->__GET('sOCObservacion') . "</textarea> </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Cantidad Pendiente</th>";
            echo "<th>Unidad</th>";
            echo "<th>Precio</th>";
            echo "<th>Sub Total</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_movimiento = $this->ordencompradetalle_model->Buscar($r->__GET('OrdenCompra_Id'));
            foreach ($detalle_movimiento as $detmov) :
                echo '<tr>';
                echo '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
                echo '<td>' . $detmov->__GET('nOCDCantidad') . '</td>';
                echo '<td>' . $detmov->__GET('nOCDCantidadPendiente') . '</td>';
                echo '<td>' . $this->UnidadNombre($detmov->__GET('nOCDUnidad_Id')) . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nOCDPrecioUnitario'), $this->DECIMALES, ".", ",") . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nOCDImporte'), $this->DECIMALES, ".", ",") . '</td>';
                echo '</tr>';
            endforeach;
            echo '<tr><td style="text-align: right;" colspan="5">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nOCImporte'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="5">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nOCIGV'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="5">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nOCTotal'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }

    public function GuardarMovimiento()
    {
        $importes = json_decode($_POST['importes']);
        $mov = new OrdenCompra();
        if ($_POST['OrdenCompra_Id'] != 0 ? $mov->__SET('OrdenCompra_Id', $_POST['OrdenCompra_Id']) : '');
        $mov->__SET('dOCFecha', $_POST['dOCFecha']);
        $mov->__SET('nOCTipoMovimiento_Id', $_POST['Tipomovimiento_Id']);
        $mov->__SET('nOCTipopago', $_POST['nOCTipopago']);
        $mov->__SET('Almacen_Id', $_POST['Almacen_Id']);
        $mov->__SET('nOCTipoOrigenDestino', $_POST['nOCTipoOrigenDestino']);
        $mov->__SET('nOCOrigenDestino_Id', $_POST['nOCOrigenDestino_Id']);
        $mov->__SET('nOCTipodestino', $_POST['nOCTipodestino']);
        $mov->__SET('Documento_Id', $_POST['Documento_Id']);
        $mov->__SET('sOCDocumento', $_POST['sOCDocumento']);
        $mov->__SET('sOCDocReferencia', $_POST['sOCDocReferencia']);
        $mov->__SET('Moneda_Id', $_POST['Moneda_Id']);
        $mov->__SET('nOCTipoCambio', $_POST['nOCTipoCambio']);
        $mov->__SET('nOCImporte', str_replace(",", "", $_POST['dOCImporte']));
        $mov->__SET('nOCIGV', str_replace(",", "", $_POST['dOCIGV']));
        $mov->__SET('nOCTotal', str_replace(",", "", $_POST['dOCTotal']));
        $mov->__SET('nOCSaldo', str_replace(",", "", $_POST['dOCTotal']));
        $mov->__SET('nOCTotalCancelado', $_POST['nOCTipopago'] == 1 ? str_replace(",", "", $_POST['dOCTotal']) : '0');
        $mov->__SET('dOCDetraccion', $_POST['dOCDetraccion']);
        $mov->__SET('dOCPercepcion', $_POST['dOCPercepcion']);
        $mov->__SET('dOCRetencion', $_POST['dOCRetencion']);
        $mov->__SET('sOCObservacion', $_POST['sOCObservacion']);
        $mov->__SET('nOCEstado', 1); //$_POST['nOCTipopago'] == 1 ? '2' : '1');
        $mov->__SET('nOCEliminado', 0);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $mov->__SET('nOCVendedor_Id', $_POST['nOCVendedor_Id']);
        $mov->__SET('dOCICBPER', str_replace(",", "", $_POST['dOCICBPER']));
        $mov->__SET('dOCFechaEntrega', $_POST['dOCFechaEntrega']);
        $mov->__SET('sOCLugarEntrega', $_POST['sOCLugarEntrega']);
        if ($_POST['OrdenCompra_Id'] != 0) {
            $this->ordencompra_model->Editar($mov);
        } else {
            $OrdenCompra_Id = $this->ordencompra_model->Guardar($mov);
            $mov->__SET('OrdenCompra_Id', $OrdenCompra_Id);

            $parametro = $this->parametro_model->ListarParametros();

            if (isset($_SESSION['producto_c'])) {
                $data = $_SESSION['producto_c'];
                for ($i = 0; $i < count($data); $i++) {
                    $movdet = new OrdenCompraDetalle();
                    $movdet->__SET('OrdenCompra_Id', $OrdenCompra_Id);
                    $movdet->__SET('TipoMovimiento_Id', $_POST['Tipomovimiento_Id']);
                    $movdet->__SET('TipoDestino', $_POST['nOCTipodestino']);
                    $movdet->__SET('ProdServ_Id', $data[$i]['ProdServ_Id']);
                    $movdet->__SET('Almacen_Id', $_POST['Almacen_Id']);

                    $multlotes = null;
                    foreach ($parametro as $r) {
                        if ($r->__GET('Parametro_Id') == 13) {
                            $multlotes = $r->__GET('sParValor');
                        }
                    }
                    if ($multlotes) {
                        $multlotes = explode('|', $multlotes);

                        if ($multlotes[1]) {
                            $movdet->__SET('Lote', $data[$i]['lotes'] != 0 ? $data[$i]['lotes'] : date('Ymdhis'));
                        } else {
                            $movdet->__SET('Lote', $data[$i]['lotes'] != 0 ? $data[$i]['lotes'] : '202001'); //un solo lote
                        }
                    }
                    $movdet->__SET('FechaVencimiento', $data[$i]['dOCDConFechaVencimiento']); // pendiente
                    $movdet->__SET('Cantidad', $data[$i]['sOCDConCantidad']);
                    $movdet->__SET('Unidad_Id', $data[$i]['Unidadmedida_Id']); // pendiente
                    $movdet->__SET('MonedaCompra_Id', $_POST['Moneda_Id']);
                    $movdet->__SET('PrecioLista', $data[$i]['nOCDConPrecioUnitario']);
                    $movdet->__SET('Descuento', 0);
                    $movdet->__SET('Precio', $data[$i]['nOCDConPrecioUnitario']);
                    $movdet->__SET('SubTotal', $data[$i]['nOCDConSubtotal']);
                    $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                    $movdet->__SET('TipoCambio', $_POST['nOCTipoCambio']);
                    $movdet->__SET('nOCDIncluyeIgv', 0);
                    $dMovICBPER = 0;
                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {
                        // $dMovICBPER = $this->calcularICBPER($data[$i]["nOCDConPrecioUnitario"], $data[$i]['sOCDConCantidad']);
                        $dMovICBPER = $this->calcularICBPER($data[$i]['sOCDConCantidad']);
                    }

                    $movdet->__SET('dOCDICBPER', $dMovICBPER);
                    $movdet->__SET('nOCDCantidadPendiente', $data[$i]['nOCDConCantidadPendiente']);
                    $this->ordencompradetalle_model->Guardar($movdet);
                }
            }
            // $this->documento_model->Incrementa($_POST['Documento_Id']);
        }
        
        // guardamos los importes que se ingresaron en el calendario, al seleccionar crédito
         if ($_POST['nOCTipopago'] == 2) { // si es al crédito
            if (!empty($importes)) { // si es que se llenó el modal
                $cantidad_importes = count($importes);
                $detraccion_f = round($_POST['dOCDraccion'] / $cantidad_importes, 2);
                for ($j = 0; $j < $cantidad_importes; $j++) {
                    $this->movimiento_model->GuardarPago(
                        $OrdenCompra_Id,
                        $importes[$j]->nrocuota,
                        // number_format($importes[$j]->importe, 2, ".", ","),
                        $importes[$j]->importe - $detraccion_f,
                        $importes[$j]->fecha
                    );
                }
            } else {
                if (empty($_POST['dias_credito'])) {
                    $param = 0;
                } else {
                    $param = $_POST['dias_credito'];
                }
                $this->movimiento_model->GuardarPago(
                    $OrdenCompra_Id,
                    1,
                    str_replace(",", "", $_POST['dOCTotal']) - $_POST['dOCDraccion'],
                    date('Y-m-d', strtotime($_POST['dOCFecha'] . "+ $param days"))
                );
            }
        }
        
        $this->DetruirSessiones();
        /* echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                  </div>'; */

        $Documento_Id = $_POST['Documento_Id'];
        $doc = $this->documento_model->Numero($Documento_Id);


        //RESULTADO PARA RESPONSE DE GUARDARMOVIMIENTO
        /* $res = array(
            'OrdenCompra_Id' => $OrdenCompra_Id,
            'importe' => number_format($_POST['dMovTotal'],2),
            'previsualizacion' => ($_SESSION['usu_enterpriseIsFE'] && $doc->isFE),
            'enviarcomprobante' => ($_SESSION['usu_enterpriseIsFE'] && !$doc->isFE),
            'print' => '<div class="alert alert-success" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
          </div>'
        ); */

        //esta habilitado a nivel de empresa para facturacion electronica?
        if ($_SESSION['usu_enterpriseIsFE']) {
            //esta habilitado para facturacion electronica?
            if ($doc->isFE) {
                //previsualizar para enviar
                echo '<script type="text/javascript">previsualizacion(' . $OrdenCompra_Id . ');</script>';
                return;
            } else {

                //verifica si el documento tiene formato de impresion
                //cond: nDocTipoImprimir!=0 => Imprime
                if ($doc->nDocTipoImprimir != 0) {
                    echo "<script type='text/javascript'>enviarcomprobante($OrdenCompra_Id)</script>";
                }
            }
        }

        echo "<script type='text/javascript'>location.href='?c=OrdenCompra&a=Index';</script>";

        //echo json_encode($res);
    }

    public function TipoMovimiento()
    {
        $productos = $this->prodserv_model->Listar2();
        $tipomovimiento = $this->tipomovimiento_model->Buscar($_POST['Tipomovimiento_Id']);
        foreach ($tipomovimiento as $tv) {
            echo '<script type="text/javascript">
                        $(\'#nOCTipoOrigenDestino option[value="' . $tv->__GET('nTMovTipoOD') . '"]\').attr(\'selected\',\'selected\');
                        TipoPrvClien();
                    </script>';
        }
        if ($_POST['Tipomovimiento_Id'] == 1 || $_POST['Tipomovimiento_Id'] == 3) {
            require_once 'view/webforms/tipomovimiento/ingreso_compra.php';
        } elseif ($_POST['Tipomovimiento_Id'] == 2 || $_POST['Tipomovimiento_Id'] == 4) {
            require_once 'view/webforms/tipomovimiento/salida_venta.php';
        }
    }

    public function ListarUnidades()
    {
        $unidad = $this->unidadmedida_model->ListarUP($this->ObtenerID($_POST['ProdServ_Id']));
        $_SESSION['$unidad'] = $unidad;
        // echo "<option value=''>Seleccione unidad</option>";
        foreach ($unidad as $uni) {
            echo "<option value='" . $uni->__GET('UnidadMedida_Id') . "' data-codigosunat='" . $uni->__GET('sUndCodeSunat') . "'
                                                                         data-factconversion='" . $uni->__GET('nUndFac_Cnv') . "'
                                                                         data-alias='" . $uni->__GET('sUndAlias') . "'
                                                                         data-factor='" . $uni->__GET('nUndFac_Cnv') . "'>" .
                $uni->__GET('sUndDescripcion') .
                "</option>";
        }
    }
    public function RenderizadoClass($nProSrvExoneradoIGV)
    {
        switch ($nProSrvExoneradoIGV) {
            case 0:
                return 'style="color:black;"';
            case 1:
                return 'style="color:#cc3300;"';
            case 2:
                return 'style="color:#ffc107;"';
        }
    }
    public function ListarProductos()
    {
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {
                    // <td>
                    //     <input type='checkbox' onchange='changePreice(" . $i . ", this)' " . (isset($data[$i]['HasBonus']) ? ($data[$i]['HasBonus'] === true ? 'checked' : '') : false) . "/>
                    // </td>

                    /* echo "<tr " . $this->RenderizadoClass($data[$i]['nProSrvExoneradoIGV']) . "> 

                                <td>" . (isset($data[$i]['sProSrvNombre']) ? $data[$i]['sProSrvNombre'] : $this->ProdservdNombre($data[$i]['ProdServ_Id'])) . "</td>
                                <td>" . $data[$i]['sOCDConCantidad'] . "</td>
                                <td>" . $this->UnidadNombre($data[$i]['Unidadmedida_Id']) . "</td>
                                <td>" . number_format($data[$i]['nOCDConPrecioUnitario'], $this->DECIMALES) . "</td>
                                <td>" . number_format($data[$i]['nOCDConSubtotal'], $this->DECIMALES) . "</td>
                                <td>
                                    <a href=\"#\" class=\"btn btn-danger btn-flat btn-xs\" data-toggle=\"modal\" data-target=\"#eliminar_productos\" data-productoid='" . $i . "'><i class=\"fa fa-trash-o\"></i></a>
                                </td>
                            </tr>"; */
                    echo "<tr " . $this->RenderizadoClass($data[$i]['nProSrvExoneradoIGV']) . " id='produpd-$i'> 

                        <td>" . (isset($data[$i]['sProSrvNombre']) ? $data[$i]['sProSrvNombre'] : $this->ProdservdNombre($data[$i]['ProdServ_Id'])) . "</td>
                        <td><input type='text' value='" . $data[$i]['sOCDConCantidad'] . "' class='form-control inp-cantidad' onchange='movActualizarProducto($i)'/></td>
                        <td>".$data[$i]['nOCDConCantidadPendiente']."</td>
                        <td>" . $this->UnidadNombre($data[$i]['Unidadmedida_Id']) . "</td>
                        <td><input type='text' value='" . number_format($data[$i]['nOCDConPrecioUnitario'], $this->DECIMALES) . "' onchange='movActualizarProducto($i)' class='form-control inp-precio'/></td>
                        <td>" . number_format($data[$i]['nOCDConSubtotal'], $this->DECIMALES) . "</td>
                        <td>
                            <a href=\"#\" class=\"btn btn-danger btn-flat btn-xs\" data-toggle=\"modal\" data-target=\"#eliminar_productos\" data-productoid='" . $i . "'><i class=\"fa fa-trash-o\"></i></a>
                        </td>
                    </tr>";
                }
            } else {
                echo "<tr> 
                        <td colspan='7'>No hay datos</td>
                      </tr>";
            }
        } else {
            echo "<tr>
                        <td colspan='7'>No hay datos</td>
                      </tr>";
        }
    }

    public function validardetallemovimiento()
    {
        if (isset($_SESSION['producto_c'])) {
            echo count($_SESSION['producto_c']);
            // echo 0;
        } else {
            echo 0;
        }
    }

    public function ListarLoteProducto()
    {
        $data = $this->productolote_model->Listar(!empty($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : 0);
        if (count($data) > 0) {
            foreach ($data as $l) {
                echo "<tr>
                            <th>
                                <input type='radio' name='lotes' id='lotes' data-stock='" . $l->__GET("Stock") . "' value='" . $l->__GET("Lote") . "' onclick='enviarPrecioCosto(" . $l->__GET("PrecioCosto") . ");' data-preciocosto='" . $l->__GET("PrecioCosto") . "' data-almacen='" . $l->__GET("Almacen_Id") . "' checked>
                                <input type='radio' style='visibility:hidden;' name='lotes1' id='lotes' value='" . $l->__GET("Stock") . "'>
                            </th>
                            <td>" . $l->__GET("Almacen") . "</td>
                            <td>" . $l->__GET("Lote") . "</td>
                            <td>" . number_format($l->__GET("Stock"), $this->DECIMALES) . "</td>
                            <td>" . $l->__GET("Unidad") . "</td>
                            <td>" . number_format($l->__GET("PrecioCosto"), $this->DECIMALES) . "</td>
                          </tr>";
            }
        } else {
            echo "<tr>
                    <td colspan='7'>
                        No hay datos
                    </td>
                  </tr>";
        }
    }

    public function NombreAlmacen($Almacen_Id)
    {
        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sAlmNombre');
        }
    }

    public function ActualizarProductoC(){
        $data = array();
        if(isset($_POST['index'])){

            $index = $_POST['index'];
            $cantidad = $_POST['cantidad'];
            $precio = $_POST['precio'];

            $_SESSION['producto_c'][$index]['sOCDConCantidad'] = $cantidad;
            $_SESSION['producto_c'][$index]['nOCDConPrecioUnitario'] = round($precio, $this->DECIMALES, PHP_ROUND_HALF_UP);
            $_SESSION['producto_c'][$index]['nOCDConSubtotal'] = round($precio, $this->DECIMALES, PHP_ROUND_HALF_UP) * $cantidad;

            die('1');
        }
    }

    public function AgregarProductoC()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            $nOCDConPrecioUnitario = $_POST['nOCDConPrecioUnitario'] / $this->IGV;
        } else {
            $nOCDConPrecioUnitario = $_POST['nOCDConPrecioUnitario'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sOCDConCantidad" => $_POST['sOCDConCantidad'],
            "nOCDConCantidadPendiente" => $_POST['nOCDConCantidadPendiente'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dOCDConFechaVencimiento" => isset($_POST['dOCDConFechaVencimiento']) ? $_POST['dOCDConFechaVencimiento'] : date('d-m-Y'),
            "nOCDConPrecioUnitario" => round($nOCDConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nOCDConSubtotal" => round($nOCDConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP) * $_POST['sOCDConCantidad'],
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            array_push($data, $array);
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        echo '<div class="alert alert-success prod" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito!</strong>, Los Datos fueron agregados correctamente.
                  </div>';
    }

    public function EliminarProductoLista()
    {
        $array = array();
        $data = $_SESSION['producto_c'];
        for ($i = 0; $i < count($data); $i++) {
            if ($i != $_POST['Codigo_Producto']) {
                $array[] = array(
                    "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : $data[$i]['ProdServ_Id'],
                    "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sOCDConCantidad" => $data[$i]['sOCDConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dOCDConFechaVencimiento" => $data[$i]['dOCDConFechaVencimiento'],
                    "nOCDConPrecioUnitario" => $data[$i]['nOCDConPrecioUnitario'],
                    "nOCDConSubtotal" => $data[$i]['nOCDConSubtotal'],
                    "nProSrvExoneradoIGV" => $data[$i]['nProSrvExoneradoIGV'],
                    "nProSrvICBPer" => $data[$i]['nProSrvICBPer'],
                );
            }
        }
        $_SESSION['producto_c'] = $array;
        // echo "Datos eliminados";
    }

    public function ModificarPrecioProductoLista()
    {
        // echo $_POST['checked'] === 'true' ? 1 : 0;
        $array = array();
        $data = $_SESSION['producto_c'];
        for ($i = 0; $i < count($data); $i++) {
            if ($i == $_POST['Codigo_Producto']) {
                $array[] = array(
                    "HasBonus" => true,
                    "ProdServ_Id" => $data[$i]['ProdServ_Id'],
                    "lotes" => $data[$i]['lotes'],
                    "Almacen_Id" => $data[$i]['Almacen_Id'],
                    "sOCDConCantidad" => $data[$i]['sOCDConCantidad'],
                    "Unidadmedida_Id" => $data[$i]['Unidadmedida_Id'],
                    "dOCDConFechaVencimiento" => $data[$i]['dOCDConFechaVencimiento'],
                    "nOCDConPrecioUnitario" => $_POST['checked'] === 'true' ? 0 : $data[$i]['after_nOCDConPrecioUnitario'],
                    "nOCDConSubtotal" => $_POST['checked'] === 'true' ? 0.01 : $data[$i]['after_nOCDConSubtotal'],
                    "nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? 1 : $data[$i]['after_nProSrvExoneradoIGV'], // $data[$i]['nProSrvExoneradoIGV']
                    "after_nOCDConPrecioUnitario" => $_POST['checked'] === 'true' ? $data[$i]['nOCDConPrecioUnitario'] : 0,
                    "after_nOCDConSubtotal" => $_POST['checked'] === 'true' ? $data[$i]['nOCDConSubtotal'] : 0,
                    "after_nProSrvExoneradoIGV" => $_POST['checked'] === 'true' ? $data[$i]['nProSrvExoneradoIGV'] : 0, // $data[$i]['nProSrvExoneradoIGV']
                );
            } else {
                $array[] = $data[$i];
            }
        }
        $_SESSION['producto_c'] = $array;
    }

    public function EliminarProductos()
    {
        $pro = new Prodserv();
        $pro->__SET('ProdServ_Id', $_POST['idProdServ']);
        $this->prodserv_model->Eliminar($pro);
        echo '<script type="text/javascript">window.location="?c=Productos&a=Index";</script>';
    }

    public function AnularMovimiento()
    {
        $mov = new Movimiento();
        $mov->__SET('OrdenCompra_Id', $_POST['IdMovimiento']);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $this->ordencompra_model->Eliminar($mov);
        echo '<script type="text/javascript">window.location="?c=OrdenCompra&a=Index";</script>';
    }

    public function CerrarOrden()
    {
        $mov = new Movimiento();
        $mov->__SET('OrdenCompra_Id', $_POST['IdMovimiento']);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $this->ordencompra_model->CerrarOrden($mov);
        echo '<script type="text/javascript">window.location="?c=OrdenCompra&a=Index"</script>';
    }

    public function ObtenerID($ProdServ_Id)
    {
        foreach ($this->prodserv_model->Buscar($ProdServ_Id) as $p) {
            return $p->__GET('nProSrvUnidad_Id');
        }
    }

    public function CalcularImpTotIGV()
    {
        $dMovICBPER = 0;
        // $importe = 0;
        $dMovImporte = 0;
        $dMovIGV = 0;

        $total = 0;
        $IGV = 0;
        $isItem = 'false';
        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = 0.18;
                }
                /*else {
            $IGV = 1.18;
            }*/
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            if (count($data) > 0) {
                for ($i = 0; $i < count($data); $i++) {

                    $dMovImporte += $data[$i]['nOCDConSubtotal'];

                    if (isset($data[$i]['nProSrvExoneradoIGV']) && $data[$i]['nProSrvExoneradoIGV'] == 0) {

                        $dMovIGV += $data[$i]['nOCDConSubtotal'] * $IGV;
                    } else {

                        $dMovIGV += 0;
                    }

                    if (isset($data[$i]['nProSrvICBPer']) && $data[$i]["nProSrvICBPer"] === "1") {
                        $dMovICBPER += $this->calcularICBPER($data[$i]['sOCDConCantidad']);
                    }
                }
                $isItem = 'true';
            } else {
                $isItem = 'false';
            }
        }


        $dMovIGV = isset($_SESSION['usu_enterpriseExoneratedIGV']) && $_SESSION['usu_enterpriseExoneratedIGV'] == 1 ? 0 : $dMovIGV;

        /* echo "<script type='text/javascript'>
                    document.getElementById('dMovImporte').value = '" . number_format($dMovImporte, 2, ".", ",") . "';
                    document.getElementById('dMovIGV').value = '" . number_format($dMovIGV, 2, ".", ",") . "';
                    document.getElementById('dMovICBPER').value = '" . number_format($dMovICBPER, 2, ".", ",") . "';
                    document.getElementById('dMovTotal').value = '" . number_format(($dMovImporte + $dMovIGV + $dMovICBPER), 2, ".", ",") . "';
                    document.getElementById('TipoOrdenCompra_Id').disabled = $isItem;
                    document.getElementById('nMovTipodestino').disabled = $isItem;
                </script>"; */
        echo "<script type='text/javascript'>
                document.getElementById('dOCImporte').value = '" . number_format($dMovImporte, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dOCIGV').value = '" . number_format($dMovIGV, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dOCICBPER').value = '" . number_format($dMovICBPER, $this->DECIMALES, ".", ",") . "';
                document.getElementById('dOCTotal').value = '" . number_format(($dMovImporte + $dMovIGV + $dMovICBPER), $this->DECIMALES, ".", ",") . "';
                document.getElementById('Tipomovimiento_Id').disabled = $isItem;
                document.getElementById('nOCTipodestino').disabled = $isItem;
            </script>";
    }

    public function CalcularImpTotIGV_venta()
    {
        $importe = 0;
        $total = 0;
        $IGV = 1;

        $documento = $this->documento_model->Buscar($_POST['Documento_Id'] != "" ? $_POST['Documento_Id'] : '0');
        if (count($documento) > 0) {
            foreach ($documento as $doc) {
                if ($doc->__GET('nDocAfectoIGV') == 1) {
                    $IGV = $this->IGV;
                }
            }
        }
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            for ($i = 0; $i < count($data); $i++) {
                $importe = $importe + $data[$i]['nOCDConSubtotal'];
            }
        }
        echo "<script type='text/javascript'>
                    document.getElementById('dPedImporte').value = '" . number_format($importe, $this->DECIMALES) . "';
                    document.getElementById('dPedIGV').value = '" . number_format(($importe * $IGV - $importe), $this->DECIMALES) . "';
                    document.getElementById('dPedTotal').value = '" . number_format(($importe * $IGV), $this->DECIMALES) . "';
                </script>";
    }

    public function UnidadNombre($Unidadmedida_Id)
    {
        $dato = $this->unidadmedida_model->Buscar($Unidadmedida_Id);
        foreach ($dato as $d) {
            return $d->__GET('sUndAlias');
        }
    }

    public function ProdservdNombre($ProdServ_Id)
    {
        $data = $this->prodserv_model->Buscar($ProdServ_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sProSrvNombre');
        }
    }

    public function DocNombre($Documento_Id)
    {
        $data = $this->documento_model->Buscar($Documento_Id);
        foreach ($data as $doc) {
            return $doc->__GET('sDocNombre');
        }
    }
    public function AlmNombre($Almacen_Id)
    {

        $data = $this->almacen_model->Buscar($Almacen_Id);
        foreach ($data as $alm) {
            return $alm->__GET('sAlmNombre');
        }
    }
    public function DetruirSessiones()
    {
        unset($_SESSION['producto_c']);
    }

    public function PDFMovimiento()
    {
        $movimiento = $this->movimiento_model->Buscar($_POST['PDFMOrdenCompra_Id']);
        $detalle_movimiento = $this->Detalles($movimiento[0]->OrdenCompra_Id);
        require_once 'view/webforms/PDF/movimiento.php';
    }
    public function act_obs_docref()
    {

        $mov = new Movimiento();
        if ($_POST['OrdenCompra_Id'] != 0 ? $mov->__SET('OrdenCompra_Id', $_POST['OrdenCompra_Id']) : '');
        $mov->__SET('sMovDocReferencia', $_POST['sMovDocReferencia']);
        $mov->__SET('sMovObservacion', $_POST['sMovObservacion']);
        if ($_POST['OrdenCompra_Id'] != 0) {
            $this->movimiento_model->act_obs_docref($mov);
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }

    public function Detalles($OrdenCompra_Id)
    {
        $detalle_movimiento = $this->movimientodetalle_model->Buscar($OrdenCompra_Id);
        $result = '';
        foreach ($detalle_movimiento as $detmov) :
            $result .= '<tr>';
            $result .= '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
            $result .= '<td>' . $detmov->__GET('nOCDCantidad') . '</td>';
            $result .= '<td>' . $this->UnidadNombre($detmov->__GET('nOCDUnidad_Id')) . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nOCDPrecioUnitario'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '<td>' . number_format($detmov->__GET('nOCDImporte'), $this->DECIMALES, ".", ".") . '</td>';
            $result .= '</tr>';
        endforeach;
        return $result;
    }

    public function ImprimirTicket()
    {
        $parametro = $_GET['Movimiento'];
        //$comando = 'start /d "C:\STC R2\" start "" "C:\STC R2\STCCFD.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando = 'start /d "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\" start "" "C:\xampp\htdocs\clubpacasmayo\view\librerias\dist\print\PrintVale.exe" ' . $parametro . ' /SEPARATE /WAIT /I && exit';
        $comando_escapado = escapeshellcmd($comando);
        exec($comando_escapado, $resultadoSalida, $ejecucion);
        if ($ejecucion > 0) {
            echo 'Ocurrio un problema en la impresion.';
        } else {
            echo 'La impresion se realizo correctamente gracias.';
        }
        echo '<script type="text/javascript">setTimeout(function(){window.close();}, 3000)</script>';
    }
    public function Previsualizacion()
    {
        $movimiento = $this->movimiento_model->Buscar($_POST['OrdenCompra_Id']);
        $data = array();
        $mov = "<table class='table table-hover table-bordered'>";
        foreach ($movimiento as $r) :
            $mov .= "<tr>";
            $mov .= "<td>Fecha: <input type='hidden' id='nDocTipoImprimir' name='nDocTipoImprimir' value='" . $r->__GET('nDocTipoImprimir') . "'></td>";
            $mov .= "<td>" . $r->__GET('dMovFecha') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Hora: </td>";
            $mov .= "<td>" . date('h:i a', strtotime($r->__GET('dMovFecha_Act'))) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo Movimiento: </td>";
            $mov .= "<td>" . $r->__GET('sTMovNombre') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo Pago: </td>";
            $mov .= "<td>" . ($r->__GET('nMovTipopago') == 1 ? 'Contado' : 'Credito') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo: </td>";
            $mov .= "<td>" . ($r->__GET('nMovTipoOrigenDestino') == 1 ? 'Proveedor' : 'Cliente') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Cliente/Proveedor:</td>";
            $mov .= "<td>" . $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Dirección:</td>";
            $mov .= "<td>" . $this->DireccionClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>RUC/DNI:</td>";
            $mov .= "<td>" . $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Ubigeo:</td>";
            $mov .= "<td>" . $this->UbigeoNombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Destino:</td>";
            $mov .= "<td>" . ($r->__GET('nMovTipodestino') == 1 ? 'Almacen' : 'Consumo') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Almacen:</td>";
            $mov .= "<td>" . $this->AlmNombre($r->__GET('Almacen_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Documento:</td>";
            $mov .= "<td>" . $this->DocNombre($r->__GET('Documento_Id')) . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Nro. Documento:</td>";
            $mov .= "<td>" . $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Documento referencia:</td>";
            $mov .= "<td>" . $r->__GET('sMovDocReferencia') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Tipo de moneda:</td>";
            $mov .= "<td>" . ($r->__GET('Moneda_Id') == 1 ? 'Soles' : 'Dolares') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td>Observación:</td>";
            $mov .= "<td>" . $r->__GET('sMovObservacion') . "</td>";
            $mov .= "</tr>";
            $mov .= "<tr>";
            $mov .= "<td colspan='2'>";
            $mov .= "<table class='table table-hover table-bordered'>";
            $mov .= "<thead>";
            $mov .= "<tr>";
            $mov .= "<th>Producto</th>";
            $mov .= "<th>Cantidad</th>";
            $mov .= "<th>Unidad</th>";
            $mov .= "<th>Precio</th>";
            $mov .= "<th>Sub Total</th>";
            $mov .= "</tr>";
            $mov .= "</thead>";
            $mov .= "<tbody>";
            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('OrdenCompra_Id'));
            foreach ($detalle_movimiento as $detmov) :
                $mov .= '<tr>';
                $mov .= '<td>' . $detmov->__GET('sProSrvNombre') . '</td>';
                $mov .= '<td>' . $detmov->__GET('nOCDCantidad') . '</td>';
                $mov .= '<td>' . $this->UnidadNombre($detmov->__GET('nOCDUnidad_Id')) . '</td>';
                $mov .= '<td style="text-align: right;">' . number_format($detmov->__GET('nOCDPrecioUnitario'), $this->DECIMALES, ".", ".") . '</td>';
                $mov .= '<td style="text-align: right;">' . number_format($detmov->__GET('nOCDImporte'), $this->DECIMALES, ".", ".") . '</td>';
                $mov .= '</tr>';
            endforeach;
            $mov .= '<tr><td style="text-align: right;" colspan="4">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nMovImporte'),$this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '<tr><td style="text-align: right;" colspan="4">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nMovIGV'), $this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '<tr><td style="text-align: right;" colspan="4">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nMovTotal'), $this->DECIMALES, ".", ".") . '</td></tr>';
            $mov .= '</tbody>';
            $mov .= '</table>';
            $mov .= '</td>';
            $mov .= '</tr>';
            $mov .= "</table>";
        endforeach;

        $print_force = null;
        $OrdenCompra_Id = $_POST['OrdenCompra_Id'];
        $importe = number_format($r->__GET('nMovTotal'), $this->DECIMALES);

        $pagoenefectivo = (bool)$this->parametro_model->obtenerParametro(17)['sParValor'];
        $Documento_Id = $r->__GET('Documento_Id');
        $doc = $this->documento_model->Numero($Documento_Id);

        if($_SESSION['usu_enterpriseIsFE'] && $doc->isFE && $pagoenefectivo && $r->__GET('nMovTipopago')==1){
            $print_force = sprintf('forcePago("%s","%s")',$OrdenCompra_Id,$importe);
        }
        
        require_once 'view/webforms/wfamovimientov.php';
    }
    private function enviarcomprobanteautomatico($OrdenCompra_Id)
    {
        return $this->electronic_controller->Transaction($OrdenCompra_Id);
    }
    public function enviarcomprobante()
    {
        echo $this->electronic_controller->Transaction($_REQUEST['OrdenCompra_Id']);
    }
    public function comprobante()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['OrdenCompra_Id']);

        $r = $movimiento[0];
        $detalle = $this->movimientodetalle_model->getByMovimientoId($r->__GET('OrdenCompra_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[15]->__GET('sParValor'));
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];
        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/comprobanteelectronico.php';
    }
    
    public function comprobante2()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['OrdenCompra_Id']);

        $r = $movimiento[0];
        $detalle = $this->movimientodetalle_model->getByMovimientoId($r->__GET('OrdenCompra_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[15]->__GET('sParValor'));
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/comprobanteelectronico2.php';
    }

    public function comprobantePDF()
    {
        $movimiento = $this->movimiento_model->Buscar($_REQUEST['OrdenCompra_Id']);

        //print_r($movimiento);print_r($_SESSION);

        $r = $movimiento[0];
        $detalle_movimiento = $this->movimientodetalle_model->getByMovimientoId($r->__GET('OrdenCompra_Id'));
        $observacion = $r->__GET('sMovObservacion');
        $detraccion = $this->parametro_model->obtenerParametro(6)['sParValor'];
        $cuenta_bn = $_SESSION['usu_enterpriseCTADetraccion'];
        $decimales = $this->parametro_model->obtenerParametro(14)['sParValor'];
        $parametro = $this->parametro_model->ListarParametros();
        // $valor = explode('|', $parametro[16]->__GET('sParValor'));
        $valor = $this->parametro_model->obtenerParametro(16)['sParValor'];
        $pagos_movimiento = $this->movimiento_model->BuscarPagos($r->__GET('OrdenCompra_Id'));


        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '03',
            $r->sDocNombreCorto,
            $r->sMovDocumento,
            $r->nMovIGV,
            $r->nMovTotal,
            date('Y-m-d', strtotime($r->dMovFecha)),
            '6',
            $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
            ''
        );

        require_once 'view/webforms/PDF/ecomprobante2.php';
    }

    public function getByDocumento()
    {
        $movimiento = $this->movimiento_model->getByDocumento($_REQUEST['documento']);
        if ($movimiento) {
            $movimiento['detalle'] = $this->movimientodetalle_model->getByMovimientoId($movimiento['OrdenCompra_Id']);
        }
        echo json_encode($movimiento);
    }
    /**
     * Registrar array de movimientos function
     *
     * @return void
     */
    public function GuardarMovimientoAll()
    {
        $movmientosList = json_decode($_REQUEST['movimientos']);
        $index = 0;
        foreach ($movmientosList as $item) {
            $documento = $this->documento_model->Numero($item->Documento_Id);
            if ($documento->nDocNomAutomatico == 0) {
                http_response_code(StatusCodes::HTTP_PRECONDITION_FAILED);
                echo json_encode(["message" => "Se presento un problema al obtener el documento"]);
                exit();
            }
            if ($this->validar_documento($item)) {
                $OrigenDestino_Id = $this->registrar_cliente($item);
                if ($OrigenDestino_Id != null) {
                    $movmientosList[$index]->status = 'CLIENT_REGISTERED';
                } else {
                    $origenDestino = $this->origendestino_model->getByDocument($item->RUC_DNI);
                    $OrigenDestino_Id = $origenDestino->OrigenDestino_Id;
                }
                $mov = new Movimiento();
                $mov->__SET('dMovFecha', $item->dMovFecha);
                $mov->__SET('nMovTipoOrdenCompra_Id', $item->TipoOrdenCompra_Id);
                $mov->__SET('nMovTipopago', $item->nMovTipopago);
                $mov->__SET('Almacen_Id', $item->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $item->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $OrigenDestino_Id); // cliente
                $mov->__SET('nMovTipodestino', $item->nMovTipodestino);
                $mov->__SET('Documento_Id', $item->Documento_Id);
                $mov->__SET('sMovDocumento', $documento->sDocSiguiente);
                $mov->__SET('sMovDocReferencia', "");
                $mov->__SET('Moneda_Id', $item->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $item->nMovTipoCambio);
                $mov->__SET('nMovImporte', str_replace(",", "", $item->dMovImporte));
                $mov->__SET('nMovIGV', str_replace(",", "", $item->dMovIGV));
                $mov->__SET('nMovTotal', str_replace(",", "", $item->dMovTotal));
                $mov->__SET('nMovSaldo', str_replace(",", "", $item->dMovTotal));
                $mov->__SET('nMovTotalCancelado', $item->nMovTipopago == 1 ? str_replace(",", "", $item->dMovTotal) : '0');
                $mov->__SET('dOCDraccion', $item->dOCDraccion);
                $mov->__SET('dMovPercepcion', $item->dMovPercepcion);
                $mov->__SET('dMovRetencion', $item->dMovRetencion);
                $mov->__SET('sMovObservacion', $item->sMovObservacion);
                $mov->__SET('nMovEstado', $item->nMovTipopago == 1 ? '2' : '1');
                $mov->__SET('nMovEliminado', 0);
                $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                $mov->__SET('nMovVendedor_Id', $item->nMovVendedor_Id);
                $mov->__SET('dMovICBPER', 0);
                $OrdenCompra_Id = $this->movimiento_model->Guardar($mov);
                if ($OrdenCompra_Id > 0) {
                    $movmientosList[$index]->id = $OrdenCompra_Id;
                    if ($movmientosList[$index]->status == "") {
                        $movmientosList[$index]->status = 'MOVEMENT_REGISTERED';
                    }
                    foreach ($item->deail as $prod) {
                        $movdet = new Movimientodetalle();
                        $movdet->__SET('OrdenCompra_Id', $OrdenCompra_Id);
                        $movdet->__SET('TipoOrdenCompra_Id', $prod->TipoOrdenCompra_Id);
                        $movdet->__SET('TipoDestino', $prod->TipoDestino);
                        $movdet->__SET('ProdServ_Id', $prod->ProdServ_Id);
                        $movdet->__SET('Almacen_Id', $prod->Almacen_Id);
                        // $movdet->__SET('Lote', $prod->Lote != 0 ? $prod->Lote : date('Ymdhis'));
                        $movdet->__SET('Lote', $prod->Lote != 0 ? $prod->Lote : '202001'); //un solo lote
                        $movdet->__SET('FechaVencimiento', ''); // pendiente
                        $movdet->__SET('Cantidad', $prod->Cantidad);
                        $movdet->__SET('Unidad_Id', $prod->Unidad_Id); // default UND = 2
                        $movdet->__SET('MonedaCompra_Id', $prod->MonedaCompra_Id);
                        $movdet->__SET('PrecioLista', $prod->PrecioLista);
                        $movdet->__SET('Descuento', 0);
                        $movdet->__SET('Precio', $prod->Precio);
                        $movdet->__SET('SubTotal', $prod->SubTotal);
                        $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                        $movdet->__SET('TipoCambio', $prod->TipoCambio);
                        $movdet->__SET('nOCDIncluyeIgv', $prod->nOCDIncluyeIgv);
                        $this->movimientodetalle_model->Guardar($movdet);
                    }
                    // $this->documento_model->Incrementa($item->Documento_Id);
                    
                    // guardamos los importes que se ingresaron en el calendario, al seleccionar crédito

                    if ($item->nMovTipopago == 2) { // si es al crédito
                        $param = 30;
                        $this->movimiento_model->GuardarPago(
                            $OrdenCompra_Id,
                            1,
                            str_replace(",", "", $item->dMovTotal),
                            date('Y-m-d', strtotime($item->dMovFecha . "+ $param days"))
                        );
                    }
                } else {
                    if ($movmientosList[$index]->status == "") {
                        $movmientosList[$index]->status = 'MOVEMENT_NOT_REGISTERED';
                    }
                }
            } else {
                $movmientosList[$index]->status = 'INVALID_DOCUMENT';
            }
            $index++;
        }
        echo json_encode($movmientosList);
    }
    /**
     * Registrar cliente por movimientos function
     *
     * @param [type] $movimiento
     * @return void
     */
    public function registrar_cliente($movimiento)
    {
        $doc = $this->origendestino_model->validar($movimiento->RUC_DNI, 0);
        if ($doc['status'] === true) {
            $pro = new Origendestino();
            $pro->__SET('nODTipo', 2);
            $pro->__SET('sODRucDni', $movimiento->RUC_DNI);
            $pro->__SET('sODNombre', $movimiento->NOMBRE);
            $pro->__SET('sODNombreComercial', $movimiento->NOMBRE);
            $pro->__SET('sODDireccion', "");
            $pro->__SET('sODTelefono', "");
            $pro->__SET('sODCorreo', "");
            $pro->__SET('sODContacto', "");
            $pro->__SET('nODDiasCredito', "");
            $pro->__SET('nProcliDepId', "");
            $pro->__SET('nProcliDepName', "");
            $pro->__SET('nProcliProvId', "");
            $pro->__SET('nProcliProvName', "");
            $pro->__SET('nProcliDistId', "");
            $pro->__SET('nProcliDistName', "");
            $pro->__SET('nODEstado', 1);
            $pro->__SET('nODEliminado', 0);
            $pro->__SET('nODUsuario_Id', $_SESSION['usu_codigo']);
            return $this->origendestino_model->Crear($pro);
        }
        return null;
    }
    /**
     * Validar documento function
     *
     * @param [type] $movimiento
     * @return void
     */
    public function validar_documento($movimiento)
    {
        $documento = $movimiento->RUC_DNI;
        /**
         * Validar si es solo dni
         */
        if (strlen($documento) == 8) {
            return true;
        }
        /**
         * Validar si es ruc
         */
        if (strlen($documento) == 11) {
            return true;
        }
        /**
         * si el documento no tiene el tamaño
         * de dni o ruc no es valido
         */
        return false;
    }
    /**
     * Calcular ICBPER function
     *
     * @param [type] $value
     * @param [type] $cantidad
     * @return void
     */
    // function calcularICBPER($value, $cantidad) {
    //     return ($value * $this->ICBPER) * $cantidad;
    // }
    function calcularICBPER($cantidad)
    {
        return ($this->ICBPER) * $cantidad;
    }

    public function AgregarProductoX()
    {
        $data = array();
        if ($_POST['nIncluyeIGV'] == 1) {
            $nOCDConPrecioUnitario = $_POST['nOCDConPrecioUnitario'] / $this->IGV;
        } else {
            $nOCDConPrecioUnitario = $_POST['nOCDConPrecioUnitario'];
        }
        $array = array(
            "ProdServ_Id" => isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : '0',
            "lotes" => isset($_POST['lotes']) ? $_POST['lotes'] : '0',
            "Almacen_Id" => $_POST['Almacen_Id'],
            "sOCDConCantidad" => $_POST['sOCDConCantidad'],
            "Unidadmedida_Id" => $_POST['Unidadmedida_Id'],
            "dOCDConFechaVencimiento" => isset($_POST['dOCDConFechaVencimiento']) ? $_POST['dOCDConFechaVencimiento'] : date('d-m-Y'),
            "nOCDConPrecioUnitario" => round($nOCDConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP),
            "nOCDConSubtotal" => round($nOCDConPrecioUnitario, $this->DECIMALES, PHP_ROUND_HALF_UP) * $_POST['sOCDConCantidad'],
            "nProSrvExoneradoIGV" => $_POST['nProSrvExoneradoIGV'],
            "nProSrvICBPer" => $_POST['nProSrvICBPer']
        );
        if (isset($_SESSION['producto_c'])) {
            $data = $_SESSION['producto_c'];
            array_push($data, $array);
        } else {
            $data[] = $array;
        }
        $_SESSION['producto_c'] = $data;
        return true;
    }
    private function forceAddProductC($lotes,$ProdServ_Id,$Almacen_Id,$Unidadmedida_Id,$sOCDConCantidad,$nOCDConPrecioUnitario,$nIncluyeIGV,$nProSrvExoneradoIGV,$nProSrvICBPer){
        $x = array(
            'lotes' => $lotes,
            'ProdServ_Id' => $ProdServ_Id,
            'Almacen_Id' => $Almacen_Id,
            'Unidadmedida_Id' => $Unidadmedida_Id,
            'sOCDConCantidad' => (double)$sOCDConCantidad,
            'nOCDConPrecioUnitario' => number_format($nOCDConPrecioUnitario,$this->DECIMALES),
            'nOCDConSubtotal' => number_format($sOCDConCantidad*$nOCDConPrecioUnitario,$this->DECIMALES),
            'nIncluyeIGV' => $nIncluyeIGV,
            'nProSrvExoneradoIGV' => $nProSrvExoneradoIGV,
            'nProSrvICBPer' => $nProSrvICBPer
        );
        $_POST = array();
        $_POST = $x;
        $this->AgregarProductoX();
    }

    public function PromoverCotizacion()
    {
        $this->DetruirSessiones();
        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();

        $ptipomovimiento = null;
        $pbienes = null;
        $pobservacion = null;
        $ptipopago = null;
        $ptipodocumento = null;

        foreach ($parametro as $r) {
            if ($r->__GET('Parametro_Id') == 3) {
                $ptipomovimiento = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 4) {
                $pbienes = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 5) {
                $pobservacion = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 7) {
                $ptipopago = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 8) {
                $ptipodocumento = $r->__GET('sParValor');
            }
        }

        $cotizacion = $this->cotizacion_model->Buscar($_POST['OrdenCompra_Id'])[0];

        $detalle_cotizacion = $this->cotizaciondetalle_model->Buscar($cotizacion->__GET('OrdenCompra_Id'));
        //print_r($detalle_cotizacion);die();
        if(!empty($detalle_cotizacion)){
            foreach($detalle_cotizacion as $dc){
                $lote = $this->cotizaciondetalle_model->BuscarLote($cotizacion->Almacen_Id,$dc->prodserv_Id);
                //print_r($lote);die();
                $this->forceAddProductC(@$lote->sProLNombreLote, $dc->prodserv_Id,$cotizacion->Almacen_Id,$dc->nOCDUnidad_Id,$dc->nOCDCantidad,$dc->nOCDPrecioUnitario,$dc->nOCDIncluyeIGV,$dc->nProSrvExoneradoIGV,$dc->dOCDICBPER);
            }
        }

        $mov = new Movimiento();
        $mov->__SET('OrdenCompra_Id','0');
        $mov->__SET('nro_decimales','');
        $mov->__SET('dMovFecha',date('d-m-Y'));
        $mov->__SET('nMovTipoOrdenCompra_Id',2);//$ptipomovimiento);
        $mov->__SET('nMovTipopago',$cotizacion->__get('nMovTipopago'));
        $mov->__SET('nMovTipoOrigenDestino',$cotizacion->__get('nMovTipoOrigenDestino'));
        $mov->__SET('nMovOrigenDestino_Id',$cotizacion->__get('nMovOrigenDestino_Id'));
        $mov->__SET('nMovTipodestino',$cotizacion->__get('nMovTipodestino'));
        $mov->__SET('Almacen_Id',$cotizacion->__get('nMovTipodestino'));
        $mov->__SET('Documento_Id',$ptipodocumento);
        $mov->__SET('sMovDocReferencia',$cotizacion->__get('Documento'));
        $mov->__SET('nDocAfectoIGV',$cotizacion->__get('nDocAfectoIGV'));
        $mov->__SET('Moneda_Id',$cotizacion->__get('Moneda_Id'));
        $mov->__SET('nMovTipoCambio',$cotizacion->__get('nMovTipoCambio'));
        $mov->__SET('nMovImporte',$cotizacion->__get('nMovImporte'));
        $mov->__SET('nMovIGV',$cotizacion->__get('nMovIGV'));
        $mov->__SET('nMovTotal',$cotizacion->__get('nMovTotal'));
        $mov->__SET('nMovSaldo',$cotizacion->__get('nMovSaldo'));
        //$mov->__SET('nMovVendedor_Id',$cotizacion->__get('nMovVendedor_Id'));
        $mov->__SET('vendedor_id',$cotizacion->__get('vendedor_id'));
        $mov->__SET('dOCDraccion',$cotizacion->__get('dOCDraccion'));
        $mov->__SET('dMovPercepcion',$cotizacion->__get('dMovPercepcion'));
        $mov->__SET('dMovRetencion',$cotizacion->__get('dMovRetencion'));
        $mov->__SET('sMovObservacion',$cotizacion->__get('sMovObservacion'));
        $r = $mov;

        $promovido = true;
        $promovido_fecha_credito = '';
        $promovido_importe = 0;

        if($cotizacion->__get('nMovTipopago')==2){
            $cliente = $this->origendestino_model->Buscar($cotizacion->__get('nMovOrigenDestino_Id'));
            $dias_credito = $cliente[0]->nODDiasCredito;
            $fecha_emision = date('Y-m-d');
            $fecha_vencimiento = date('Y-m-d',strtotime(sprintf('%s +%sdays',$fecha_emision,$dias_credito)));
            $promovido_fecha_credito = date('d-m-Y',strtotime($fecha_vencimiento));
            $promovido_importe = $cotizacion->__get('nMovTotal');
        }

        require_once 'view/webforms/wfaordencompraa.php';
    }
}
