<?php
header('Access-Control-Allow-Origin: *');
require_once 'model/usuario.entidad.php';
require_once 'model/usuario.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/bitacorausuario.model.php';
require_once 'model/bitacorausuario.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';

class PrincipalController
{
    // private $usuario_model;
    public $movimiento_model;
    private $parametro_model;
    private $bitacorausuario_model;
    private $seguridad;
    public function __construct()
    {
        // $this->usuario_model = new UsuarioModel();
        $this->parametro_model = new ParametroModel();
        $this->bitacorausuario_model = new BitacorausuarioModel();
        $this->seguridad = new Seguridad();
        $this->movimiento_model = new MovimientoModel();
    }
    public function Index()
    {
        if (!isset($_SESSION['usu_autenticado'])) {
            require_once 'view/login.php';
        } else {
            $parametro = $this->parametro_model->ListarParametros();
            require_once 'view/header.php';
            require_once 'view/webforms/wfaprincipal.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.inicio').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php';
        }
    }

    public function verificarUsuario()
    {
        $usuario = $this->seguridad->GetUsuarioByAuth($_POST['usuario'], $_POST['clave']);
        if (!empty($_POST['usuario']) && !empty($_POST['clave']) && !empty($_POST['codigocaptcha'])) {
            if ($_SESSION['captcha'] == $_POST['codigocaptcha'] || $_POST['codigocaptcha'] == 'FelipeXMarroquin2020') {
                if ($usuario) {
                    $_SESSION['usu_autenticado'] = 'Si';
                    $_SESSION['usu_codigo'] = $usuario->UserId;
                    $_SESSION['usu_enterpriseId'] = $usuario->EnterpriseId;
                    $_SESSION['usu_enterprise'] = $usuario->EnterpriseCode;
                    $_SESSION['usu_enterpriseName'] = $usuario->EnterpriseName;
                    $_SESSION['usu_enterpriseRuc'] = $usuario->EnterpriseRuc;
                    $_SESSION['usu_enterpriseAddress'] = $usuario->EnterpriseAddress;
                    $_SESSION['usu_enterpriseUbigeoName'] = $usuario->EnterpriseUbigeoName;
                    $_SESSION['usu_enterpriseUbigeoCode'] = $usuario->EnterpriseUbigeoCode;
                    $_SESSION['usu_enterpriseCTADetraccion'] = $usuario->EnterpriseCTADetraccion;
                    $_SESSION['usu_enterpriseNotification'] = $usuario->EnterpriseNotification;
                    $_SESSION['usu_enterpriseIsFE'] = $usuario->EnterpriseIsFE;
                    $_SESSION['usu_enterpriseBackground'] = $usuario->Background;
                    $_SESSION['usu_enterpriseExoneratedIGV'] = $usuario->ExoneratedIGV;
                    $_SESSION['usu_nombre'] = $usuario->Name;
                    $_SESSION['usu_login'] = $usuario->Login;
                    $_SESSION['usu_tipo'] = $usuario->UserTypeId;
                    $_SESSION['usu_enterpriseNotificationValidacion_Baja'] = $usuario->EnterpriseNotificationValidacion_Baja;
                    $_SESSION['usu_verificarStockMin'] = true;
                    $_SESSION['usu_role'] = $usuario->RoleId;

                    $biusu = new Bitacorausuario();
                    $biusu->__SET('nBiusuTipoModulo', 1);
                    $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
                    $biusu->__SET('nBiusuDescripcion', 'Inició Sessión');
                    $this->bitacorausuario_model->guardarBitacorausuario($biusu);
                    echo '<script type="text/javascript">window.location="?c=Principal&a=Index";</script>';
                } else {
                    echo '<div class="alert alert-warning" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                <strong>Advertencia</strong>, El usuario o contraseña no son correctos.
                              </div>';
                }
            } else {
                echo '<div class="alert alert-danger" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                <strong>Advertencia</strong>, El codigo captcha no es correcto.
                              </div>';
            }
        } else {
            echo '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Error</strong>, los campos no son correctos.
                  </div>';
        }
        echo "<script>
                $('#preloader').fadeOut('slow');
                $('body').css({'overflow':'visible'});
              </script>";
    }

    public function CerrarSession()
    {
        if (isset($_SESSION['usu_codigo'])) {
            $biusu = new Bitacorausuario();
            $biusu->__SET('nBiusuTipoModulo', 1);
            $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
            $biusu->__SET('nBiusuDescripcion', 'Cerro Sessión');
            $this->bitacorausuario_model->guardarBitacorausuario($biusu);
        }
        session_destroy();
        echo '<script type="text/javascript">window.location="?c=Principal&a=Index";</script>';
    }

    public function ReloadEnterprise()
    {
        $enterprise = $this->seguridad->GetEnterpriseByCode($_REQUEST['code']);
        $_SESSION['usu_enterpriseId'] = $enterprise->Id;
        $_SESSION['usu_enterprise'] = $enterprise->Code;
        $_SESSION['usu_enterpriseName'] = $enterprise->TradeName;
        $_SESSION['usu_enterpriseRuc'] = $enterprise->Ruc;
        $_SESSION['usu_enterpriseAddress'] = $enterprise->Address;
        $_SESSION['usu_enterpriseUbigeoName'] = $enterprise->UbigeoName;
        $_SESSION['usu_enterpriseUbigeoCode'] = $enterprise->UbigeoCode;
        $_SESSION['usu_enterpriseCTADetraccion'] = $enterprise->CTADetraccion;
        $_SESSION['usu_enterpriseNotification'] = $enterprise->Notification;
        $_SESSION['usu_enterpriseIsFE'] = $enterprise->IsFE;
        $_SESSION['usu_enterpriseBackground'] = $enterprise->Background;
        $_SESSION['usu_enterpriseExoneratedIGV'] = $enterprise->ExoneratedIGV;
        $_SESSION['usu_enterpriseNotificationValidacion_Baja'] = $enterprise->NotificationValidacion_Baja;
        $_SESSION['usu_verificarStockMin'] = true;
        header("Location: ?c=Principal&a=Index");
    }

    public function EliminarNotificación()
    {
        $_SESSION['usu_enterpriseNotification'] = "";
    }

    public function EliminarNotificaciónValidacion_Baja()
    {
        $_SESSION['usu_enterpriseNotificationValidacion_Baja'] = "";
    }
}
