<?php

use ICanBoogie\DateTime;

date_default_timezone_set('America/Lima');
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/reportes.entidad.php';
require_once 'model/reportes.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/origendestino.model.php';
//CLASE CON FUNCIONES PARA REPORTE EN EXCEL
require_once 'ClassExcel.php';
//LIBRERIA DE EXCEL
require_once 'view/librerias/PHPExcel/PHPExcel.php';

class ReportesController extends ClassExcel
{

    private $reportes_model;
    private $prodserv_model;
    private $parametro_model;
    private $origendestino_model;
    public $tipomovimiento_model;
    public $objPHPExcel;
    private $seguridad;

    public function __CONSTRUCT()
    {
        $this->reportes_model = new ReportesModel();
        $this->prodserv_model = new ProdservModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->parametro_model = new ParametroModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->objPHPExcel = new PHPExcel();
        $this->seguridad = new Seguridad();
    }

    public function Master()
    {
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrmaster.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }



    public function Stock()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $reportes = $this->reportes_model->Stock();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrstock.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Kardex()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $productos = $this->prodserv_model->Listar();

        $prodserv = isset($_POST['ProdServ_Id']) ? $_POST['ProdServ_Id'] : 0;
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');

        $reportes = $this->reportes_model->Kardex($prodserv, $fechaIni, $fechaFin);

        require_once 'view/header.php';
        require_once 'view/webreport/wfrkardex.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Reporte_Tiempos()
    {
        $parametro = $this->parametro_model->ListarParametros();

        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');

        $reportes = $this->reportes_model->Reporte_Tiempos($fechaIni, $fechaFin);


        require_once 'view/header.php';
        require_once 'view/webreport/wfreportetiempos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function VentaDetallada()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->VentaDetallada($fechaIni, $fechaFin);

        require_once 'view/header.php';
        require_once 'view/webreport/wfrventadetallada.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Stock_Excel()
    {
        $data = $_POST['data'];
        $this->SetPropiedades(["CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "REPORTE DE STOCK", "REPORTE DE STOCK"]);
        $this->SetTitulo("A1:G1", "A1", "REPORTE DE STOCK DEL " . date('d/m/Y H:m'));
        $this->HeaderCell(2, ["CODIGO", "FAMILIA", "PRODUCTO/SERVICIO", "STOCK", "UNIDAD", "PRECIO", "VALORIZADO"]);
        $this->Style_Titulo(count($data), range('A', 'G'));
        //        $this->AjustarTextoCell('A2:G2');
        $this->AjustarColumnCell(range('A', 'G'));

        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', 'G'));

        $this->WriteFormat('view/librerias/dist/excel/stock.xlsx');
    }

    public function Kardex_Excel()
    {
        $data = $_POST['data'];
        $this->SetPropiedades(["CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "REPORTE DE KARDEX", "REPORTE DE KARDEX"]);
        $this->SetTitulo("A1:N1", "A1", "REPORTE DE KARDEX DEL " . date('d/m/Y', strtotime($_POST['fechaInicio'])) . " AL " . date('d/m/Y', strtotime($_POST['fechaFin'])));
        $this->HeaderCell(2, ["FECHA HORA", "TIPO MOVIMIENTO", "ALMACEN", "DOCUMENTO", "FECHA DOCUMENTO", "ORIGEN/DESTINO", "ESTADO", "LOTE", "CANTIDAD", "UNIDAD", "SALDO ANTERIOR LOTE", "SALDO POSTERIOR LOTE", "SALDO ANTERIOR", "SALDO POSTERIOR"]);
        $this->Style_Titulo(count($data), range('A', 'N'));
        //        $this->AjustarTextoCell('A2:N2');
        $this->AjustarColumnCell(range('A', 'N'));
        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', 'N'));

        $this->WriteFormat('view/librerias/dist/excel/kardex.xlsx');
    }

    public function VentaDetallada_Excel()
    {
        $data = $_POST['data'];
        $this->SetPropiedades(["CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "REPORTE DE VENTAS DETALLADAS", "VENTAS DETALLADAS"]);
        $this->SetTitulo("A1:N1", "A1", "VENTAS DETALLADAS DEL " . date('d/m/Y', strtotime($_POST['fechaInicio'])) . " AL " . date('d/m/Y', strtotime($_POST['fechaFin'])));
        $this->HeaderCell(2, ["FECHA", "ALMACEN", "DOCUMENTO", "CONDICI�0�7N", "CLIENTE", "PRODUCTO", "CANTIDAD", "UNIDAD", "PRECIO COSTO UNITARIO SIN IGV", "PRECIO VENTA UNITARIO SIN IGV", "MONEDA", "IMPORTE VENTA", "UTILIDAD", "PORCENTAJE RENTABILIDAD"]);
        $this->Style_Titulo(count($data), range('A', 'N'));
        $this->AjustarColumnCell(range('A', 'N'));
        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', 'N'));
        $this->WriteFormat('view/librerias/dist/excel/detalle_ventas.xlsx');
    }

    public function Creditos_Excel()
    {

        $data = json_decode($_POST['data'], true);

        $this->SetPropiedades(["CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "CLUB PACASMAYO", "REPORTE DE CREDITOS", "CREDITOS"]);
        $this->SetTitulo("A1:H1", "A1", "CREDITOS DEL " . date('d/m/Y', strtotime($_POST['fechaInicio'])) . " AL " . date('d/m/Y', strtotime($_POST['fechafin'])));
        $this->HeaderCell(2, ["TIPO MOVIMIENTO", "FECHA", "DOCUMENTO", "CLIENTE/PROVEEDOR", "MONEDA", "TOTAL", "POR PAGAR", "ESTADO"]);
        $this->Style_Titulo(count($data), range('A', 'H'));

        $this->AjustarColumnCell(range('A', 'H'));

        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', 'H'));

        $this->WriteFormat('view/librerias/dist/excel/creditos.xlsx');
    }

    private function GenerarExcel($reporte, array $titulos, array $data, $fecha = null, $filename = null)
    {

        if (empty($fecha)) {
            $fecha = date('d/m/Y');
        }
        if (empty($filename)) {
            $filename = sprintf('%s-%s.xlsx', $reporte, date('YmdHis'));
        }

        $desc = sprintf('Reporte de %s', $reporte);
        if (strlen($desc) >= 31) {
            $desc = $reporte;
        }
        $titulo = sprintf(
            "%s DEL %s ",
            strtoupper($reporte),
            $fecha
        );

        $letra = chr(64 + count($titulos));


        $this->SetPropiedades(["Hormiguita", $desc, $desc, $desc, $desc, $desc]);
        $this->SetTitulo("A1:{$letra}1", "A1", $titulo);
        $this->HeaderCell(2, $titulos);
        $this->Style_Titulo(count($data), range('A', $letra));

        $this->AjustarColumnCell(range('A', $letra));

        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', $letra));
        $this->Download($filename);
    }

    public function DescargarExcel()
    {

        $reporte = $_POST['nombre'];
        $titulos = json_decode($_POST['titulos'], true);
        $data = json_decode($_POST['data'], true);
        $fechaIni = $_POST['fechaInicio'];
        $fechaFin = $_POST['fechaFin'];

        if (empty($fechaIni) && empty($fechaFin)) {
            $fechaIni = $fechaFin = date('Y-m-d');
        }
        if ($fechaIni === $fechaFin) {
            $fecha = sprintf('%s', date('d/m/Y', strtotime($fechaIni)));
        } else {
            $fecha = sprintf(
                '%s AL %s',
                date('d/m/Y', strtotime($fechaIni)),
                date('d/m/Y', strtotime($fechaFin))
            );
        }
        $this->GenerarExcel($reporte, $titulos, $data, $fecha);
    }

    public function Pagos_Excel()
    {

        $reporte = 'Pagos Realizados';
        $titulos = json_decode($_POST['titulos'], true);
        $data = json_decode($_POST['data'], true);
        $fechaIni = $_POST['fechaInicio'];
        $fechaFin = $_POST['fechaFin'];
        $fecha = sprintf(
            '%s AL %s',
            date('d/m/Y', strtotime($fechaIni)),
            date('d/m/Y', strtotime($fechaFin))
        );

        $this->GenerarExcel($reporte, $titulos, $data, $fecha);
    }

    public function reporteStockExcel()
    {
        $listaStock = $this->reportes_model->Stock();

        if (count($listaStock) > 0) {

            date_default_timezone_set('America/Lima');

            /** Se agrega la libreria PHPExcel */
            require_once 'view/librerias/PHPExcel/PHPExcel.php';

            // Se crea el objeto PHPExcel
            $objPHPExcel = new PHPExcel();

            // Se asignan las propiedades del libro
            $objPHPExcel->getProperties()->setCreator("Hormiguita") //Autor
                ->setLastModifiedBy("Hormiguita") //Ultimo usuario que lo modific��
                ->setTitle("Reporte de Stock de Hormiguita")
                ->setSubject("Reporte de Stock de Hormiguita")
                ->setDescription("Reporte de Stock de Hormiguita")
                ->setKeywords("Reporte de Stock de Hormiguita")
                ->setCategory("Reporte de Stock de Hormiguita");

            $tituloReporte = "Relacion completa de Stock Consolidado";
            $titulosColumnas = array('C�0�7DIGO', 'FAMILIA', 'PRODUCTO/SERVICIO', 'STOCK', 'UNIDAD', 'COSTO SIN IGV S/', 'VALORIZACI�0�7N S/', 'COSTO INC. IGV S/', 'PRECIO VENTA S/');

            $objPHPExcel->setActiveSheetIndex(0)
                ->mergeCells('A1:G2');

            // Se agregan los titulos del reporte
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', $tituloReporte)
                ->setCellValue('A3', $titulosColumnas[0])
                ->setCellValue('B3', $titulosColumnas[1])
                ->setCellValue('C3', $titulosColumnas[2])
                ->setCellValue('D3', $titulosColumnas[3])
                ->setCellValue('E3', $titulosColumnas[4])
                ->setCellValue('F3', $titulosColumnas[5])
                ->setCellValue('G3', $titulosColumnas[6])
                ->setCellValue('H3', $titulosColumnas[7])
                ->setCellValue('I3', $titulosColumnas[8]);

            //Se agregan los datos de los alumnos
            $i = 4;
            foreach ($listaStock as $row) {
                $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $i, $row->__GET('valor01'))
                    ->setCellValue('B' . $i, $row->__GET('valor02'))
                    ->setCellValue('C' . $i, $row->__GET('valor03'))
                    ->setCellValue('D' . $i, $row->__GET('valor04'))
                    ->setCellValue('E' . $i, $row->__GET('valor05'))
                    ->setCellValue('F' . $i, $row->__GET('valor06'))
                    ->setCellValue('G' . $i, $row->__GET('valor07'))
                    ->setCellValue('H' . $i, $row->__GET('valor08'))
                    ->setCellValue('I' . $i, $row->__GET('valor09'));
                $i++;
            }

            $estiloTituloReporte = array(
                'font' => array(
                    'name' => 'Verdana',
                    'bold' => true,
                    'italic' => false,
                    'strike' => false,
                    'size' => 16,
                    'color' => array('rgb' => '000000')
                ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID),
                'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_NONE)),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'rotation' => 0,
                    'wrap' => true
                )
            );

            $estiloTituloColumnas = array(
                'font' => array(
                    'name' => 'Arial',
                    'bold' => true,
                    'color' => array('rgb' => 'FFFFFF')
                ),
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_GRADIENT_LINEAR,
                    'rotation' => 90,
                    'startcolor' => array('rgb' => '3366ff'),
                    'endcolor' => array('argb' => 'FF000000')
                ),
                'borders' => array(
                    'top' => array(
                        'style' => PHPExcel_Style_Border::BORDER_MEDIUM,
                        'color' => array('rgb' => 'B0B0B0')
                    ),
                    'bottom' => array(
                        'style' => PHPExcel_Style_Border::BORDER_MEDIUM,
                        'color' => array('rgb' => '143860')
                    )
                ),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'wrap' => true
                )
            );

            $estiloInformacion = new PHPExcel_Style();
            $estiloInformacion->applyFromArray(array(
                'font' => array(
                    'name' => 'Arial',
                    'color' => array('rgb' => '000000')
                ),
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'color' => array('argb' => 'FFFFFFFF')
                ),
                'borders' => array('allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_MEDIUM,
                    'color' => array('rgb' => 'B0B0B0')
                )),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'wrap' => true
                )
            ));

            $objPHPExcel->getActiveSheet()->getStyle('A1:I1')->applyFromArray($estiloTituloReporte);
            $objPHPExcel->getActiveSheet()->getStyle('A3:I3')->applyFromArray($estiloTituloColumnas);
            $objPHPExcel->getActiveSheet()->getStyle('A1')->getAlignment()->setIndent($estiloTituloColumnas);
            $objPHPExcel->getActiveSheet()->setSharedStyle($estiloInformacion, "A4:I" . ($i - 1));
            for ($i = 'A'; $i <= 'G'; $i++) {
                $objPHPExcel->setActiveSheetIndex(0)
                    ->getColumnDimension($i)->setAutoSize(true);
            }

            // Se asigna el nombre a la hoja
            $objPHPExcel->getActiveSheet()->setTitle('Stock');

            // Se activa la hoja para que sea la que se muestre cuando el archivo se abre
            $objPHPExcel->setActiveSheetIndex(0);

            // Inmovilizar paneles 
            //$objPHPExcel->getActiveSheet(0)->freezePane('A4');
            $objPHPExcel->getActiveSheet(0)->freezePaneByColumnAndRow(0, 4);

            // Se manda el archivo al navegador web, con el nombre que se indica (Excel2007)
            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
            header('Content-Disposition: attachment;filename="ReporteStock' . date('d-m-Y') . '.xlsx"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
            $objWriter->save('php://output');
            exit;
        } else {
            echo "<script type='text/javascript'>window.location='?c=Reportes&a=Stock';</script>";
        }
    }

    public function catalogoProductos()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $reportes = $this->reportes_model->catalogoProductos();
        require_once 'view/header.php';
        require_once 'view/webreport/wfpcatalofoproductos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function ventaxfacturacion()
    {

        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i:s');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i:s');

        $usu_code = $_SESSION['usu_codigo'] != 16 ? 0 : $_SESSION['usu_codigo'];
        $reportes = $this->reportes_model->ventaxfacturacion(0, $fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfventaxfactura.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function ventaxvendedor()
    {

        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');

        // $usu_code = $_SESSION['usu_codigo'] != 16 ? 0 : $_SESSION['usu_codigo'];
        $usu_code = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];

        // $reportes = $this->reportes_model->ventaxvendedor($usu_code, $fechaIni, $fechaFin);
        if ($this->seguridad->validRoleName(RolesType::jefe_vendedor)) { // aqui entra emely
            // echo '<pre>';
            // var_dump('acá');
            // echo '</pre>';
            // exit();
            $reportes = $this->reportes_model->ventaxvendedor_jefe($usu_code, $fechaIni, $fechaFin);
        } else { // los demás
            // echo '<pre>';
            // var_dump('aqui');
            // echo '</pre>';
            // exit();
            $reportes = $this->reportes_model->ventaxvendedor($usu_code, $fechaIni, $fechaFin);
        }
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrventaxvendedor.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    function MovSunat()
    {

        $tipomovimientos = isset($_POST['TipoMovimiento_Id']) ? $_POST['TipoMovimiento_Id'] : 6;
        $fechaIni = isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio'])) : date('Y-m-d');
        $fechaFin = isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin'])) : date('Y-m-d');

        $reportes = $this->reportes_model->listar_sunat(
            $fechaIni,
            $fechaFin,
            $tipomovimientos
        );

        $parametro = $this->parametro_model->ListarParametros();

        require_once 'view/header.php';
        require_once 'view/webreport/wrreportesunat.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Movimientos()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->movimientos($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfmovimiento.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function MovimientosSimple()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->MovimientosSimple($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfmovimientosimple.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function MovimientosSunat()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->movimientosSunat($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfmovimientoSunat.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function RegVentas()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->RegVentas($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfregventas.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }



    public function RegVentasCeramicorp()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->RegVentasCeramicorp($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfregventasceramicorp.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function LibrosElectronicos()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->LibrosElectronicos($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wflibroselectronicos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function LibrosElectronicosTxt()
    {
        $fechaIni = isset($_POST['fechaIni']) ?  date('d-m-Y', strtotime($_POST['fechaIni'])) : date('d-m-Y H:i');
        $fechaFin = isset($_POST['fechaFin']) ?  date('d-m-Y', strtotime($_POST['fechaFin'])) : date('d-m-Y H:i');
        $reportes = $this->reportes_model->LibrosElectronicos($fechaIni, $fechaFin);

        $fecha_separada = explode('-', $fechaIni);

        $name = 'LE' . $_SESSION['usu_enterpriseRuc'] . $fecha_separada[2] . $fecha_separada[1] . '00140100001111' . '.txt';
        $archivo = fopen($name, "a");

        foreach ($reportes as $r) :

            fwrite($archivo, $r->Periodo);
            fwrite($archivo, $r->Operacion);
            fwrite($archivo, $r->Correlativo);
            fwrite($archivo, $r->FecEmision);
            fwrite($archivo, $r->FecVence);
            fwrite($archivo, $r->TipoDoc);
            fwrite($archivo, $r->Serie);
            fwrite($archivo, $r->Numero);
            fwrite($archivo, $r->Tickets);
            fwrite($archivo, $r->TipoCliente);
            fwrite($archivo, $r->DocCliente);
            fwrite($archivo, $r->Nombre);
            fwrite($archivo, $r->Export);
            fwrite($archivo, $r->Base);
            fwrite($archivo, $r->DsctoBase);
            fwrite($archivo, $r->IGV);
            fwrite($archivo, $r->DsctoIGV);
            fwrite($archivo, $r->Exoner);
            fwrite($archivo, $r->Inafecta);
            fwrite($archivo, $r->ISC);
            fwrite($archivo, $r->ISC1);
            fwrite($archivo, $r->ISC2);
            fwrite($archivo, $r->Bolsas);
            fwrite($archivo, $r->Bolsas);
            fwrite($archivo, $r->ISC3);
            fwrite($archivo, $r->Total);
            fwrite($archivo, $r->Moneda);
            fwrite($archivo, $r->TC);
            fwrite($archivo, $r->NotaFecha);
            fwrite($archivo, $r->NotaRefTipo);
            fwrite($archivo, $r->NotaRefSerie);
            fwrite($archivo, $r->NotaRefNum);
            fwrite($archivo, $r->Contrato);
            fwrite($archivo, $r->Error1);
            fwrite($archivo, $r->MediodePago);
            fwrite($archivo, $r->Estado . PHP_EOL);
        endforeach;
        fclose($archivo);

        $basefichero = basename($name);

        header("Content-Type: application/octet-stream");
        header("Content-Length: " . filesize($name));
        header("Content-Disposition: attachment; filename=" . $basefichero . "");
        readfile($name);
    }


    public function MovimientosVendedor()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $usu_code = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];

        if ($this->seguridad->validRoleName(RolesType::jefe_vendedor)) {
            $reportes = $this->reportes_model->MovimientosVendedor_jefe($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'), $usu_code);
        } else {
            $reportes = $this->reportes_model->MovimientosVendedor($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'), $usu_code);
        }
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfmovimientosvendedor.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function VentaDiaria()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->VentaDiaria($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfventadiaria.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function VentaMensual()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->VentaMensual($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfventamensual.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function RankingProdServ()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->RankingProdServ($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrankingprodserv.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function RankingOD()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->RankingOD($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrankingod.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Creditos()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->Creditos($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfcreditos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function Pagos()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->Pagos($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'));
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfpagos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function StockVencimiento()
    {
        $reportes = $this->reportes_model->StockVencimiento();
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfstockxvencer.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function date_time($date)
    {
        if ($date == "") {
            return "";
        } else {
            // echo $date;
            $my_date = DateTime::createFromFormat('m-d-Y H:i:s', '22/09/2018 00:56');
            // echo '<pre>';
            // print_r($my_date);
            // echo '</pre>';
            $new_date = $my_date->format('Y-m-d H:i:s');
            return $new_date;
        }
    }

    public function ventaxfacturacionExcel()
    {

        // if (count($listaStock) > 0) {

        date_default_timezone_set('America/Lima');

        /** Se agrega la libreria PHPExcel */
        require_once 'view/librerias/PHPExcel/PHPExcel.php';
        $objPHPExcel = new PHPExcel();
        // Set properties
        $objPHPExcel->getProperties()->setCreator("ThinkPHP")
            ->setLastModifiedBy("Daniel Schlichtholz")
            ->setTitle("Office 2007 XLSX Test Document")
            ->setSubject("Office 2007 XLSX Test Document")
            ->setDescription("Test doc for Office 2007 XLSX, generated by PHPExcel.")
            ->setKeywords("office 2007 openxml php")
            ->setCategory("Test result file");
        $objPHPExcel->getActiveSheet(0)->setTitle('Minimalistic demo');
        // Se manda el archivo al navegador web, con el nombre que se indica (Excel2007)
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="item_list.xlsx"');
        header('Cache-Control: max-age=0');
        ob_end_clean();
        $objWriter->save('php://output');
        exit;
    }

    public function Stockmin()
    {
        $reportes = $this->reportes_model->Stockmin();
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfstockmin.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function VentaxCliente()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $clientes = $this->origendestino_model->Listar();

        $OrigenDestino_Id = isset($_POST['OrigenDestino_Id']) ? $_POST['OrigenDestino_Id'] : 0;
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i:s');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i:s');

        $reportes = $this->reportes_model->VentasxCliente($OrigenDestino_Id, $fechaIni, $fechaFin);
        
        if ($_SESSION['usu_role'] == 11) { // vendedor_reyta
            // buscamos id del vendedor reyta
            $vendedor_reyta = $this->reportes_model->obtenerIdVendedor($_SESSION['usu_codigo']);
            $id = $vendedor_reyta[0]->vendedor_id;

            $reportes = $this->reportes_model->VentasxCliente2($OrigenDestino_Id, $fechaIni, $fechaFin, $id);
        }

        require_once 'view/header.php';
        require_once 'view/webreport/wfrventasxcliente.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }


    public function MovimientosYPagos()
    {
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $usu_code = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];
        $reportes = $this->reportes_model->MovimientosYPagos($fechaIni, $fechaFin, isset($_REQUEST['Tipomovimiento_Id']) ? $_REQUEST['Tipomovimiento_Id'] : $tipomovimiento[1]->__GET('TipoMovimiento_Id'), $usu_code);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfmovimientosypagos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function VentaMensualPagadosyPendientes()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->VentaMensualPagadosyPendientes($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrventamensualpagadosypendientes.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function ControlReparto()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->ControlReparto($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfcontrolreparto.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function ClientesxUbigeo()
    {
        $clientes = $this->origendestino_model->Listar();
        // var_dump($_POST['nProcliDep']);

        $OrigenDestino_Id = !empty($_POST['OrigenDestino_Id']) ? $_POST['OrigenDestino_Id'] : 0;
        $nProcliDep = isset($_POST['nProcliDep']) ? $_POST['nProcliDep'] : 0;
        $nProcliProv = isset($_POST['nProcliProv']) ? $_POST['nProcliProv'] : 0;
        $nProcliDist = isset($_POST['nProcliDist']) ? $_POST['nProcliDist'] : 0;
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');

        $reportes = $this->reportes_model->Clientesxubigeo($OrigenDestino_Id, $fechaIni, $fechaFin, $nProcliDep, $nProcliProv, $nProcliDist);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfrclientesxubigeo.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
    
    
    public function GuiasRemisionTransportista()
    {
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $reportes = $this->reportes_model->GuiaRT($fechaIni, $fechaFin);
        $parametro = $this->parametro_model->ListarParametros();
        require_once 'view/header.php';
        require_once 'view/webreport/wfguiaremisiontransportista.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function byYear() {
        $parametro = $this->parametro_model->ListarParametros();
        $year = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('Y');
        $yearx = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : '';
        $reportes = $this->reportes_model->byYear($year); // year
        require_once 'view/header.php';
        require_once 'view/webreport/wfbyyear.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function jsonbyYear() {
        $year = isset($_REQUEST['year']) ? $_REQUEST['year'] : date('Y');
        echo json_encode($this->reportes_model->jsonbyYear($year));
    }

    public function comparativesperYears() {
        $parametro = $this->parametro_model->ListarParametros();
        $year1 = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('Y');
        $year1x = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : '';

        $year2 = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('Y');
        $year2x = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : '';
        
        require_once 'view/header.php';
        require_once 'view/webreport/wfcomparativesperyear.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function jsoncomparativesperYears() {
        $yearInicio = isset($_REQUEST['yearInicio']) ? $_REQUEST['yearInicio'] : date('Y');
        $yearFin = isset($_REQUEST['yearFin']) ? $_REQUEST['yearFin'] : date('Y');

        $missing = [];
        // if ($yearInicio != $yearFin) {
            for ($i=$yearInicio+1; $i < $yearFin; $i++) { 
                $missing[] = $i;
            }
            array_push($missing, $yearInicio);
            array_push($missing, $yearFin);
        // }

        $missing = array_unique($missing);

        sort($missing);
        // echo '<pre>';
        // var_dump($missing);
        // echo '</pre>';
        // exit();

        $result = [];
        for ($j=0; $j < count($missing); $j++) {
            $result[] = json_encode($this->reportes_model->jsonbyYear($missing[$j]));
        }

        echo json_encode($result);
    }
}
