<?php
class ConductorModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL Con_ListarC(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $con = new Conductor();
                $con->__SET('conductor_Id', $r->Conductor_Id);
                $con->__SET('Conductor', $r->Conductor);
                $con->__SET('sConLicencia', $r->sConLicencia);
                $con->__SET('dConVencimientoLic', date('d-m-Y', strtotime($r->dConVencimientoLic)));
                $con->__SET('nConEstado', $r->nConEstado);
                
                $result[] = $con;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($conductor_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL Con_ListarC($conductor_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $con = new Conductor();
                $con->__SET('conductor_Id', $r->Conductor_Id);
                $con->__SET('sConApePaterno', $r->sConApePaterno);
                $con->__SET('sConApeMaterno', $r->sConApeMaterno);
                $con->__SET('sConNombres', $r->sConNombres);
                $con->__SET('sConDNI', $r->sConDNI);
                $con->__SET('sConLicencia', $r->sConLicencia);
                $con->__SET('sConCategoriaLic', $r->sConCategoriaLic);
                $con->__SET('dConVencimientoLic', $r->dConVencimientoLic);
                $con->__SET('nConEstado', $r->nConEstado);
                $result[] = $con;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    

    public function Crear(Conductor $data){
        try {
            $stm = $this->pdo->prepare("CALL con_Crear(?,?,?,?,?,?,?,?,?,?,@conductor_Id)");
            $stm->execute(array(
                                 $data->__get('sConApePaterno'),
                                 $data->__get('sConApeMaterno'),
                                 $data->__get('sConNombres'),
                                 $data->__get('sConDNI'),
                                 $data->__get('sConLicencia'),
                                 $data->__get('sConCategoriaLic'),
                                 $data->__get('dConVencimientoLic'),
                                 $data->__get('nConEliminado'),
                                 $data->__get('nConEstado'),                                 
                                 $data->__get('nConUsuario_Id')                                 
                                 ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardada</strong>, los datos fueron registrados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=conductor&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    

    public function Editar(Conductor $data){
        try {
            $stm = $this->pdo->prepare("CALL con_editar(?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(                                 
                                 $data->__get('conductor_Id'),
                                 $data->__get('sConApePaterno'),
                                 $data->__get('sConApeMaterno'),
                                 $data->__get('sConNombres'),
                                 $data->__get('sConDNI'),
                                 $data->__get('sConLicencia'),
                                 $data->__get('sConCategoriaLic'),
                                 $data->__get('dConVencimientoLic'),
                                 $data->__get('nConEliminado'),
                                 $data->__get('nConEstado'),                                 
                                 $data->__get('nConUsuario_Id')                              
                                 ));
            //print_r($data);
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>'; 
            echo '<script type="text/javascript">window.location="?c=conductor&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Conductor $data){
        try {
             $stm = $this->pdo->prepare("CALL con_ocultar(?,?)");
             $stm->execute(array(
                                $data->__get('conductor_Id'),
                                $data->__get('nConUsuario_Id')
                                )
                          );
             //print_r($data);
        } catch (Exception $e) {
             die($e->getMessage());
        }
   }

//****************************************


    
    
        public function ListarProveedor(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL OD_Listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ori = new Origendestino();
                if ($r->nODTipo == 1){
                $ori->__SET('OrigenDestino_Id', $r->OrigenDestino_Id);
                $ori->__SET('nODTipo', $r->nODTipo);
                $ori->__SET('sODRucDni', $r->sODRucDni);
                $ori->__SET('sODNombre', $r->sODNombre);
                $ori->__SET('sODNombreComercial', $r->sODNombreComercial);
                $ori->__SET('sODDireccion', $r->sODDireccion);
                $ori->__SET('sODTelefono', $r->sODTelefono);
                $ori->__SET('sODCorreo', $r->sODCorreo);
                $ori->__SET('sODContacto', $r->sODContacto);
                $ori->__SET('nODDiasCredito', $r->nODDiasCredito);
                $ori->__SET('nODEstado', $r->nODEstado);
                $ori->__SET('dODFechaActualizacion', $r->dODFechaActualizacion);
                $ori->__SET('nODUsuario_Id', $r->nODUsuario_Id);
                $ori->__SET('nODEliminado', $r->nODEliminado);
                $result[] = $ori;
            }
            
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    
    
    
}
?>
