<?php

class EnterpriseInfoModel {

    private $pdo;

    function __construct()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL enterprise_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Enterprise_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL enterprise_listar(?)");
            $stm->execute([$Enterprise_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());  
        }
    }

    public function Guardar($data) {
        try {
            $stm = $this->pdo->prepare("CALL enterprise_crear(?,?)");
            $stm->execute([
                $data['sEnterName'],
                $data['nEnterUser_Id']
            ]);
            return 1;
        } catch (Exception $e) {
            die($e->getMessage());  
        }
    }

    public function Editar($data) {
        try {
            $stm = $this->pdo->prepare("CALL enterprise_editar(?,?,?)");
            $stm->execute([
                $data['Enterprise_Id'],
                $data['sEnterName'],
                $data['nEnterUser_Id']
            ]);
            return 2;
        } catch (Exception $e) {
            die($e->getMessage());  
        }
    }

    public function Eliminar($Enterprise_Id) {
        try {
            $stm = $this->pdo->prepare("CALL enterprise_eliminar(?)");
            $stm->execute([$Enterprise_Id]);
        } catch (Exception $e) {
            die($e->getMessage());  
        }
    }
}