<?php

class GastoModel {
    private $pdo;

    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL listar_gasto(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Gasto_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL listar_gasto(?)");
            $stm->execute([$Gasto_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListarxDate($fechaInicio, $fechaFin, $paramDestino) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL listar_gasto_date(?,?,?)");
            $stm->execute([$fechaInicio, $fechaFin, $paramDestino]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function GuardarGasto($Gasto) {
        try {
            $Gasto_Id = 0;
            $stm = $this->pdo->prepare("CALL crear_gasto(?,?,?,?,@pGasto_Id)");
            $stm->execute(array(
                $Gasto['dGasFechaEmision'],
                $Gasto['sGasDescripcion'],
                $Gasto['nGasMonto'],
                $Gasto['Usuario_Id'],
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Gasto_Id = $r->Gasto_Id;
            }
            return $Gasto_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarGasto($Gasto_Id) {
        try {
            $stm = $this->pdo->prepare("UPDATE gasto SET nGasElimnado=1, nGasEstado=0 WHERE Gasto_Id=?");
            $stm->execute([$Gasto_Id]);
            $rowCount = $stm->rowCount();
            return $rowCount;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EditarGasto($Gasto) {
        try {
            $stm = $this->pdo->prepare("CALL editar_gasto(?,?,?,?,?)");
            $stm->execute(array(
                $Gasto['dGasFechaEmision'],
                $Gasto['sGasDescripcion'],
                $Gasto['nGasMonto'],
                $Gasto['Usuario_Id'],
                $Gasto['Gasto_Id'],
            ));
            return 2;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarGastoDetalle($Gasto_Id) {
        try {
            $stm = $this->pdo->prepare("DELETE FROM gasto_detalle WHERE nGDGasto_Id=?");
            $stm->execute([$Gasto_Id]);
            $rowCount = $stm->rowCount();
            return $rowCount;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function CrearGastoDetalle($Gasto_Id, $Enterprise_Id) {
        try {
            $stm = $this->pdo->prepare("CALL crear_gastodetalle(?,?)");
            $stm->execute(array(
                $Gasto_Id,
                $Enterprise_Id
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListarGastoDetalle($Gasto_Id) {
        try {
            $stm = $this->pdo->prepare("SELECT e.Enterprise_Id, e.sEnterName, e.nEnterStatus FROM gasto_detalle gd
                                        INNER JOIN enterprise e
                                        ON e.Enterprise_Id=gd.nGDEnterprise_Id
                                        WHERE nGDGasto_Id=?");
            $stm->execute(array(
                $Gasto_Id
            ));
            return $stm->fetchAll(PDO::FETCH_OBJ);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}