<?php
class MovimientoModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function getMovimientosBaja()
    {
        try {
            $result = array();
            /*$stm = $this->pdo->prepare("SELECT 
            m.Movimiento_Id FROM 
                    movimiento as m
                    inner join documento as d
                    on d.Documento_Id = m.Documento_Id
                    where m.sMovEstadoValidacion_Baja in (0,6)
                    and d.isFE = 1
                    ORDER BY m.dMovFecha DESC;");*/
            $stm = $this->pdo->prepare("SELECT 
                m.Movimiento_Id,
                CONCAT(d.sDocNombreCorto, ' ', m.sMovDocumento) as Documento,
                DATE_FORMAT(m.dMovFecha, '%d-%m-%Y') as dMovFecha,
                m.Moneda_Id,
                m.nMovTotal
                FROM 
                movimiento as m
                inner join documento as d
                on d.Documento_Id = m.Documento_Id
                where m.nMovEstadoSunat = 6
                and d.isFE = 1
                ORDER BY m.dMovFecha DESC;");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function ListarCredito($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL cred_listar('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDate($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_date('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDateToArray($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_list_Actestados('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function ConfirmarDespacho($Despacho_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL movdespacho_confirmar(?)");
            $stm->execute([$Despacho_Id]);
            return true;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDateDespacho($fechaInicio, $fechaFin, $TipoMovimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL movdespacho_date('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('nDesEstado', $r->nDesEstado);
                $mov->__SET('Despacho_Id', $r->Despacho_Id);
                $mov->__SET('sObservacion', $r->sObservacion);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDate2($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_date2('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarJefeVendedor($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_date3('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sODNombreComercial', $r->sODNombreComercial);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovTotal);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('isFE', $r->isFE);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);

                $datemovimiento = new DateTime($r->dMovFecha);
                $mov->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('sAlmNombre', $r->sAlmNombre);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovSaldo);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('nMovOrdenCompra_Id', $r->nMovOrdenCompra_Id);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Buscar($Movimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_listar($Movimiento_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('nDocAfectoIGV', $r->nDocAfectoIGV);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovSaldo);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('sMovObservacion', $r->sMovObservacion);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('sODCorreo', $r->sODCorreo);
                $mov->__SET('sMonDescripcion', $r->sMonDescripcion);
                $mov->__SET('sMonAlias', $r->sMonAlias);
                $mov->__SET('NumeroLetras', $r->NumeroLetras);
                $mov->__SET('sVenNom', $r->sVenNom);
                $mov->__SET('vendedor_id', $r->vendedor_id);
                $mov->__SET('dMovICBPER', $r->dMovICBPER);
                $mov->__SET('nODTipoDoc', $r->nODTipoDoc);
                $mov->__SET('sODTelefono', $r->sODTelefono);
                $mov->__SET('nDocNumImpresiones', $r->nDocNumImpresiones);
                $mov->__SET('nPagTipoPago_Id', $r->nPagTipoPago_Id);
                $mov->__SET('nMovPorcentajeDetraccion', $r->nMovPorcentajeDetraccion);
                $mov->__SET('sMovCodDetraccion', $r->sMovCodDetraccion);
                // $mov->__SET('nroguia_ref', $r->nroguia_ref);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Buscar2($Movimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_listar2($Movimiento_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new Movimiento();
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $mov->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $mov->__SET('sTMovNombre', $r->sTMovNombre);
                $mov->__SET('nMovTipopago', $r->nMovTipopago);
                $mov->__SET('Almacen_Id', $r->Almacen_Id);
                $mov->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $mov->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $mov->__SET('nMovTipodestino', $r->nMovTipodestino);
                $mov->__SET('Documento_Id', $r->Documento_Id);
                $mov->__SET('sMovDocumento', $r->sMovDocumento);
                $mov->__SET('sDocNombre', $r->sDocNombre);
                $mov->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $mov->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $mov->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $mov->__SET('nDocAfectoIGV', $r->nDocAfectoIGV);
                $mov->__SET('Moneda_Id', $r->Moneda_Id);
                $mov->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $mov->__SET('nMovImporte', $r->nMovImporte);
                $mov->__SET('nMovIGV', $r->nMovIGV);
                $mov->__SET('nMovTotal', $r->nMovTotal);
                $mov->__SET('nMovSaldo', $r->nMovSaldo);
                $mov->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $mov->__SET('dMovDetraccion', $r->dMovDetraccion);
                $mov->__SET('dMovPercepcion', $r->dMovPercepcion);
                $mov->__SET('dMovRetencion', $r->dMovRetencion);
                $mov->__SET('sMovObservacion', $r->sMovObservacion);
                $mov->__SET('nMovEstado', $r->nMovEstado);
                $mov->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $mov->__SET('nMovEliminado', $r->nMovEliminado);
                $mov->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $mov->__SET('Usuario_Id', $r->Usuario_Id);
                $mov->__SET('Documento', $r->Documento);
                $mov->__SET('sODCorreo', $r->sODCorreo);
                $mov->__SET('sMonDescripcion', $r->sMonDescripcion);
                $mov->__SET('sMonAlias', $r->sMonAlias);
                $mov->__SET('NumeroLetras', $r->NumeroLetras);
                $mov->__SET('sVenNom', $r->sVenNom);
                $mov->__SET('vendedor_id', $r->vendedor_id);
                $mov->__SET('dMovICBPER', $r->dMovICBPER);
                $mov->__SET('nODTipoDoc', $r->nODTipoDoc);
                $mov->__SET('sODTelefono', $r->sODTelefono);
                $mov->__SET('nDocNumImpresiones', $r->nDocNumImpresiones);
                $mov->__SET('nPagTipoPago_Id', $r->nPagTipoPago_Id);
                $mov->__SET('nMovPorcentajeDetraccion', $r->nMovPorcentajeDetraccion);
                $mov->__SET('sMovCodDetraccion', $r->sMovCodDetraccion);
                $mov->__SET('nPrimerValorReferencial', $r->nPrimerValorReferencial);
                $mov->__SET('nSegundoValorReferencial', $r->nSegundoValorReferencial);
                $mov->__SET('nTercerValorReferencial', $r->nTercerValorReferencial);
                // $mov->__SET('nroguia_ref', $r->nroguia_ref);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function getByDocumento($documento)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_documento('$documento')");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = (array)$r;
                $result['dMovFecha'] = date('d-m-Y', strtotime($r->dMovFecha));
                $datemovimiento = new DateTime($r->dMovFecha);
                $result['dMovDays'] = $datecurrent->diff($datemovimiento)->days;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Guardar(Movimiento $data)
    {
        // var_dump($data);
        // die();
        try {
            
//             $fecha_enviada = date('Y-m-d', strtotime($data->__get('dMovFecha')));

// // Construyendo la cadena de llamada al procedimiento almacenado
// $query = "CALL mov_crear(";
// $query .= "'$fecha_enviada', "; // La fecha en formato 'YYYY-MM-DD'

// // Añade los otros parámetros uno por uno
// $query .= "'" . $data->__get('nMovTipoMovimiento_Id') . "', ";
// $query .= "'" . $data->__get('nMovTipopago') . "', ";
// $query .= "'" . $data->__get('Almacen_Id') . "', ";
// $query .= "'" . $data->__get('nMovTipoOrigenDestino') . "', ";
// $query .= "'" . $data->__get('nMovOrigenDestino_Id') . "', ";
// $query .= "'" . $data->__get('nMovTipodestino') . "', ";
// $query .= "'" . $data->__get('Documento_Id') . "', ";
// $query .= "'" . $data->__get('sMovDocumento') . "', ";
// $query .= "'" . $data->__get('sMovDocReferencia') . "', ";
// $query .= "'" . $data->__get('Moneda_Id') . "', ";
// $query .= "'" . $data->__get('nMovTipoCambio') . "', ";
// $query .= "'" . $data->__get('nMovImporte') . "', ";
// $query .= "'" . $data->__get('nMovIGV') . "', ";
// $query .= "'" . $data->__get('nMovTotal') . "', ";
// $query .= "'" . $data->__get('nMovSaldo') . "', ";
// $query .= "'" . $data->__get('nMovTotalCancelado') . "', ";
// $query .= "'" . $data->__get('dMovDetraccion') . "', ";
// $query .= "'" . $data->__get('dMovPercepcion') . "', ";
// $query .= "'" . $data->__get('dMovRetencion') . "', ";
// $query .= "'" . $data->__get('sMovObservacion') . "', ";
// $query .= "'" . $data->__get('nMovEstado') . "', ";
// $query .= "'" . $data->__get('nMovEliminado') . "', ";
// $query .= "'" . $data->__get('Usuario_Id') . "', ";
// $query .= "'" . $data->__get('nMovVendedor_Id') . "', ";
// $query .= "'" . $data->__get('dMovICBPER') . "', ";
// $query .= "'" . $data->__get('nMovPorcentajeDetraccion') . "', ";
// $query .= "'" . $data->__get('sMovCodDetraccion') . "', ";
// $query .= "'" . $data->__get('nMovOrdenCompra_Id') . "'";

// // Agrega el parámetro de salida
// $query .= ", @Movimiento_Id)";

// // Ahora $query contiene la cadena completa de la llamada al procedimiento almacenado
// echo $query;
// die();
            
            
            
            
            $Movimiento_Id = 0;
            $stm = $this->pdo->prepare("CALL mov_crear(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,@Movimiento_Id )");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dMovFecha'))),
                $data->__get('nMovTipoMovimiento_Id'),
                $data->__get('nMovTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nMovTipoOrigenDestino'),
                $data->__get('nMovOrigenDestino_Id'),
                $data->__get('nMovTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sMovDocumento'),
                $data->__get('sMovDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nMovTipoCambio'),
                $data->__get('nMovImporte'),
                $data->__get('nMovIGV'),
                $data->__get('nMovTotal'),
                $data->__get('nMovSaldo'),
                $data->__get('nMovTotalCancelado'),
                $data->__get('dMovDetraccion'),
                $data->__get('dMovPercepcion'),
                $data->__get('dMovRetencion'),
                $data->__get('sMovObservacion'),
                $data->__get('nMovEstado'),
                $data->__get('nMovEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nMovVendedor_Id'),
                $data->__get('dMovICBPER'),
                $data->__get('nMovPorcentajeDetraccion'),
                $data->__get('sMovCodDetraccion'),
                $data->__get('nMovOrdenCompra_Id')
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Movimiento_Id = $r->Movimiento_Id;
            }
            //            echo "Se guardo correctamente ->".$nMovTipoMovimiento_Id;
            return $Movimiento_Id;
        } catch (Exception $e) {
            // echo $e->getMessage();
            die($e->getMessage());
            // die();
        }
    }
    
    public function GuardarwithVR(Movimiento $data)
    {
        try {
            $Movimiento_Id = 0;
            $stm = $this->pdo->prepare("CALL mov_crear2(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,@Movimiento_Id )");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dMovFecha'))),
                $data->__get('nMovTipoMovimiento_Id'),
                $data->__get('nMovTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nMovTipoOrigenDestino'),
                $data->__get('nMovOrigenDestino_Id'),
                $data->__get('nMovTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sMovDocumento'),
                $data->__get('sMovDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nMovTipoCambio'),
                $data->__get('nMovImporte'),
                $data->__get('nMovIGV'),
                $data->__get('nMovTotal'),
                $data->__get('nMovSaldo'),
                $data->__get('nMovTotalCancelado'),
                $data->__get('dMovDetraccion'),
                $data->__get('dMovPercepcion'),
                $data->__get('dMovRetencion'),
                $data->__get('sMovObservacion'),
                $data->__get('nMovEstado'),
                $data->__get('nMovEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nMovVendedor_Id'),
                $data->__get('dMovICBPER'),
                $data->__get('nMovPorcentajeDetraccion'),
                $data->__get('sMovCodDetraccion'),
                $data->__get('nMovOrdenCompra_Id'),

                $data->__get('nPrimerValorReferencial'),
                $data->__get('nSegundoValorReferencial'),
                $data->__get('nTercerValorReferencial'),
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Movimiento_Id = $r->Movimiento_Id;
            }
            //            echo "Se guardo correctamente ->".$nMovTipoMovimiento_Id;
            return $Movimiento_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    
    public function EditarwithVR(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL mov_editar2(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dMovFecha'))),
                $data->__get('nMovTipoMovimiento_Id'),
                $data->__get('nMovTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nMovTipoOrigenDestino'),
                $data->__get('nMovOrigenDestino_Id'),
                $data->__get('nMovTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sMovDocumento'),
                $data->__get('sMovDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nMovTipoCambio'),
                $data->__get('nMovImporte'),
                $data->__get('nMovIGV'),
                $data->__get('nMovTotal'),
                $data->__get('nMovSaldo'),
                $data->__get('nMovTotalCancelado'),
                $data->__get('dMovDetraccion'),
                $data->__get('dMovPercepcion'),
                $data->__get('dMovRetencion'),
                $data->__get('sMovObservacion'),
                $data->__get('nMovEstado'),
                $data->__get('nMovEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nMovVendedor_Id'),
                $data->__get('nMovPorcentajeDetraccion'),
                $data->__get('sMovCodDetraccion'),
                $data->__get('nMovOrdenCompra_Id'),

                $data->__get('nPrimerValorReferencial'),
                $data->__get('nSegundoValorReferencial'),
                $data->__get('nTercerValorReferencial'),

                $data->__get('Movimiento_Id')

            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito informaci贸n editado</strong>, los datos fueron editados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    
    public function Editar(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL mov_editar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dMovFecha'))),
                $data->__get('nMovTipoMovimiento_Id'),
                $data->__get('nMovTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nMovTipoOrigenDestino'),
                $data->__get('nMovOrigenDestino_Id'),
                $data->__get('nMovTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sMovDocumento'),
                $data->__get('sMovDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nMovTipoCambio'),
                $data->__get('nMovImporte'),
                $data->__get('nMovIGV'),
                $data->__get('nMovTotal'),
                $data->__get('nMovSaldo'),
                $data->__get('nMovTotalCancelado'),
                $data->__get('dMovDetraccion'),
                $data->__get('dMovPercepcion'),
                $data->__get('dMovRetencion'),
                $data->__get('sMovObservacion'),
                $data->__get('nMovEstado'),
                $data->__get('nMovEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nMovVendedor_Id'),
                $data->__get('nMovPorcentajeDetraccion'),
                $data->__get('sMovCodDetraccion'),
                $data->__get('nMovOrdenCompra_Id'),
                $data->__get('Movimiento_Id')

            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito informaci贸n editado</strong>, los datos fueron editados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL Mov_Anular(?,?)");
            $stm->execute(array($data->__get('Movimiento_Id'), $data->__get('Usuario_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function updaeteEstado_sunat($movimiento_Id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("update movimiento set `nMovEstadoSunat` = ? where Movimiento_Id = ?");
            $stm->execute([$estado, $movimiento_Id]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function updateMovEstado($movimiento_Id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("update movimiento set `nMovEstado` = ? where Movimiento_Id = ?");
            $stm->execute([$estado, $movimiento_Id]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarNroCuotas($notacredito_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL not_buscar_mov_cuotas(?)");
            $stm->execute([$notacredito_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function updaeteEstado($movimiento_Id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("update movimiento set `sMovEstadoValidacion_Baja` = ? where Movimiento_Id = ?");
            $stm->execute([$estado, $movimiento_Id]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function act_obs_docref(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL act_obs_docref(?,?,?,?)");
            $stm->execute(array(
                $data->__get('sMovDocReferencia'),
                $data->__get('sMovObservacion'),
                $data->__get('Movimiento_Id'),
                $data->__get('nMovVendedor_Id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito</strong>, los datos fueron editados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function GuardarPago($Movimiento_Id, $nMovPagNroCuota, $nMovPagTotalCuota, $dMovPagFechaCuota)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL Mov_registrarpago(?,?,?,?)');
            $stm->execute([$Movimiento_Id, $nMovPagNroCuota, $nMovPagTotalCuota, date('Y-m-d', strtotime($dMovPagFechaCuota))]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function BuscarPagos($Movimiento_Id)
    {
        try {
            // print_r($this->pdo);
            $result = array();
            $stm = $this->pdo->prepare("CALL movpagos_listar($Movimiento_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = new MovimientoPagos();
                $mov->__SET('MovimientoPago_Id', $r->MovimientoPago_Id);
                $mov->__SET('Movimiento_Id', $r->Movimiento_Id);
                $mov->__SET('nMovPagNroCuota', $r->nMovPagNroCuota);
                $mov->__SET('nMovPagTotalCuota', $r->nMovPagTotalCuota);
                $mov->__SET('dMovPagFechaCuota', $r->dMovPagFechaCuota);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDetracciones()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * from detraccion WHERE nDeEstado=1");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ObtenerIdConNroSerie($Documento_Id, $sMovDocumento)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT Movimiento_Id from movimiento where Documento_Id= ? and sMovDocumento=?;");
            $stm->execute([$Documento_Id, $sMovDocumento]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function actualizarEstadoPorId($id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("UPDATE movimiento SET nMovEstadoSunat = {$estado} WHERE Movimiento_Id= ?");
            $stm->execute([$id]);
            return $stm->rowCount();
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function crearDespacho ($Despacho_Id, $flag, $idmovimiento, $obs) {
        try {
            $stm = $this->pdo->prepare("CALL despacho_crear(?,?,?,?)");
            $stm->execute([
                $Despacho_Id,
                $flag,
                $idmovimiento,
                $obs
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function despachosIncompletos()
    {
        try {
            $result = array();
            /*$stm = $this->pdo->prepare("SELECT count(*) as cantidad
                FROM despacho d
                INNER JOIN movimiento m
                ON m.Movimiento_Id = d.nDesMovimiento_Id
                WHERE nDesEstado = 0
                AND sObservacion IS NOT NULL;");*/
            $stm = $this->pdo->prepare("SELECT COUNT(*) as cantidad
                FROM despacho d
                INNER JOIN movimiento m ON m.Movimiento_Id = d.nDesMovimiento_Id
                WHERE d.nDesEstado = 0
                AND d.sObservacion IS NOT NULL
                AND m.nMovEstado !=0;");
            $stm->execute();

            // year(m.dMovFecha) = year(now())
            //     AND month(m.dMovFecha) = month(now())  
            //     AND 
            
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function VerDespachosIncompletos()
    {
        try {
            
            $result = array();
            // $stm = $this->pdo->prepare("SELECT *
            //     FROM despacho d
            //     INNER JOIN movimiento m
            //     ON m.Movimiento_Id = d.nDesMovimiento_Id
            //     WHERE nDesEstado = 0
            //     AND sObservacion IS NOT NULL;");

            $stm = $this->pdo->prepare("CALL ver_despachos_incompletos();");
            $stm->execute();
            
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function ExisteDocumento($sMovDocumento, $Documento_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT COUNT(*) as cantidad FROM movimiento WHERE sMovDocumento = ? AND Documento_Id = ?;");
            $stm->execute([$sMovDocumento, $Documento_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
