<?php
class OrdenCompraModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function ListarDate($fechaInicio, $fechaFin, $TipoMovimiento_Id, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL oc_date('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ", " . $UserId . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $oc = new OrdenCompra();
                $oc->__SET('OrdenCompra_Id', $r->OrdenCompra_Id);
                $oc->__SET('dOCFecha', date('d-m-Y', strtotime($r->dOCFecha)));
                $oc->__SET('nOCTipoMovimiento_Id', $r->nOCTipoMovimiento_Id);
                $oc->__SET('sTMovNombre', $r->sTMovNombre);
                $oc->__SET('nOCTipopago', $r->nOCTipopago);
                $oc->__SET('Almacen_Id', $r->Almacen_Id);
                $oc->__SET('nOCTipoOrigenDestino', $r->nOCTipoOrigenDestino);
                $oc->__SET('nOCOrigenDestino_Id', $r->nOCOrigenDestino_Id);
                $oc->__SET('sODNombreComercial', $r->sODNombreComercial);
                $oc->__SET('sAlmNombre', $r->sAlmNombre);
                $oc->__SET('nOCTipodestino', $r->nOCTipodestino);
                $oc->__SET('Documento_Id', $r->Documento_Id);
                $oc->__SET('sDocNombre', $r->sDocNombre);
                $oc->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $oc->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $oc->__SET('sOCDocumento', $r->sOCDocumento);
                $oc->__SET('sOCDocReferencia', $r->sOCDocReferencia);
                $oc->__SET('Moneda_Id', $r->Moneda_Id);
                $oc->__SET('nOCTipoCambio', $r->nOCTipoCambio);
                $oc->__SET('nOCImporte', $r->nOCImporte);
                $oc->__SET('nOCIGV', $r->nOCIGV);
                $oc->__SET('nOCTotal', $r->nOCTotal);
                $oc->__SET('nOCSaldo', $r->nOCTotal);
                $oc->__SET('nOCTotalCancelado', $r->nOCTotalCancelado);
                $oc->__SET('dOCDetraccion', $r->dOCDetraccion);
                $oc->__SET('dOCPercepcion', $r->dOCPercepcion);
                $oc->__SET('dOCRetencion', $r->dOCRetencion);
                $oc->__SET('nOCEstadoSunat', $r->nOCEstadoSunat);
                $oc->__SET('nOCEstado', $r->nOCEstado);
                $oc->__SET('isFE', $r->isFE);
                $oc->__SET('nOCEliminado', $r->nOCEliminado);
                $oc->__SET('dOCFecha_Act', $r->dOCFecha_Act);
                $oc->__SET('Usuario_Id', $r->Usuario_Id);
                $oc->__SET('Documento', $r->Documento);
                $oc->__SET('dOCFechaEntrega', $r->dOCFechaEntrega);
                $oc->__SET('sOCLugarEntrega', $r->sOCLugarEntrega);

                $datemovimiento = new DateTime($r->dOCFecha);
                $oc->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $oc;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ConfirmarDespacho($Despacho_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL movdespacho_confirmar(?)");
            $stm->execute([$Despacho_Id]);
            return true;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL oc_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $oc = new OrdenCompra();
                $oc->__SET('OrdenCompra_Id', $r->OrdenCompra_Id);
                $oc->__SET('dOCFecha', date('d-m-Y', strtotime($r->dOCFecha)));
                $oc->__SET('nOCTipoMovimiento_Id', $r->nOCTipoMovimiento_Id);
                $oc->__SET('sTMovNombre', $r->sTMovNombre);
                $oc->__SET('nOCTipopago', $r->nOCTipopago);
                $oc->__SET('Almacen_Id', $r->Almacen_Id);
                $oc->__SET('nOCTipoOrigenDestino', $r->nOCTipoOrigenDestino);
                $oc->__SET('nOCOrigenDestino_Id', $r->nOCOrigenDestino_Id);
                $oc->__SET('sAlmNombre', $r->sAlmNombre);
                $oc->__SET('nOCTipodestino', $r->nOCTipodestino);
                $oc->__SET('Documento_Id', $r->Documento_Id);
                $oc->__SET('sDocNombre', $r->sDocNombre);
                $oc->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $oc->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $oc->__SET('sOCDocumento', $r->sOCDocumento);
                $oc->__SET('sOCDocReferencia', $r->sOCDocReferencia);
                $oc->__SET('Moneda_Id', $r->Moneda_Id);
                $oc->__SET('nOCTipoCambio', $r->nOCTipoCambio);
                $oc->__SET('nOCImporte', $r->nOCImporte);
                $oc->__SET('nOCIGV', $r->nOCIGV);
                $oc->__SET('nOCTotal', $r->nOCTotal);
                $oc->__SET('nOCSaldo', $r->nOCSaldo);
                $oc->__SET('nOCTotalCancelado', $r->nOCTotalCancelado);
                $oc->__SET('dOCDetraccion', $r->dOCDetraccion);
                $oc->__SET('dOCPercepcion', $r->dOCPercepcion);
                $oc->__SET('dOCRetencion', $r->dOCRetencion);
                $oc->__SET('nOCEstado', $r->nOCEstado);
                $oc->__SET('nOCEliminado', $r->nOCEliminado);
                $oc->__SET('dOCFecha_Act', $r->dOCFecha_Act);
                $oc->__SET('Usuario_Id', $r->Usuario_Id);
                $oc->__SET('Documento', $r->Documento);
                $oc->__SET('dOCFechaEntrega', date('d-m-Y', strtotime($r->dOCFechaEntrega)));
                $oc->__SET('sOCLugarEntrega', $r->sOCLugarEntrega);
                $result[] = $oc;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Buscar($OrdenCompra_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL oc_listar($OrdenCompra_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $oc = new OrdenCompra();
                $oc->__SET('OrdenCompra_Id', $r->OrdenCompra_Id);
                $oc->__SET('dOCFecha', date('d-m-Y', strtotime($r->dOCFecha)));
                $oc->__SET('nOCTipoMovimiento_Id', $r->nOCTipoMovimiento_Id);
                $oc->__SET('sTMovNombre', $r->sTMovNombre);
                $oc->__SET('nOCTipopago', $r->nOCTipopago);
                $oc->__SET('Almacen_Id', $r->Almacen_Id);
                $oc->__SET('nOCTipoOrigenDestino', $r->nOCTipoOrigenDestino);
                $oc->__SET('nOCOrigenDestino_Id', $r->nOCOrigenDestino_Id);
                $oc->__SET('nOCTipodestino', $r->nOCTipodestino);
                $oc->__SET('Documento_Id', $r->Documento_Id);
                $oc->__SET('sOCDocumento', $r->sOCDocumento);
                $oc->__SET('sDocNombre', $r->sDocNombre);
                $oc->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $oc->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $oc->__SET('sOCDocReferencia', $r->sOCDocReferencia);
                $oc->__SET('nDocAfectoIGV', $r->nDocAfectoIGV);
                $oc->__SET('Moneda_Id', $r->Moneda_Id);
                $oc->__SET('nOCTipoCambio', $r->nOCTipoCambio);
                $oc->__SET('nOCImporte', $r->nOCImporte);
                $oc->__SET('nOCIGV', $r->nOCIGV);
                $oc->__SET('nOCTotal', $r->nOCTotal);
                $oc->__SET('nOCSaldo', $r->nOCSaldo);
                $oc->__SET('nOCTotalCancelado', $r->nOCTotalCancelado);
                $oc->__SET('dOCDetraccion', $r->dOCDetraccion);
                $oc->__SET('dOCPercepcion', $r->dOCPercepcion);
                $oc->__SET('dOCRetencion', $r->dOCRetencion);
                $oc->__SET('sOCObservacion', $r->sOCObservacion);
                $oc->__SET('nOCEstado', $r->nOCEstado);
                $oc->__SET('nOCEstadoSunat', $r->nOCEstadoSunat);
                $oc->__SET('nOCEliminado', $r->nOCEliminado);
                $oc->__SET('dOCFecha_Act', $r->dOCFecha_Act);
                $oc->__SET('Usuario_Id', $r->Usuario_Id);
                $oc->__SET('Documento', $r->Documento);
                $oc->__SET('sODCorreo', $r->sODCorreo);
                $oc->__SET('sMonDescripcion', $r->sMonDescripcion);
                $oc->__SET('sMonAlias', $r->sMonAlias);
                $oc->__SET('NumeroLetras', $r->NumeroLetras);
                $oc->__SET('sVenNom', $r->sVenNom);
                $oc->__SET('dOCICBPER', $r->dOCICBPER);
                $oc->__SET('nODTipoDoc', $r->nODTipoDoc);
                $oc->__SET('sODTelefono', $r->sODTelefono);
                $oc->__SET('nDocNumImpresiones', $r->nDocNumImpresiones);
                $oc->__SET('dOCFechaEntrega', date('d-m-Y', strtotime($r->dOCFechaEntrega)));
                $oc->__SET('sOCLugarEntrega', $r->sOCLugarEntrega);
              
                $result[] = $oc;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function getByDocumento($documento)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mov_documento('$documento')");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = (array)$r;
                $result['dOCFecha'] = date('d-m-Y', strtotime($r->dOCFecha));
                $datemovimiento = new DateTime($r->dOCFecha);
                $result['dOCDays'] = $datecurrent->diff($datemovimiento)->days;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function getMovimiento($OrdenCompra_Id)
    {
        try {
            $result = null;
            $stm = $this->pdo->prepare("CALL mov_byOrdenCompra($OrdenCompra_Id)");
            $stm->execute();
            $res = $stm->fetch(PDO::FETCH_OBJ);
            if(!empty($res)){
                $result = $res->Movimiento_Id;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Guardar(OrdenCompra $data)
    {
        try {
            $OrdenCompra_Id = 0;
            $stm = $this->pdo->prepare("CALL oc_crear(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,@OrdenCompra_Id)");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dOCFecha'))),
                $data->__get('nOCTipoMovimiento_Id'),
                $data->__get('nOCTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nOCTipoOrigenDestino'),
                $data->__get('nOCOrigenDestino_Id'),
                $data->__get('nOCTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sOCDocumento'),
                $data->__get('sOCDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nOCTipoCambio'),
                $data->__get('nOCImporte'),
                $data->__get('nOCIGV'),
                $data->__get('nOCTotal'),
                $data->__get('nOCSaldo'),
                $data->__get('nOCTotalCancelado'),
                $data->__get('dOCDetraccion'),
                $data->__get('dOCPercepcion'),
                $data->__get('dOCRetencion'),
                $data->__get('sOCObservacion'),
                $data->__get('nOCEstado'),
                $data->__get('nOCEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nOCVendedor_Id'),
                $data->__get('dOCICBPER'),
                date('Y-m-d', strtotime($data->__get('dOCFechaEntrega'))),
                $data->__get('sOCLugarEntrega')
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $OrdenCompra_Id = $r->OrdenCompra_Id;
            }
//            echo "Se guardo correctamente ->".$nOCTipoOrdenCompra_Id;
            return $OrdenCompra_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(OrdenCompra $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL oc_editar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                date('Y-m-d', strtotime($data->__get('dOCFecha'))),
                $data->__get('nOCTipoMovimiento_Id'),
                $data->__get('nOCTipopago'),
                $data->__get('Almacen_Id'),
                $data->__get('nOCTipoOrigenDestino'),
                $data->__get('nOCOrigenDestino_Id'),
                $data->__get('nOCTipodestino'),
                $data->__get('Documento_Id'),
                $data->__get('sOCDocumento'),
                $data->__get('sOCDocReferencia'),
                $data->__get('Moneda_Id'),
                $data->__get('nOCTipoCambio'),
                $data->__get('nOCImporte'),
                $data->__get('nOCIGV'),
                $data->__get('nOCTotal'),
                $data->__get('nOCSaldo'),
                $data->__get('nOCTotalCancelado'),
                $data->__get('dOCDetraccion'),
                $data->__get('dOCPercepcion'),
                $data->__get('dOCRetencion'),
                $data->__get('sOCObservacion'),
                $data->__get('nOCEstado'),
                $data->__get('nOCEliminado'),
                $data->__get('Usuario_Id'),
                $data->__get('nOCVendedor_Id'),
                $data->__get('dOCFechaEntrega'),
                $data->__get('sOCLugarEntrega'),
                $data->__get('OrdenCompra_Id')
                
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL oc_eliminar(?,?)");
            $stm->execute(array($data->__get('OrdenCompra_Id'), $data->__get('Usuario_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function CerrarOrden(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL oc_cerrar(?,?)");
            $stm->execute(array($data->__get('OrdenCompra_Id'), $data->__get('Usuario_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function updaeteEstado($OrdenCompra_Id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("update ordencompra set `nOCEstadoSunat` = ? where OrdenCompra_Id = ?");
            $stm->execute([$estado, $OrdenCompra_Id]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
       public function act_obs_docref(Movimiento $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL act_obs_docref(?,?,?)");
            $stm->execute(array(
                $data->__get('sOCDocReferencia'),
                $data->__get('sOCObservacion'),
                $data->__get('OrdenCompra_Id')
            ));
           echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito</strong>, los datos fueron editados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
?>
