<?php 
class PersonalModel {
    private $pdo;
    public function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL per_listar(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $per = new Personal();
                $per->__SET('Personal_Id', $r->Personal_Id);
                $per->__SET('sPerApePaterno', $r->sPerApePaterno);
                $per->__SET('sPerApeMaterno', $r->sPerApeMaterno);
                $per->__SET('sPerNombres', $r->sPerNombres);
                $per->__SET('sPerDNI', $r->sPerDNI);
                $per->__SET('sPerCargo', $r->sPerCargo);
                $per->__SET('nPerEliminado', $r->nPerEliminado);
                $per->__SET('nPerEstado', $r->nPerEstado);
                $per->__SET('dPerFecha_Act', $r->dPerFecha_Act);
                $per->__SET('nPerUsuario_Id', $r->nPerUsuario_Id);
                $result[] = $per;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($Personal_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL per_listar($Personal_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $per = new Personal();
                $per->__SET('Personal_Id', $r->Personal_Id);
                $per->__SET('sPerApePaterno', $r->sPerApePaterno);
                $per->__SET('sPerApeMaterno', $r->sPerApeMaterno);
                $per->__SET('sPerNombres', $r->sPerNombres);
                $per->__SET('sPerDNI', $r->sPerDNI);
                $per->__SET('sPerCargo', $r->sPerCargo);
                $per->__SET('nPerEliminado', $r->nPerEliminado);
                $per->__SET('nPerEstado', $r->nPerEstado);
                $per->__SET('dPerFecha_Act', $r->dPerFecha_Act);
                $per->__SET('nPerUsuario_Id', $r->nPerUsuario_Id);
                $result[] = $per;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_crear(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                $data->__get('sPerApePaterno'),
                                $data->__get('sPerApeMaterno'),
                                $data->__get('sPerNombres'),
                                $data->__get('sPerDNI'),
                                $data->__get('sPerCargo'),
                                $data->__get('nPerEliminado'),
                                $data->__get('nPerEstado'),
                                $data->__get('nPerUsuario_Id')
                         ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    La informacion fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_editar(?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('Personal_Id'),
                                 $data->__get('sPerApePaterno'),
                                 $data->__get('sPerApeMaterno'),
                                 $data->__get('sPerNombres'),
                                 $data->__get('sPerDNI'),
                                 $data->__get('sPerCargo'),
                                 $data->__get('nPerEliminado'),
                                 $data->__get('nPerEstado'),
                                 $data->__get('nPerUsuario_Id')
                                ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Exito, </h4>
                    Se modifico correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Personal $data){
        try {
            $stm = $this->pdo->prepare("CALL per_eliminar(?)");
            $stm->execute(array($data->__get('Personal_Id')));     
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}