<?php
class VendedorModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

     public function Buscar($vendedor_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ven_listar($vendedor_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ori = new Vendedor();
                $ori->__SET('vendedor_id', $r->vendedor_id);
                $ori->__SET('sVenNom', $r->sVenNom);
                $ori->__SET('nVenPorCom', $r->nVenPorCom);
                $ori->__SET('nVenEstado', $r->nVenEstado);
                $ori->__SET('dVenFecha_Act', $r->dVenFecha_Act);
                $ori->__SET('nVenUsuario_Id', $r->nVenUsuario_Id);
                $ori->__SET('nVenEliminado', $r->nVenEliminado);
                $result[] = $ori;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ven_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ori = new Vendedor();
                $ori->__SET('vendedor_id', $r->vendedor_id);
                $ori->__SET('sVenNom', $r->sVenNom);
                $ori->__SET('nVenPorCom', $r->nVenPorCom);
                $ori->__SET('nVenEstado', $r->nVenEstado);
                $ori->__SET('dVenFecha_Act', $r->dVenFecha_Act);
                $ori->__SET('nVenUsuario_Id', $r->nVenUsuario_Id);
                $ori->__SET('nVenEliminado', $r->nVenEliminado);
                $result[] = $ori;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Crear(Vendedor $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL ven_crear(?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('sVenNom'),
                $data->__get('nVenPorCom'),
                $data->__get('nVenEstado'),
                0,
                $data->__get('dVenFecha_Act'),
                $data->__get('nVenUsuario_Id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito, información guardada</strong>. Los datos fueron registrados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Vendedor $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL ven_editar(?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('vendedor_id'),
                $data->__get('sVenNom'),
                $data->__get('nVenPorCom'),
                $data->__get('nVenEstado'),
                0,
                $data->__get('dVenFecha_Act'),
                $data->__get('nVenUsuario_Id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito, información editada</strong>. Los datos fueron editados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Vendedor&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Vendedor $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL ven_eliminar(?)");
            $stm->execute(array($data->__get('vendedor_id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

   
}
?>
