<?php
require_once '../extends/request-services.php';
// require_once '../hormiguita/model/seguridad/db.php';
class ReenviarComprobante
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'db.php';
            $this->pdo = DB::cn();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function run()
    {
        return $this->getMovimientos();
    }

    public function getMovimientos()
    {
        try {
            $movimientos = [];
            $stm = $this->pdo->prepare("SELECT * from vpsfmsac_hormiguita_fmsac.movimiento m WHERE Documento_Id IN (1,2) AND nMovEstadoSunat in (0,-1,500) AND nMovEstado IN(1,2) AND DATEDIFF(now(), m.dMovFecha) <= 3;");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $movimientos[] = $r->Movimiento_Id;
            }
            return json_encode($movimientos);
        } catch (PDOException $e) {
            print "¡Error!: " . $e->getMessage() . "<br/>";
            die();
        }
    }
}

$execute = new ReenviarComprobante();
$data = $execute->run();
?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Envio de comprobantes</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

</head>

<body>
    <div class="container">
        <div class="row">
            <h4>Enviando comprobantes FMSAC</h4>
            <hr>
            <div class="col-md-12" id="resultado"></div>
            <img src="http://hormiguitala.com/view/librerias/catpcha/captcha.php" class="d-none" />
        </div>
    </div>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script type="text/javascript">
        console.log(JSON.stringify(<?php echo $data; ?>));
        console.log();
        var code = 'FelipeXMarroquin2020';

        function login() {
            $.post('http://hormiguitala.com/?c=Principal&a=verificarUsuario', {
                usuario: 'felipe.marroquin',
                clave: '20482092897',
                // usuario: 'ana.tirado',
                // clave: 'aluciat202101',
                codigocaptcha: code
            }, function(data) {
                enviarcomprobantes();
            });
        }

        function enviarcomprobantes() {
            var movimientos = <?php echo $data; ?>;
            for (var i = 0; i < movimientos.length; i++) {
                const promise = new Promise((resolve, reject) => {
                    const movimiento_id = movimientos[i];
                    setTimeout(() => {
                        $.post('http://hormiguitala.com/?c=Movimiento&a=enviarcomprobante', {
                        Movimiento_Id: movimiento_id
                    }, function(data) {
                            $("#resultado").append(`<h4>ID_Movimiento: ${movimiento_id}</h4>` + data);
                        });
                    }, 3000);
                });
            }
        }
     
        $(document).ready(function() {
            login();
        });
    </script>
</body>

</html>