document.addEventListener('DOMContentLoaded', function () {
	document.getElementById('nGasMonto').addEventListener('input', function(e) {
		const rgx = /^[0-9\b.]+$/
		if (rgx.test(e.target.value)) {
			document.getElementById('nGasMonto').value = e.target.value
		} else {
			document.getElementById('nGasMonto').value = e.target.value.slice(0, -1)
		}
	})
})

function dateNow(param) {
	const now = new Date()
	const year = now.getFullYear()
	const month = String(now.getMonth() + 1).padStart(2, '0')
	const day = String(now.getDate()).padStart(2, '0')
	
	if (param) {
		console.log('aca')
		const pyear = param.split('-')[0]
		const pmonth = param.split('-')[1]
		const pday = param.split('-')[2].split(' ')[0]
		document.getElementById('dMovFecha').value = `${pyear}-${pmonth}-${pday}`
	} else {
		console.log('aca2')
		document.getElementById('dMovFecha').value = `${year}-${month}-${day}`
	}
}

function addExpense() {
	clearForm()

	$('#modal-register').modal('show')
}

function GuardarGasto() {
	const Gasto_Id = document.getElementById('Gasto_Id').value
	const dMovFecha = document.getElementById('dMovFecha').value
	const sGasDescripcion = document.getElementById('sGasDescripcion').value
	const nGasMonto = document.getElementById('nGasMonto').value

	let flagBoxes = false
	const checboxes = document.querySelectorAll('input[type="checkbox"]')
	checboxes.forEach(checkbox => {
		if (checkbox.checked) {
			flagBoxes = true
			return
		}
	})

	const valuesCheck = Array.from(checboxes).map(check => {
		return {
			id: check.id,
			checked: check.checked
		}
	})

	if (!dMovFecha) {
		swal('Warning', 'Date is a required field', 'warning')
		return
	}

	if (!sGasDescripcion) {
		swal('Warning', 'Description is a required field', 'warning')
		return
	}

	if (!nGasMonto || nGasMonto <= 0) {
		swal('Warning', 'Amount is a required field', 'warning')
		return
	}

	if (!flagBoxes) {
		swal('Warning', 'Select at least one destination', 'warning')
		return
	}


    $.post('?c=Gasto&a=GuardarGasto', {
		Gasto_Id: Gasto_Id,
        dMovFecha: dMovFecha,
        sGasDescripcion: sGasDescripcion,
        nGasMonto: nGasMonto,
		checkboxes: JSON.stringify(valuesCheck)
    }, function(data) {
        console.log(data)
		// clearForm()

        $('#response_expense').html(data);

        setTimeout(function() {
			// $('#modal-register').modal('hide')
            // window.location.reload();
        }, 3000);
    })
	
}

function clearForm() {
	dateNow('')
	document.getElementById('Gasto_Id').value = ''
	document.getElementById('sGasDescripcion').value = ''
	document.getElementById('nGasMonto').value = ''
	const checboxes = document.querySelectorAll('input[type="checkbox"]')
	checboxes.forEach(checkbox => checkbox.checked = false)
}

function MostrarGasto(Gasto_Id) {
	$.post('?c=Gasto&a=MostrarGasto', {
		Gasto_Id: Gasto_Id
	}, function(data) {
		document.getElementById('ver_datos').innerHTML = data
	})
}

function EliminarGasto() {
	const Gasto_Id = document.getElementById('Gasto_Id').value
	$.post('?c=Gasto&a=EliminarGasto', {
		Gasto_Id: Gasto_Id
	}, function(data) {
		$('#modal-eliminar').modal('hide')
		$('#preloader').fadeOut('slow')
		$('#script_js').html(data)
	})
}

function FrmEditarGasto(Gasto_Id) {
	clearForm()

	$.post('?c=Gasto&a=getGasto', {
		Gasto_Id: Gasto_Id
	}, function (data) {
		console.log(data)
		const json = JSON.parse(data)
		if (json.length > 0) {
			dateNow(json[0].dGasFechaEmision)
			document.getElementById('Gasto_Id').value = json[0].Gasto_Id
			document.getElementById('sGasDescripcion').value = json[0].sGasDescripcion
			document.getElementById('nGasMonto').value = json[0].nGasMonto
			
			$.post('?c=Gasto&a=getGastoDetalle', {
				Gasto_Id: Gasto_Id
			}, function(detalle) {
				const jsonDetalle = JSON.parse(detalle)

				if (jsonDetalle.length > 0) {
					jsonDetalle.forEach(element => {
						document.getElementById(element.Enterprise_Id).checked = true
					});
				}
			})
			
			document.getElementById('span_update').classList.remove('hidden')
			document.getElementById('span_save').classList.add('hidden')

			$('#modal-register').modal('show')
		}
	})
}

function FrmGuardarGasto() {
	$.post('?c=Gasto&a=FrmGuardarGasto', {}, function(data) {
		$('.content-wrapper').html(data);
	})
}