var dataTable = []
var rows = 0

function agregarDescuentoTabla() {
    const select = document.getElementById('Concepto_Id')
    const idDescuento = select.options[select.selectedIndex].value.split('|')[0]
    const nIDMonto = document.getElementById('nIDMonto').value
    const descripcion = select.options[select.selectedIndex].text
    
    if (parseInt(idDescuento) === 0) {
        swal('Advertencia', 'Debe de seleccionar un descuento', 'warning')
        return
    }

    if (nIDMonto === '' || parseFloat(nIDMonto) <= 0) {
        swal('Advertencia', 'Debe de ingresar un monto valido', 'warning')
        return
    }

    const exist = dataTable.findIndex((item) => item.Concepto_Id === parseInt(idDescuento))
    if (exist >= 0) {
        swal('Advertencia', 'El descuento ya esta en la lista.', 'warning')
        return
    }

    dataTable.push(
        {
            num: ++rows,
            Concepto_Id: parseInt(idDescuento),
            sConNombre: descripcion,
            nIDMonto: nIDMonto
        }
    )
    limpiarLista()
    renderTable(dataTable)
}

function removeRow(id) {
    dataTable = dataTable.filter((item) => parseInt(item.Concepto_Id) !== id)
    rows = rows - 1
    renderTable(dataTable)
}

function renderTable(data) {
    const tableBody = document.getElementById('tbDescuentos')
    tableBody.innerHTML = ''

    let tableHTML = ''

    if (data.length === 0) {
        tableHTML = '<tr><td colspan="3" class="text-center">No hay descuentos agregados</td></tr>'
    } else {
        data.forEach((item) => {
            tableHTML += `
                <tr>
                    <td>${ item.sConNombre }</td>
                    <td>${ item.nIDMonto }</td>
                    <td>
                        <button type="button" class="btn btn-danger btn-xs" onclick="removeRow(${item.Concepto_Id})"><i class="fa fa-trash"></i></button>
                    </td>
                </tr>
            `
        })
    }

    tableBody.innerHTML = tableHTML

    calcularTotales()
}

function FrmGuardarIngreso() {
    $.post('?c=Ingreso&a=FrmGuardarIngreso', {}, function (data) {
        $('.content-wrapper').html(data);
    });
}

function calcularTotales() {
    document.getElementById('nIngTotalVarios').value = dataTable.reduce((a, b) => a + parseFloat(b.nIDMonto), 0).toFixed(2)

    // const tabla = document.getElementById('tbDescuentos')
    // let totalDesc = 0

    // for (let i = 0; i < tabla.rows.length; i++) {
    //     if (tabla.rows[i].cells.length > 1) {
    //         totalDesc += parseFloat(tabla.rows[i].cells[1].innerText).toFixed(2) || 0
    //     } else {
    //         totalDesc = 0
    //     }
    // }

    // document.getElementById('nIngTotalVarios').value = parseFloat(totalDesc).toFixed(2)

    // document.getElementById('nIngTotalNeto').value = (parseFloat(document.getElementById('nIngCargaFinal').value) - totalDesc).toFixed(2)

    // % comision -> neto/cargafinal
    // document.getElementById('nIngPorcenComision').value = ((parseFloat(document.getElementById('nIngTotalNeto').value) / parseFloat(document.getElementById('nIngCargaFinal').value)) * 100).toFixed(0)

    // % retorno -> retornos/cargafinal
    // document.getElementById('nIngPorcenRetorno').value = ((parseFloat(document.getElementById('nIngRetornos').value) / parseFloat(document.getElementById('nIngCargaFinal').value)) * 100).toFixed(0)
}

function agregarDescuento() {
    const select = document.getElementById('Concepto_Id')

    const cantidad = select.options.length

    if (cantidad === 1) {
        $.post('?c=Ingreso&a=ObtenerDescuentoFijos', {}, function(data) {
            const json = JSON.parse(data)
            json.forEach((item) => {
                let option = document.createElement('option')

                option.value = item.Concepto_Id + '|' + item.nConValor
                option.text = item.sConNombre

                select.appendChild(option)
            })
            $('#Concepto_Id').selectpicker('refresh')
        })
    }
}

function cargarMonto() {
    const select = document.getElementById('Concepto_Id')
    const value = select.options[select.selectedIndex].value
    const monto = value.split('|')[1] === undefined ? '' : value.split('|')[1]
    document.getElementById('nIDMonto').value = monto
}

function limpiarLista() {
    document.getElementById('Concepto_Id').value = 0
    $('#Concepto_Id').selectpicker('refresh')
    document.getElementById('nIDMonto').value = 0
}

function calcularPorcentajes() {
    if (parseFloat(document.getElementById('nIngTotalNeto').value) < 0 || document.getElementById('nIngTotalNeto').value === '') {
        document.getElementById('nIngPorcenComision').value = 0
        document.getElementById('nIngPorcenRetorno').value = 0
    } else {
        document.getElementById('nIngPorcenComision').value = ((parseFloat(document.getElementById('nIngTotalNeto').value) / parseFloat(document.getElementById('nIngCargaFinal').value)) * 100).toFixed(0)
        document.getElementById('nIngPorcenRetorno').value = ((parseFloat(document.getElementById('nIngRetornos').value) / parseFloat(document.getElementById('nIngCargaFinal').value)) * 100).toFixed(0)
    }
}

function GuardarIngreso() {
    const Ingreso_Id = document.getElementById('Ingreso_Id').value
    const dIngFechaInicio = document.getElementById('dIngFechaInicio').value
    const dIngFechaFin = document.getElementById('dIngFechaFin').value
    const nIngCargaFinal = document.getElementById('nIngCargaFinal').value
    const nIngRetornos = document.getElementById('nIngRetornos').value
    const nIngVentasNetas = document.getElementById('nIngVentasNetas').value
    const nIngPromociones = document.getElementById('nIngPromociones').value
    const nIngPermisoEfectivo = document.getElementById('nIngPermisoEfectivo').value
    const nIngTotalPrevisiones = document.getElementById('nIngTotalPrevisiones').value
    const nIngTotalVarios = document.getElementById('nIngTotalVarios').value
    const nIngTotalNeto = document.getElementById('nIngTotalNeto').value
    const nIngPorcenComision = document.getElementById('nIngPorcenComision').value
    const nIngPorcenRetorno = document.getElementById('nIngPorcenRetorno').value

    const nIngrEnterprise_Id = document.getElementById('nIngrEnterprise_Id').value

    if (nIngCargaFinal < 0 || nIngCargaFinal === '') {
        swal('Warning', 'The Final Charge cannot be negative!', 'warning')
        return
    }

    if (nIngTotalNeto === '') {
        swal('Warning', 'The Total cannot be empty!', 'warning')    
        return
    }

    if (parseInt(nIngrEnterprise_Id) === 0) {
        swal('Warning', 'You must select a company!', 'warning')    
        return
    }

    $.post('?c=Ingreso&a=GuardarIngreso', {
        Ingreso_Id: Ingreso_Id,
        dIngFechaInicio: dIngFechaInicio,
        dIngFechaFin: dIngFechaFin,
        nIngCargaFinal: nIngCargaFinal,
        nIngRetornos: nIngRetornos,
        nIngVentasNetas: nIngVentasNetas,
        nIngPromociones: nIngPromociones,
        nIngPermisoEfectivo: nIngPermisoEfectivo,
        nIngTotalPrevisiones: nIngTotalPrevisiones,
        nIngTotalVarios: nIngTotalVarios,
        nIngTotalNeto: nIngTotalNeto,
        nIngPorcenComision: nIngPorcenComision,
        nIngPorcenRetorno: nIngPorcenRetorno,
        nIngrEnterprise_Id: nIngrEnterprise_Id,
        details: dataTable
    }, function (data) {
        console.log(data)

        $('#response_income').html(data)

        setTimeout(() => {
            window.location.reload()
        }, 500)
    })
}

function FrmVerIngreso(id) {
    $.post('?c=Ingreso&a=VerIngreso', {
        Ingreso_Id: id
    }, function (data) {
        $('#ver_datos').html(data);
    })
}

function FrmEditarIngreso(id) {
    $.post('?c=Ingreso&a=FrmEditarIngreso', {
        Ingreso_Id: id
    }, function (data) {
        $('.content-wrapper').html(data);

        $.post('?c=Ingreso&a=ListarIngresosDetalleTabla', {
            Ingreso_Id: id
        }, function (data) {
            console.log(data)
            const json = JSON.parse(data)

            for (let i = 0; i < json.length; i++) {
                const element = json[i]

                dataTable.push(
                    {
                        //num: ++rows,
                        num: i + 1,
                        Concepto_Id: parseInt(element.Concepto_Id),
                        sConNombre: element.sConNombre,
                        nIDMonto: element.nIDMonto
                    }
                )
            }

            renderTable(dataTable)
        })

    })
}

function EliminarIngreso() {
    $.post('?c=Ingreso&a=EliminarIngreso', {
        Ingreso_Id: document.getElementById('Ingreso_Id').value
    }, function (data) {
        console.log(data)
        
        setTimeout(() => {
            window.location.reload()
        }, 500)
    })
}

function exportarExcel() {
    $('#preloader').fadeIn('slow')
    $.post('?c=Ingreso&a=ExportarExcel', {

    }, function (data) {
        console.log(data)
        const json = JSON.parse(data)
        window.location.href = '?c=Ingreso&a=donwloadExcel&filename=' + json.filename

        $('#preloader').fadeOut('slow')
    })
}