<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <title>Comprobante</title> 
        <style type="text/css">
            @media print{
                @page {
                    size: portrait;
                    margin-left: 15px;
                    margin-top: 15px;
                    top:5px;
                    left:5px;
                }
            }

            body{
                font-size: 18px;
                font-family: Helvetica;
                padding: 8px;
            }

            .container{
                /*position: absolute;
                padding: 5px;
                top:0px;
                width: 100%;*/
                size: auto;
                margin: 0.1mm 0.1mm 0.1mm 0.1mm;
                /*transform: scale(0.5);*/
                transform-origin: top center; 
                /* height: 50%; */
            }

            .empresa{
                padding:1%;
                width: 70%;
                font-family: Helvetica;
                font-size: 10px;
                font-weight: normal;
                /* display:flex; */
            }

            .empresa img{
                max-width: 100%;
                width: 30%;
            }

            .empresa p{
                margin-left: 20px;
                margin-right: 20px;
            }

            .cabecera{
                width: 100%;
                display: flex;
            }

            .data-ruc{
                display: table-cell;
                vertical-align: middle;
                font-family: helvetica;
                font-weight: 600;
                text-align: center;
                position: relative;
                border: 4px solid #000;
                width: 35%;
                /* margin-left: 39%; */
                height: 150px;
            }

            .data-ruc .fact-elect{
                background-color: #cccccc;
                padding-top: 5px;
                padding-bottom: 5px;
                width: 100%;
            }

            .data-factura{
                border: 3px solid #000;
                font-family: helvetica;
                line-height:13px;
                font-size: 13px;
                display: flex;
                margin-top: 10px;
            }

            .data-factura p{}

            p span{
                font-weight:700;
                margin-right: 1%;
                width: 50%;
                line-height: 13px;
            }

            p.campo{
            	font-size: 16px;
                display: flex;
            } 

            p span.contenido-campo{
                display: table-cell;
                font-weight: normal;
                line-height: 13px;
                padding-left: 20px;
            }

            .data-factura .columna{
                width: 50%;
                padding-left: 10px;
            }

            .contenido-factura{
                margin-top: 10px;
                display:table;
                width: 100%;
                min-height: 250px;
                height: 250px;
                margin-bottom: 20px;
            }

            .contenido-factura-thead, .NumeroLetras{
                border: 3px solid #000;
                padding: 5px;
                display:flex;
            }

            .contenido-factura-th{
                display:table-cell;
                width: 20%;
                text-align: center;
                font-weight: bolder;
                padding-right: 10px;
                padding-left: 10px;
            }

            .contenido-factura-tbody{
                display:flex;
                position:relative;
                margin-bottom:7px;
            }

            .contenido-factura-tr{
                display:table-cell;
                text-align: center;
                padding-right: 10px;
                padding-left: 10px;
            }

            .contenido-factura-tbody-wrapper{
                border: 3px solid #000;
                height: 230px;
                margin-top: 15px;
                padding-top:10px;
                position:relative;
            }

            .observacion{
                font-weight: bold;
                margin-top: 10px;
                margin-bottom:10px;
                padding-left:10px;
                padding-bottom: 5px;
                position:absolute;
                bottom: 0;
            }


            .pie{
                width: 100%;
                display:flex;
                line-height: 5px !important;
            }

            .pie .pre-totales{
                padding:10px;
                border: 3px solid #000;
                margin-right:10px;
                width:35%;
            }

            .pie .pre-totales .contenido-campo{
                text-align: right;
            }

            .pie .QR{
                margin-top: -10px;
                max-height:130px;
                font-size: 9px;
                margin-right:10px;
                width: 29%;
                text-align: center;
            }

            .pie .label-totales{
                width:26%;
                padding:10px;
                text-align:right;
                border: 3px solid #000;
                border-right: 0px;
                font-weight: bolder;
            }

            .pie .totales{
                text-align: right;
                padding:10px;
                border: 3px solid #000;
                width: 10%;
                border-left: 0px;
            }

            .informacion {
                width: 100%;
                display: block;
                font-size: 14px;
            }
            .informacion label {
                font-weight: bold;
            }
            .informacion table {
                text-align: left;
                margin-bottom: 10px;
            }
        </style>
    </head>
    <body>
        <div class="container">
            <div class="cabecera">
                <div class="empresa">
                    <img src="./view/librerias/dist/img/<?php echo $_SESSION['usu_enterpriseRuc']; ?>.png" width="50"/>
                    <p><span style="font-size: 18px; line-height: normal"><?php echo $_SESSION['usu_enterpriseName']; ?></span><br /><br />
                        <?php echo $_SESSION['usu_enterpriseAddress']; ?><br />
                        <?php echo $_SESSION['usu_enterpriseUbigeoName']; ?>
                </div>
                <div class="data-ruc">
                    <p>R.U.C <?php echo $_SESSION['usu_enterpriseRuc']; ?></p>
                    <p class="fact-elect"><?php echo 'GUIA DE REMISIÓN'; ?></p>
                    <p><?php echo $guia['sTraSerie'] . '-' . $guia['sTraNumero']; ?></p>
                </div>
            </div>
            <div class="informacion">
                <label>DATOS DE INICIO DEL TRASLADO</label>
                <table>
                        <tr>
                        <th>Fecha de Emisión</th>
                        <td><?php echo date('d-m-Y', strtotime($guia['dTraFecha'])); ?></td>
                    </tr>
                    <tr>
                        <th>Fecha de Inicio del traslado</th>
                        <td><?php echo date('d-m-Y', strtotime($guia['dTraFechaTraslado'])); ?></td>
                    </tr>
                    <tr>
                        <th>Motivo de traslado</th>
                        <td><?php echo $guia['sTraMotivoTraslado']; ?></td>
                    </tr>
                    <tr>
                        <th>Modalidad de transporte</th>
                        <td><?php echo $guia['sTraDescripcionModalidadTraslado']; ?></td>
                    </tr>
                    <tr>
                        <th>Peso Bruto Total de la Guia (KGM)</th>
                        <td><?php echo $guia['nTraPesoBrutoGuiaTraslado']; ?></td>
                    </tr>
                </table>
            </div>
            <div class="informacion">
                <label>DATOS DEL DESTINATARIO</label>
                <table>                   
                    <tr>
                        <th>Apellidos y Nombres, denominación o razón</th>
                        <td><?php echo $guia['sCliente']; ?></td>
                    </tr>
                    <tr>
                        <th>Documento de identidad</th>
                        <td><?php echo $guia['sCliNroIdentidad']; ?></td>
                    </tr>
                </table>
            </div>
            <div class="informacion">
                <label>DATOS DEL TRANSPORTISTA</label>
                <table>                   
                    <tr>
                        <th>Apellidos y Nombres, denominación o razón</th>
                        <td><?php echo $guia['sTraNombreTransportistaTraslado']; ?></td>
                    </tr>
                    <tr>
                        <th>Número de RUC</th>
                        <td><?php echo $guia['sTraRUCTransportistaTraslado']; ?></td>
                    </tr>
                </table>
            </div>
            <div class="informacion">
                <label>DATOS DEL PUNTO DE PARTIDA Y PUNTO DE LLEGADA</label>
                <table>                   
                    <tr>
                        <th>Dirección del punto de partida</th>
                        <td><?php echo $guia['sTraDireccionPuntoPartidaTraslado']; ?></td>
                    </tr>
                    <tr>
                        <th>Dirección del punto de Llegada</th>
                        <td><?php echo $guia['sTraDireccionPuntoLlegadaTraslado']; ?></td>
                    </tr>
                </table>
            </div>
            
            <div class="informacion">
                <label>DATOS DE LOS BIENES</label>
                <table class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Nro</th>
                            <th>Cod. Bien</th>
                            <th>Descripción</th>
                            <th>Unidad de medida</th>
                            <th>Cantidad</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php 
                        $i = 0;
                        foreach ($detalle as $item) {
                            $i++;
                            ?>
                        <tr>
                            <td><?php echo $i; ?></td>
                            <td><?php echo $item['Guiaremisiondetalle_Id']; ?></td>
                            <td><?php echo $item['sProNombre']; ?></td>
                            <td><?php echo $item['sUMeCodigoSunat']; ?></td>
                            <td><?php echo $item['nTDeCantidad']; ?></td>
                        </tr>
                        <?php 
                    }
                    ?>
                    </tbody>
                </table>
            </div>
            <div class="informacion">
                <label>Observaciones</label>
                <p>
                    <?php echo $guia['sTraDireccionPuntoLlegadaTraslado']; ?>
                </p>
            </div>
            <table style="width: 100%;">
                <tr>
                    <td>
                        <div class="informacion">                
                            <label>DATOS DE LOS VEHICULOS</label>
                            <table>
                                <tr>
                                    <th>Número de placa</th>
                                    <td><?php echo $guia['sTraPlacaVehiculoTraslado']; ?></td>
                                </tr>
                            </table>
                        </div>
                    </td>
                    <td>
                        <div class="informacion">                
                            <label>DATOS DEL CONDUCTOR</label>
                            <table class="table table-bordered table-striped">
                                <tr>
                                    <th>DNI</th>
                                    <td><?php echo $guia['sTraDNIConductorTraslado']; ?></td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
            </table>
            <table style="width: 100%;">
                <td style="text-align: center;">
                    <?php 
                    $dataText   = $guia['sTraSerie'] . '-' . $guia['sTraNumero'];
                    $svgTagId   = 'id-of-svg';
                    $saveToFile = false;
                    $imageWidth = 200; // px        
                    // SVG file format support
                    $svgCode = QRcode::svg($dataText, $svgTagId, $saveToFile, QR_ECLEVEL_L, $imageWidth);         
                    echo $svgCode;
                    ?>
                    <br>
                    Representación impresa de la Guía de Remisión Electrónica
                </td>
            </table>
        </div>
        <script src="view/librerias/plugins/jQuery/jquery-1.11.0.min.js"></script>
        <script>
            $(document).ready(function () {
                //  window.print(); 
            });
        </script>
    </body>
</html>