<!-- Content Header (Page header) -->
<style type="text/css">
    #totalp {
        width: 100px !important;
    }

    #totalg {
        width: 150px !important;
    }
</style>
<section class="content-header">
    <h1>
        Reports by year
        <small></small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="/bkhormiguita"><i class="fa fa-dashboard"></i> Home</a></li>
        <li><a href="#">Reports by year</a></li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-xs-12">
            <div class="box box-primary">
                <div class="box-header">
                    <h3 class="box-title">Reports by year</h3>
                    <div class="row">
                        <div class="col-md-8" style="margin-top: 15px;">
                            <form action="?c=Reportes&a=byYear" method="POST">
                                <div class="row">
                                    <div class="col-md-3">
                                        Year <br />
                                        <input type="text" class="form-control" name="fechaIni" id="fechaIni">
                                    </div>
                                    <!-- <div class="col-md-3">
                                        Company<br>
                                        <select class="form-control" name="company" id="company">
                                            <option value="0">All</option>
                                            <option value="1">Gielow I</option>
                                            <option value="2">Gielow II</option>
                                            <option value="3">Gielow III</option>
                                            <option value="4">Personal</option>
                                        </select>
                                    </div> -->
                                    <div class="col-md-3">
                                        <br>
                                        <button type="submit" class="btn btn-danger btn-flat">Filter</button>
                                        <!-- <button type="button" class="btn btn-success btn-flat" id="click-export-excel">Export</button> -->
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div><!-- /.box-header -->
                <div class="box-body">

                    <table id="example1" class="table table-hover display responsive no-wrap">
                        <thead>
                            <tr>
                                <th>MONTHS</th>
                                <th>CHEQUE</th>
                                <th>% COMISION</th>
                                <th>% RETURNS</th>
                                <th>TOTAL</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach ($reportes as $item) { ?>
                                <tr>
                                    <td><?php echo $item->Mes; ?></td>
                                    <td><?php echo $item->Cheque; ?></td>
                                    <td><?php echo intval($item->comision) . '%'; ?></td>
                                    <td><?php echo '-' . intval($item->retorno) . '%'; ?></td>
                                    <td><?php echo (intval($item->comision) + intval($item->retorno)) . '%' ?></td>
                                </tr>
                            <?php } ?>
                        </tbody>
                        <tfoot>
                            <tr>
                                <th style="visibility:hidden">Total</th>
                                <th id="totalp" style="visibility:hidden">Total p&aacute;gina:</th>
                                <th id="totalg" style="visibility:hidden"></th>
                                <th style="visibility:hidden">Total </th>
                            </tr>
                        </tfoot>
                    </table>

                    <div id="grafico_vistamensual" style="margin: 0 auto; max-height: 600px; max-width: 900px;">
                        <canvas id="myChart" width="400" height="200"></canvas>
                    </div>

                </div><!-- /.box-body -->
            </div><!-- /.box -->
        </div><!-- /.col -->
    </div><!-- /.row -->
</section><!-- /.content -->

<script src="view/librerias/plugins/chartjs2/Chart.js" type="text/javascript"></script>
<script type="text/javascript">
    var MostrarMovimiento = function(Movimiento_Id) {
        var datos = [];
        var header = []

        $('#ver_datos').html('');

        $('#example1 thead tr').find('th').each(function() {
            header.push($(this).text());
        });

        var trId = $(Movimiento_Id).filter("tr").attr("id");

        var fila = $(`#${trId}`);
        fila.find('td').each(function() {
            datos.push($(this).text());
        })

        datos.forEach(function(element, index) {

            var addClass = index % 2 == 0 ? 'whitesmoke' : '';

            var html = ` <div class="row" style='font-size: 15px; padding: 5px 0; background-color:${addClass}'>
            <p class="col-xs-4 col-md-4" id="modal_header" style='font-weight: bolder'>${header[index]}:</p>
            <span id="col-xs-8 col-md-8" id="modal_fila">${element}</span>
            </div>`

            $('#ver_datos').append(html);

        });
    }
</script>


<script>
    $(document).ready(function() {
        $('#fechaIni').datetimepicker({
            viewMode: 'years',
            format: 'YYYY'
        });

        var year = "<?php echo $yearx; ?>"
        
        if (year != '') {
            $('#fechaIni').data('DateTimePicker').date(moment(year, 'YYYY'))
        } else {
            $('#fechaIni').data('DateTimePicker').date(moment().startOf('year'));
        }

        $("#example1").dataTable({
            "scrollX": true,
            "bSort": false,
            "language": {
            }
        });

        $.post('?c=Reportes&a=jsonbyYear', {
            year: $('#fechaIni').val()
        }, function(data) {
            
            const json = JSON.parse(data)

            var labels = []
            var cheques = []

            json.forEach(element => {
                labels.push(element.Mes)
                cheques.push(element.Cheque)
            })

            var ctx = document.getElementById('myChart')
            var myChart = new Chart(ctx, {
                type: 'line',
                data: {
                    labels: labels,
                    datasets: [
                        {
                            label: 'Cheque',
                            data: cheques,
                            borderColor: 'rgba(54, 162, 235, 1)',
                            borderWidth: 1,
                            fill: false,
                            tension: 0
                        }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: true,
                        text: 'TOTALES'
                    },
                    scales: {
                        y: {
                            beginAtZero: true,
                            min: 0,
                            suggestedMin: 0,  // También puedes sugerir un mínimo de 0
                            suggestedMax: Math.max(...cheques)
                        }
                    }
                }
            })

        })
    })

</script>