<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE');
header('Access-Control-Allow-Headers: X-Requested-With, Content-Type, Authorization');

const TOKEN = 'apis-token-1.aTSI1U7KEuT-6bbbCguH-4Y8TI6KS73N';
const URL = 'https://api.apis.net.pe/v1';

function getDniReniec($dni)
{
    // Iniciar llamada a API
    $curl = curl_init();

    // Buscar dni
    curl_setopt_array($curl, array(
        // para user api versión 1
        CURLOPT_URL =>  URL . '/dni?numero=' . $dni,
        // para user api versión 2
        // CURLOPT_URL => 'https://api.apis.net.pe/v2/reniec/dni?numero=' . $dni,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_SSL_VERIFYPEER => 0,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 2,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'Referer: https://apis.net.pe/consulta-dni-api',
            'Authorization: Bearer ' . TOKEN
        ),
    ));

    $response = curl_exec($curl);

    curl_close($curl);
    // Datos listos para usar
    $persona = json_decode($response);

    return $persona;
}

function getRucReniec($ruc)
{

    // Iniciar llamada a API
    $curl = curl_init();
    // Buscar ruc sunat
    curl_setopt_array($curl, array(
        // para usar la versión 1
        CURLOPT_URL =>  URL . '/ruc?numero=' . $ruc,
        // para usar la versión 2
        // CURLOPT_URL => 'https://api.apis.net.pe/v2/sunat/ruc?numero=' . $ruc,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_SSL_VERIFYPEER => 0,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'Referer: http://apis.net.pe/api-ruc',
            'Authorization: Bearer ' . TOKEN
        ),
    ));

    $response = curl_exec($curl);

    curl_close($curl);
    // Datos de empresas según padron reducido
    $empresa = json_decode($response);

    return $empresa;
}


function getDatosRenic($tipo, $numero)
{

    $data = [];

    if ($tipo == 'dni') {
        $data = getDniReniec($numero);
    } else {
        $data = getRucReniec($numero);
    }

    if ($data) {
        if (property_exists($data, 'error')) {
            $data = [
                'error' => $data->error,
            ];
        }
    } else {
        $data = [
            'error' => 'No se encontraron datos'
        ];
    }

    if (is_null($data)) {
        $data = [
            'error' => 'No se encontraron datos'
        ];
    }

    return $data;
}

echo json_encode(getDatosRenic($_GET['tipo'], $_GET['numero']));
