<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE');
header('Access-Control-Allow-Headers: X-Requested-With, Content-Type, Authorization');

// Obtener el tipo de cambio de SUNAT

function obtenerTipoCambio()
{
    $url = 'https://www.sunat.gob.pe/a/txt/tipoCambio.txt';
    $datos = file_get_contents($url);
    $lineas = explode("\n", $datos);
    $tipo_cambio = null;

    foreach ($lineas as $linea) {

        if (!($linea) == '') {
            $datos = explode('|', $linea);
            $fecha = date('Y-m-d', strtotime($datos[0]));
            $tipo_cambio_venta  = $datos[1];
            $tipo_cambio_compra  = $datos[2];
        }
    }
    return  $fecha . ' ' . $tipo_cambio_compra . ' ' . $tipo_cambio_venta;
}


function obetenerTipoCambioMes()
{

    $token = 'apis-token-1.aTSI1U7KEuT-6bbbCguH-4Y8TI6KS73N';
    $mes = date('m');
    $anio = date('Y');

    // Iniciar llamada a API
    $data = file_get_contents('https://api.apis.net.pe/v1/tipo-cambio-sunat?month=' . $mes . '&year=' . $anio);

    $array = json_decode($data, true);

    $tipo_cambio_venta = null;
    $tipo_cambio_compra = null;
    $fecha = null;

    foreach ($array as $row) {
        if ($row['fecha'] == date('Y-m-d')) {
            $tipo_cambio_venta = $row['venta'];
            $tipo_cambio_compra = $row['compra'];
            $fecha = $row['fecha'];
        }
    }

    return $fecha . ' ' . $tipo_cambio_compra . ' ' . $tipo_cambio_venta;
}

function insertarTipoCambio($servername, $username, $password, $dbname, $fecha, $tipo_cambio_venta)
{

    if ($fecha == '' || $tipo_cambio_venta == '') {
        echo "No se ha obtenido el tipo de cambio de SUNAT" . "\n";
        return;
    }

    $conn = new mysqli($servername, $username, $password, $dbname);

    // Verificar la conex
    if ($conn->connect_error) {
        die("Error de conexión: " . $conn->connect_error);
    }

    //Verificar que no este registrado el tipo de cambio
    $sql = "SELECT * FROM tipocambio WHERE Fecha = '" . $fecha . "'";

    // Ejecuta la consulta SQL
    $result =  $conn->query($sql);

    if ($result->num_rows > 0) {
        echo "El tipo de cambio ya se encuentra registrado en la base de datos: " . $dbname . "" . "\n";
        $conn->close();
        return;
    }

    // Prepara la consulta SQL
    $sql = "INSERT INTO tipocambio (Fecha, TipoCambio) VALUES ('" . $fecha . "', '" . $tipo_cambio_venta . "')";

    // Ejecuta la consulta SQL
    if ($conn->query($sql) === TRUE) {
        echo "Tipo de cambio insertado correctamente en la base de datos: " . $dbname . "" . "\n";
    } else {
        echo "Error al insertar el tipo de cambio en la base de datos: " . $dbname . " " . $conn->error . "\n";
    }

    $conn->close();
}

// Utiliza la función obtenerTipoCambio() para obtener el tipo de cambio
$tipo_cambio = obetenerTipoCambioMes();
$fecha = strlen(explode(' ', $tipo_cambio)[0]) > 0 ? explode(' ', $tipo_cambio)[0] : '';
$tipo_cambio_compra =  strlen(explode(' ', $tipo_cambio)[2]) > 0 ? explode(' ', $tipo_cambio)[1] : '';
$tipo_cambio_venta = strlen(explode(' ', $tipo_cambio)[1]) > 0 ? explode(' ', $tipo_cambio)[2] : '';

// Insertar el tipo de cambio en la base de datos 
//Obtener las DBS

$server_servername = "localhost";
$server_username = "vpsfmsac_hormiguiroot";
$server_password = "Hormigui2022";
$server_db_name = "vpsfmsac_hormiguita_seguridad";

$conn = new mysqli($server_servername, $server_username, $server_password, $server_db_name);

// Verificar la conex
if ($conn->connect_error) {
    die("Error de conexión: " . $conn->connect_error);
}

// Prepara la consulta SQL
$sql = "SELECT NameDB,UsuarioDB,PasswordDB,ServerDB FROM enterprise";

// Ejecuta la consulta SQL
$result = $conn->query($sql);

$dbnames = array();

if ($result->num_rows > 0) {
    // output data of each row
    while ($row = $result->fetch_assoc()) {
        $dbnames[] = $row;
    }
} else {
    echo "0 results";
}

$conn->close();


//Insertar el tipo de cambio en cada DB
foreach ($dbnames as $dbname) {
    insertarTipoCambio($dbname['ServerDB'], $dbname['UsuarioDB'], $dbname['PasswordDB'], $dbname['NameDB'], $fecha, $tipo_cambio_venta);
}

echo  " --" . $tipo_cambio . "-- " ;
